/*
 * BanRecord.h - class definition for BanRecord class
 */

#ifndef _IGNORERECORD_
#include "IgnoreRecord.h"
#endif

#ifndef _BANRECORD_
#define _BANRECORD_

class BanRecord : public IgnoreRecord {
  protected:
   time_t lastactive;
   Channel * chan;

   friend class Channel;
  public:
   enum {
      PERM = 1,
	STICKY = 2
   };
   BanRecord ( Channel * x = 0 );
   BanRecord ( Channel *, char * );
   BanRecord ( Channel *, const char *, const char *, const char *, 
	      time_t, int );
   ~BanRecord ( void );
   
   int ExpMem ( void );
   int Write ( FILE * );
   
   inline time_t LastActive ( void ) { return lastactive; }
   inline void Activate ( void ) { lastactive = G->now; }
   inline BanRecord * Find ( char * x ) {
      return (BanRecord *)IgnoreRecord::Find(x);
   }
   inline BanRecord * Match ( const char * x ) {
      return (BanRecord *)IgnoreRecord::Match(x);
   }
   inline int IsPerm ( void ) { return flags & PERM; }
   inline int IsSticky ( void ) { return flags & STICKY; }
   DEF_NEXT(BanRecord);
   MEMORY_TYPE(G->memtype_ban);
};
#endif
