/*
 * BindEntry.h - class definition for BindEntry class
 */

#ifndef _KEYEDLIST_
#include "KeyedList.h"
#endif

#ifndef _FLAGRECORD_
#include "FlagRecord.h"
#endif

#ifndef _BINDENTRY_
#define _BINDENTRY_

class BindEntry : public KeyedList<MISCLEN> {
  protected:
   BindMask * owner;
   ScriptContext * script;
   FlagRecord flags;
   int hits;
   BindReturn (*F) ( void **, const char *);
  public:
   inline BindEntry ( void ) : KeyedList<MISCLEN> () { }
   BindEntry ( BindEntry &, const char *, const char *,
	      BindReturn (*) ( void **, const char *),
	      ModuleEntry * m, BindMask *, ScriptContext *);
   ~BindEntry ( void );
      
   BindReturn Check ( const char *, FlagRecord *, void **, int);
   int ExpMem ( void );
   void Reset ( const char *, BindReturn (*) (void **, const char *) );
   void Dump (ScriptContext *);
   int Display (BindTable *, char *, Socket *, int);
   inline BindEntry * Find ( const char * x) {
      return (BindEntry *)KeyedList<MISCLEN>::Find(x);
   }
   inline BindMask * Owner ( void ) { return owner; }
   inline ScriptContext * Script ( void ) { return script; }
   BindReturn Call (const char * mask, int l, ... );
   MEMORY_TYPE(G->memtype_bind);
   DEF_NEXT(BindEntry);
};
#endif
