/*
 * BindMask.h - class definition for BindMask class
 */

#ifndef _KEYEDLIST_
#include "KeyedList.h"
#endif

#ifndef _BINDENTRY_
#include "BindEntry.h"
#endif

#ifndef _BINDMASK_
#define _BINDMASK_

class BindMask : public KeyedList<UHOSTLEN> {
  protected:
   BindTable * owner;
   BindEntry first;
  public:
   inline BindMask ( void ) : KeyedList<UHOSTLEN> (), first() { }
   inline BindMask ( BindMask & t, const char * n, BindTable * o)
     : KeyedList<UHOSTLEN> (t,n), first() { owner = o; }
   ~BindMask ( void );
      
   BindEntry * AddBind ( const char *, const char *, ScriptContext * sc,
			BindReturn (*) (void **, const char *), int, ModuleEntry * );
   int RemBind ( const char * );
   BindReturn Check ( const char *, FlagRecord *, void **, int);
   
   int ExpMem ( void );
   inline BindEntry * First ( void ) { return &first; }
   int Display (BindTable *, Socket *, int);
   inline BindMask * Find ( const char * x) {
      return (BindMask *)KeyedList<UHOSTLEN>::Find(x);
   }
   inline void Cleanup ( ModuleEntry * m ) { first.Cleanup(m); }
   inline BindTable * Owner ( void ) { return owner; }
   MEMORY_TYPE(G->memtype_bind);
   DEF_NEXT(BindMask);
};

#endif
