/*
 * BindTableDcc.C -- member functions for the BindTableDcc class
*/
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
*/

#include "BindTableDcc.h"
#include "Socket.h"
#include "ScriptContext.h"
#include "ScriptArgument.h"
#include "BoundCommand.h"
#define CLASS "BindTableDcc"

BindTableDcc::~BindTableDcc ( void ) {
   FUNCTION;
}

BindReturn BindTableDcc::ToScript (BindEntry * be, void ** argv, const char * mask) {
   FUNCTION;
   Socket * sock = (Socket *)argv[0];
   char buf[32];
   
   strcpy(buf, G->ToBase10(sock->FD()));
   return be->Call(mask, 3, sock->Nick(), buf, argv[1]);
}

int BindTableDcc::FromScript (BoundCommand * bc, ScriptContext * sc,
			      int argc, ScriptArgument ** argv) {
   FUNCTION;
   void * args[2];
   
   context;
   BADARGS(4, 4, G->Lang(0x140, ""));
   args[1] = argv[2];
   if (!(args[0] = G->FindValidIdx(argv[1]->AsInteger()))) {
      sc->SetString(G->Lang (0x105, ""));
      return SCRIPT_ERROR;
   } else if (bc->Call(args,argv[0]->AsString() + 5) == EXEC_BRK)
	sc->SetString("break");
   else
     sc->SetString("0");
   return SCRIPT_OK;
}
