/*
 * This file is part of the eggdrop 2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "Channel.h"
#include "BanRecord.h"
#define CLASS "Channel"

Channel::Channel ( const char * n ) 
: KeyedList<CHANLEN> ( *G->chanset, n, KeyedList<CHANLEN>::NODUPS) { 
   FUNCTION;
   bans = 0;
   status = 0;
}

Channel::Channel ( Channel & o) : KeyedList<CHANLEN> ( ) {
   FUNCTION;
   BanRecord * b;
   
   bans = o.bans;
   o.bans = 0;
   for (b = bans; b; b = b->Next())
     b->chan = this;
   status = o.status;
   KeyedList_Cons (*G->chanset, o.key, 0);
}

Channel::~Channel ( void ) {
   FUNCTION;
   if (bans) {
      DELETE ( bans );
      bans = 0;
   }
   G->chanset->Remove(this);
}
