/* 
 * ChannelRecord.h 
 */

#ifndef _KEYEDLIST_
#include "KeyedList.h"
#endif

#ifndef _CHANNELRECORD_
#define _CHANNELRECORD_

class ChannelRecord : public KeyedList<CHANLEN> {
  protected:
   unsigned long flags;
   unsigned long flags_udef;
   time_t last_seen;
   char * info;
   
   friend class FlagRecord;
   friend class UserRecord;
  public:
   inline ChannelRecord ( UserRecord *, const char * );
   inline ChannelRecord ( void ) : KeyedList<CHANLEN> () { }
   ~ChannelRecord ( void );
   
   int ExpMem ( void );
   inline ChannelRecord * Next ( void ) { return (ChannelRecord *)next; }
   inline time_t Laston ( void ) { return last_seen; }
   inline void SetLaston ( time_t x ) { last_seen = x; }
   inline const char * Info ( void ) { return info; }
   inline ChannelRecord * Find ( const char * x ) { 
      return (ChannelRecord *)KeyedList<CHANLEN>::Find(x);
   }
   inline void SetInfo ( const char * len ) {
      if (info)
	my_free(info,G->memtype_chanrec);
      if (len && len[0]) {
	 info = (char *)my_malloc(strlen(len) + 1, G->memtype_chanrec);
	 strcpy(info, len);
      } else
	info = 0;
   }
   inline void Set ( ChannelRecord & o ) {
      flags = o.flags;
      flags_udef = o.flags_udef;
      last_seen = o.last_seen;
      SetInfo(o.info);
   }
   MEMORY_TYPE(G->memtype_chanrec);
};

#ifndef _USERRECORD_
#include "UserRecord.h"
#endif

inline ChannelRecord::ChannelRecord ( UserRecord * u, const char * n ) 
: KeyedList<CHANLEN> ( *u->ChanRecs(), n, NODUPS ) {
}
#endif
