/*
 * Command.C
 */
/*
 * This file is part of the eggdrop 2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "Command.h"
#include "ScriptContext.h"
#define CLASS "Command"

Command::Command ( char * n, int (*f) (ScriptContext *, int, ScriptArgument **),
		  ModuleEntry * m ) 
: KeyedList<MISCLEN> ( *G->command_list, n, KeyedList<MISCLEN>::NODUPS, m ) {
   FUNCTION;
   ScriptContext * ptr = G->scripts;
   
   func = f;
   while ((ptr = ptr->Next()))
     ptr->AddCommand(this);
}

Command::~Command ( void ) {
   FUNCTION;
   ScriptContext * p1 = G->scripts;
   
   while ((p1 = p1->Next())) 
     p1->RemCommand(this);
   G->command_list->Remove(this);
   next = 0;
}

int Command::ExpMem( void ) {
   FUNCTION;
   return sizeof(Command);
}

int Command::Call ( ScriptContext * sc, int argc, ScriptArgument ** argv) {
   FUNCTION;
   return func(sc,argc,argv);
}
