/*
 * Command.h
 */

#ifndef _KEYEDLIST_
#include "KeyedList.h"
#endif

#ifndef _COMMAND_
#define _COMMAND_

class Command : public KeyedList<MISCLEN> {
  protected:
   int (*func) (ScriptContext *, int, ScriptArgument **);

   friend class ScriptContext;
   inline Command ( void ) : KeyedList<MISCLEN> () { }
  public:
   MEMORY_TYPE(G->memtype_script);
   Command ( char *, int (*) (ScriptContext *, int, ScriptArgument **), 
	    ModuleEntry * m );
   ~Command(void);
   int ExpMem ( void );
   virtual int Call (ScriptContext *, int, ScriptArgument **);
   inline Command * Next ( void ) { return (Command *)next; }
   inline Command * Find ( const char * x ) {
      return (Command *)KeyedList<MISCLEN>::Find(x);
   }
};
#endif
