/*
 * This file is part of the eggdrop 2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "CoupletVariable.h"
#include "ScriptContext.h"
#define CLASS "CoupletVariable"

CoupletVariable::CoupletVariable ( char * n, int * l, int * r, ModuleEntry * m) 
: Variable ( n, m, COUPLET ) {
   FUNCTION;
   ScriptContext * ptr = G->scripts;
   
   lptr = l;
   rptr = r;
   while ((ptr = ptr->Next()))
     ptr->AddCoupletVar(this);
}

CoupletVariable::~CoupletVariable ( void ) {
   FUNCTION;
   ScriptContext * ptr = G->scripts;
   
   while ((ptr = ptr->Next()))
     ptr->RemCoupletVar(this);
}

int CoupletVariable::ExpMem ( void ) {
   FUNCTION;
   return sizeof(CoupletVariable);
}
