/*
 * DccChat.h
 */

#ifndef _DCCCHATPASS_
#include "DccChatPass.h"
#endif

#ifndef _DCCCHAT_
#define _DCCCHAT_

class DccChat : public DccChatPass {
  protected:
   LogModes con_flags;       /* with console: what to show */
   int msgs_per_sec;         /* used to stop flooding */
   char con_chan[81];        /* with console: what channel to view */
   int channel;              /* 0=party line, -1=off */

  public:
   DccChat ( int );
   DccChat (DccChatPass *);
   DccChat (DccChat &);
   ~DccChat (void);
   
   void Eof (void);
   void Activity (char *, int);
   void Display2 (Socket *);
   int ExpMem ( void );
   
   void Chatter ( void );
   void ShowMotd ( void );
   void CheckChon ( void );
   void CheckChof ( const char * );
   void CheckLChpt (const char *);
   void CheckLChjn ( void );
   int DetectDccFlood ( void );
   void ChanoutBut ( int, char * );
   static void Chanout ( int, char * );
   void SetAway ( const char *);
   
   inline void ConsoleFlags ( LogModes x ) { con_flags = x; }
   inline LogModes & ConsoleFlags ( void ) { return con_flags; }
   inline int Channel ( void ) { return channel; }
   inline void SetChannel ( int x ) { channel = x; }
   inline char * ConsoleChan ( void ) { return con_chan; }
   inline void SetConsoleChan ( const char * x) { 
      strncpy(con_chan, x, 80);
      con_chan[80] = 0;
   }
   inline DccChat * Next ( void ) {
      DccChat * ptr = this;
      while ((ptr = (DccChat *)ptr->next) && !(ptr->type_flags & DCT_CHAT));
      return ptr;
   }
   
   inline int CheckDcc ( char *, char *);
};
#endif
