/*
 * DccChatNewPass.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "DccChatNewPass.h"
#include "DccChat.h"
#include "UserEntryPass.h"
#include "UserRecord.h"
#define CLASS "DccChatNewPass"

DccChatNewPass::~DccChatNewPass ( void ) {
   FUNCTION;
}

void DccChatNewPass::Activity (char * buf,int x) {
   FUNCTION;
   char *newpass;
   DccChat * newone;
   
   StripTelnet(buf, &x);
   buf[16] = 0;
   if (strlen(buf) < 6) {
      Send(G->Lang( 0x185, ""));
      Send(G->Lang( 0x186, ""));
   } else {
      for (x = 0; buf[x]; x++)
	if ((buf[x] <= 32) || (buf[x] == 127))
	  break;
      if (buf[x]) {
	 Send(G->Lang( 0x187, ""));
	 Send(G->Lang( 0x186, ""));
      } else {
	 G->LOG_MISC.Put(G->Lang( 0x188, "ssd", nick, host, remoteport));
	 if (G->notify_new[0]) {
	    char * s, s1[121], s2[121];
	    s = G->Lang( 0x189, "ss", nick, host);
	    strcpy(s1, G->notify_new);
	    G->SplitC(s2,s1,',');
	    while (s2[0]) {
	       G->RMSpace(s2);
	       G->AddNote(s2, G->botnetnick, s, NULL, 0);
	       G->SplitC(s2,s1,',');
	    }
	    G->RMSpace(s1);
	    G->AddNote(s1, G->botnetnick, s, NULL, 0);
	 }
	 newpass = G->Split(&buf);
	 SetPassword(user, newpass);
	 Send(G->Lang( 0x18A, ""));
	 Send(G->Lang( 0x18B, "s", G->botnetnick));
	 newone = NEW ( DccChat ( this ) );
	 newone->Chatter();
      }
   }
}

void DccChatNewPass::Eof ( void ) {
   FUNCTION;
   G->LOG_MISC.Put(G->Lang( 0x18D, "ssd", nick, host, remoteport));
   DELETE(user);
   Close();
}


void DccChatNewPass::Timeout ( void ) {
   FUNCTION;
   Send(G->Lang( 0x18E, ""));
   G->LOG_MISC.Put(G->Lang( 0x190, "ssd", nick, host, remoteport ));
   Printf("Guess you're not there.  Bye.\n");
   DELETE(user);
   Close();
}

void DccChatNewPass::Display2 (Socket * where) {
   FUNCTION;
   where->Send(G->Lang( 0x192, "sl", nick, G->now - timeval));
}
