/*
 * DccChatNewUser.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "DccChatNewUser.h"
#include "DccChatLogin.h"
#include "DccChatNewPass.h"
#include "UserRecord.h"
#define CLASS "DccChatNewUser"

DccChatNewUser::DccChatNewUser (DccChatLogin & old ) 
: DccChatPass ( old ) {
   FUNCTION;
   int langv;
    
   type = G->DCC_CHAT_NEWUSER;
   for (langv = 0x16C; langv < 0x172; langv++)
     Send(G->Lang( langv, "s", G->botnetnick));
}

DccChatNewUser::~DccChatNewUser ( void ) {
   FUNCTION;
}

void DccChatNewUser::Activity (char * buf, int x) {
   FUNCTION;
   char work[UHOSTLEN+1], *p, *q, *r;
   int lang1 = 0x176, lang2 = 0x175;
   Socket * out = this;
   
   buf[HANDLEN] = 0;
   StripTelnet(buf, &x);
   SetNick(buf);
   TimeNow();
   for (x = 0; buf[x]; x++)
     if ((buf[x] <= 32) || (buf[x] >= 127))
       break;
   if (buf[x])
     lang1 ++;
   else if (strchr("-,+*=:!.@#;$", buf[0])) 
     lang1 = 0x178;
   else if (G->userlist->Find(buf))
     lang1 = 0x179;
   else if (strcasecmp(buf, G->origbotname) && strcasecmp(buf, G->botnetnick)) {
      FlagRecord fr;
      
      fr.SetGlobal(G->default_flags);
      if (G->make_userfile) {
	 fr.SetGlobOwner();
	 strcpy(work, "telnet!*@*");
      } else {
	 if ((p = strchr(host,'@'))) {
	    *(q = p) = 0;
	    if (!(r = strchr(++p,'.')))
	      G->SPrintF(work, UHOSTLEN, "telnet!%s@%s", host, p);
	    else
	      G->SPrintF(work, UHOSTLEN, "telnet!%s@*%s", host, r);
	    *q = '@';	     
	 } else 
	   G->SPrintF(work, UHOSTLEN, "telnet!*@*%s", host);
	 fr.SetGlobParty();
      }
      fr.Sanity();
      user = NEW ( UserRecord ( G->userlist, buf, work, fr));
      FlagRecord::ReaffirmOwners();
      user->CheckDccAttrs(G->default_flags);
      SetStatus(STAT_ECHO | STAT_TELNET);
      if (G->make_userfile) {
	 for (lang1 = 0x17C; lang1 < 0x17F; lang1++)
	   Send(G->Lang( lang1, ""));
	 G->LOG_MISC.Put(G->Lang( 0x17F, "s", buf));
	 G->make_userfile = 0;
	 G->userlist->WriteUserfile(NULL);
	 G->AddNote(buf, G->botnetnick, G->Lang( 0x180, ""), NULL, 0);
      }
      lang1 = 0x17A;
      lang2 = 0x17B;
      out = NEW ( DccChatNewPass ( *this ) );
   }
   out->Send(G->Lang( lang1, "s", buf[0]));
   out->Send(G->Lang( lang2, ""));
}

void DccChatNewUser::Eof ( void ) {
   FUNCTION;
   G->LOG_MISC.Put(G->Lang( 0x18C, "sd", host, remoteport ));
   Close();
}
   
void DccChatNewUser::Timeout ( void ) {
   FUNCTION;
   Send(G->Lang( 0x18E, ""));
   G->LOG_MISC.Put(G->Lang( 0x18F, "sd", host, remoteport ));
   Close();
}

void DccChatNewUser::Display2 (Socket * where) {
   FUNCTION;
   where->Send(G->Lang( 0x191, "l",  G->now - timeval));
}
