/*
 * DccChatPass.h
 */

#ifndef _SOCKET_
#include "Socket.h"
#endif

#ifndef _DCCCHATPASS_
#define _DCCCHATPASS_

class DccChatPass : public Socket {
  protected:
   char *away;               /* non-NULL if user is away */
   MessageQueue * buffer;    /* a buffer of outgoing lines (for .page cmd) */
   int strip_flags;          /* what codes to strip (b,r,u,c,a,g,*) */
   int current_lines;        /* number of lines total stored */
   int line_count;           /* number of lines sent since last page */
   int max_line;             /* maximum lines at once */
   
  public:
   DccChatPass (DccChatPass &);
   DccChatPass (Socket &, const char * );
   DccChatPass (int fd, const char *, int);
   DccChatPass (struct in_addr, int );
   ~DccChatPass (void);
   
   int ExpMem ( void );
   void Eof (void);
   void Activity (char *, int);
   void Timeout (void);
   void Display2 (Socket *);
   int Dump ( char *, int );
   
   int ProcessCodes (int, int, char *, char *);
   void FlushLines ( void );
   void DoBoot(const char *, const char *);
   
   inline const char * Away ( void ) { return away; }
   inline void SetAwayRaw ( const char * x ) {
      if (away)
	my_free(away,G->memtype_socket);
      if (x)
	strcpy(away = (char *)my_malloc(strlen(x) + 1, G->memtype_socket),x);
      else
	away = 0;
   }
   inline MessageQueue * Buffer ( void ) { return buffer; }
   inline void SetMaxLines ( int x ) { max_line = x; }
   inline int MaxLines ( void ) { return max_line; }
   inline void SetStripFlags ( int x ) { strip_flags = x; }
   inline int StripFlags ( void ) { return strip_flags; }
   inline void AddStripFlags ( int x ) { strip_flags |= x; }
   inline void DelStripFlags ( int x ) { strip_flags &= ~x; }
   inline void ClearCount ( void ) { line_count = current_lines = 0; }
   inline int LineCount ( void ) { return line_count; }
};
#endif
