/*
 * Debugger.h - used in EBUG_MEM mode to do some fancy debugging things
 */

#ifndef _DEBUGGER_
#define _DEBUGGER_

#ifdef EBUG_MEM
class Debugger : public List {
   Debugger * prev;
   const char * clss;
   const char * func;
   const char * modl;
   const char * file;
   int line;
   static Debugger * last;
  public:
   static Debugger * full_list;
   inline Debugger ( void ) { 
      full_list = this;
   }
   Debugger ( const char * cl,const char * fn, const char * mn,
	     const char * fl, int ln );
   ~Debugger ( void );
   
   int ExpMem ( void );
   void DumpStack (Socket *);
   inline void Line ( int l ) { line = l; }
};

#define FUNCTION Debugger __dbg__(CLASS,__FUNCTION__,MODULE_NAME,__FILE__,__LINE__)
#define LINE __dbg__.Line(__LINE__)
#else
#define FUNCTION
#define LINE
#endif
#endif
