/*
 * Dependancy.h - class definition
 */

#ifndef _VERSION_
#include "Version.h"
#endif

#ifndef _LIST_
#include "List.h"
#endif

#ifndef _DEPENDANCY_
#define _DEPENDANCY_

class Dependancy : public List, public Version {
  protected:
   ModuleEntry * needed;
   ModuleEntry * needing;

   friend class ModuleEntry;
  public:
   inline Dependancy ( void ) : List (), Version () {
   }
   inline Dependancy (ModuleEntry * a, ModuleEntry * b, Version * c)
     : List (*G->dep_list), Version ( c ) {
	needed = b;
	needing = a;
     }
   ~Dependancy ( void );
   
   int ExpMem ( void );
   DEF_NEXT(Dependancy);
   MEMORY_TYPE(G->memtype_dep);
   inline ModuleEntry * Needed ( void ) { return needed; }
   inline ModuleEntry * Needing ( void ) { return needing; }
};
#endif
