/*
 * HelpEntry.h - class definitions for the HelpEntry class
 */

#ifndef _KEYEDLIST_
#include "KeyedList.h"
#endif

#ifndef _HELPENTRY_
#define _HELPENTRY_

class HelpEntry;

class HelpKeys : public KeyedList<MISCLEN> {
   friend HelpEntry;
   friend HelpReference;
   
   inline HelpKeys ( void ) : KeyedList<MISCLEN> () {}
   inline HelpKeys ( HelpEntry *, char * );
   ~HelpKeys(void);
   inline HelpKeys * Find ( const char * n ) {
      return (HelpKeys *)KeyedList<MISCLEN>::Find(n);
   }
   MEMORY_TYPE(G->memtype_help);
};

class HelpEntry : public KeyedList<MISCLEN> {
   int type;
   HelpKeys keylist;

   friend HelpReference;
   friend HelpKeys;
   
   inline HelpEntry ( void ) : KeyedList<MISCLEN> () { }
   inline HelpEntry ( HelpReference *, char *, int );
   
   inline int Type ( void ) { return type; }
   inline HelpEntry * Find ( const char * n ) {
      return (HelpEntry *)KeyedList<MISCLEN>::Find(n);
   }
   MEMORY_TYPE(G->memtype_help);
   DEF_NEXT(HelpEntry);
};

inline HelpKeys::HelpKeys ( HelpEntry * e, char * t ) 
: KeyedList<MISCLEN> ( e->keylist, t, NODUPS | APPEND ) {
}
#endif
