/*
 * HelpReference.h - class definitions for the HelpReference class
 */

#ifndef _HELPENTRY_
#include "HelpEntry.h"
#endif

#ifndef _HELPREFERENCE_
#define _HELPREFERENCE_

class HelpReference : public KeyedList<MISCLEN> {
  protected:
   HelpEntry first;
   friend HelpEntry;
  public:
   enum {
      DCC = 1,
	TEXT = 2,
	IRC = 16,
	HILITE = 32,
   };
   inline HelpReference ( void ) : KeyedList<MISCLEN> () { }
   HelpReference ( const char *, ModuleEntry * = 0);
   ~HelpReference ( void );

   void ScanFile ( char * filename, int type );
   inline HelpEntry * First ( void ) { return & first; }
   inline HelpReference * Find ( const char * n ) {
      return (HelpReference *)KeyedList<MISCLEN>::Find(n);
   }
   MEMORY_TYPE(G->memtype_help);
   inline HelpReference * Next ( void ) { return (HelpReference *)next; }
   int ExpMem ( void );
   void Reload ( void );
   void Debug ( Socket * );
   FILE * Resolve ( int, char * );
   void Tell ( DccChatPass *, char *, FlagRecord &, int );
   void Search ( DccChatPass *, char *, FlagRecord & );
};

inline HelpEntry::HelpEntry ( HelpReference * hr, char * name, int val ) 
: KeyedList<MISCLEN> ( hr->first, name, KeyedList<MISCLEN>::NODUPS |
		      KeyedList<MISCLEN>::APPEND ) {
   type = val;
}

inline void RemoveHelp ( const char * k ) {
   HelpReference * hr = List::G->help_list->Find(k);
   if (hr)
     DELETE ( hr );
}

#endif
