/*
 * HookList.h - class definition for the HookList class
 */

#ifndef _KEYEDLIST_
#include "KeyedList.h"
#endif

#ifndef _HOOKLIST_
#define _HOOKLIST_

#ifndef _HOOK_
#include "Hook.h"
#endif

class HookList : public KeyedList<MISCLEN> {
   Hook top;
   friend class Hook;
  public:
   inline HookList ( void ) : KeyedList<MISCLEN> () { }
   inline HookList ( const char * x ) 
     : KeyedList<MISCLEN> ( *G->hook_list, x, KeyedList<MISCLEN>::NODUPS ) {
     }
   ~HookList ( void );
   void Call ( void );
   void Add ( void (*)(void), ModuleEntry * m );
   void Remove ( void (*)(void) );
   void Cleanup ( ModuleEntry * );
   int ExpMem ( void );
   void Dump ( Socket * );
   MEMORY_TYPE(G->memtype_hook);
   DEF_NEXT(HookList);
};
#endif
