/* 
 * HostnameCache.h - class definition
 */

#ifndef _KEYEDLIST_
#include "KeyedList.h"
#endif

#ifndef _HOSTNAMECACHE_
#define _HOSTNAMECACHE_

class HostnameCache : public KeyedList<UHOSTLEN> {
  protected:
   time_t age;
   struct in_addr address;
   
  public:
   inline HostnameCache ( void ) : KeyedList<UHOSTLEN> () { }
   HostnameCache ( const char * );
   HostnameCache ( struct in_addr * );
   ~HostnameCache ( void );
   
   struct in_addr * Find ( const char * );
   const char * Find ( struct in_addr * );
   void Flush ( void );
   int ExpMem ( void );
   MEMORY_TYPE(G->memtype_hostcache);
};
#endif
