/*
 * IdentLookup.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "IdentLookup.h"
#include "IdentWait.h"
#define CLASS "IdentLookup"

IdentLookup::IdentLookup ( IdentWait & other ) :
Socket::Socket ( G->IDENT_LOOKUP, 0, other.Address(), 113, 0, &G->ident_timeout) {
   FUNCTION;
   SetHost(other.Host());
   SetNick("*");
   ident_sock = other.FD();
   TimeNow();
}

IdentLookup::~IdentLookup ( void ) {
   FUNCTION;
}

void IdentLookup::Activity (char *buf, int) {
   FUNCTION;
   char response[512], uid[512], buf1[UHOSTLEN+1];
   Socket * ptr;
   
   context;
   sscanf(buf,"%*[^:]:%[^:]:%*[^:]:%[^\n]\n", response, uid); 
   G->RMSpace(response);
   if (response[0] != 'U') 
     TimeNow();
   else {
      G->RMSpace(uid);
      uid[20] = 0; /* 20 character ident max */
      if ((ptr = G->socklist->Find(ident_sock, G->IDENT_WAIT))) {
	 G->SPrintF(buf1, UHOSTLEN, "%s@%s", uid, host);
	 ((IdentWait *)ptr)->GotResult(buf1);
      }
      Close();
   }
}

void IdentLookup::Eof ( void ) {
   FUNCTION;
   char buf[UHOSTLEN+1];
   Socket * ptr = G->socklist->Find(ident_sock, G->IDENT_WAIT);
   
   if (ptr) {
      G->LOG_MISC.Put(G->Lang(0x195, ""));
      G->SPrintF(buf, UHOSTLEN, "telnet@%s", host);
      ((IdentWait *)ptr)->GotResult(buf);
   } 
   Close();
}  

void IdentLookup::Display2 (Socket * where) {
   FUNCTION;
   where->Send(G->Lang(0x196, "d", ident_sock));
}
   
int IdentLookup::ExpMem ( void ) {
   FUNCTION;
   return sizeof(IdentLookup);
}
