/*
 * IdentWait.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "IdentWait.h"
#include "IdentLookup.h"
#include "TelnetPort.h"
#include "DccChatLogin.h"
#include "UserRecord.h"
#include "IgnoreRecord.h"
#include "BindTable.h"
#define CLASS "IdentWait"

IdentWait::IdentWait ( int fd, TelnetPort * port )
: Socket ( FD_, G->IDENT_WAIT, 0, 0, fd, 0, 0 ) {
   FUNCTION;
   TimeNow();
   ident_sock = port->FD();
   SetNick("*");
}

IdentWait::~IdentWait ( void ) {
   FUNCTION;
}

void IdentWait::Eof (void) {
   FUNCTION;
   Socket * ptr = G->socklist;
   
   G->LOG_MISC.Put( G->Lang( 0x193, "sd", host, remoteport) );
   while ((ptr = ptr->Next()))
     if ((ptr->Type() == G->IDENT_LOOKUP) && 
	 (((IdentLookup *)ptr)->ident_sock == key)) 
       ptr->Close();
   Close();
}

void IdentWait::Display2 (Socket * where) {
   FUNCTION;
   where->Send(G->Lang( 0x194, "l", G->now - timeval));
}

void IdentWait::GotResult (const char * host) {
   FUNCTION;
   Socket * idx = G->socklist->Find ( ident_sock, G->TELNET_PORT );
   char x[UHOSTLEN+1];
   UserRecord *u;
   FlagRecord fr;
   
   if (!idx) {
      G->LOG_MISC.Put(G->Lang( 0x197, ""));
      Close();
   } else {
      FD_SET(key, &G->fds_read);
      SetHost(host);
      G->SPrintF(x, UHOSTLEN, "telnet!%s", host);
      if (G->protect_telnet && !G->make_userfile 
	  && !((u = G->userlist->FindHost(x)) && 
	       (fr.Set(u)->GlobBot() || fr.GlobParty() 
		|| (!G->require_p && fr.GlobOp())))) {
	 G->LOG_MISC.Put(G->Lang( 0x198, "s", host));
	 Close();
      } else if (G->ignores->Match(x))
	   Close();
      else if (strcmp(idx->Nick(),"(users)")) {
	 void * args[2] = { this, idx };
	 if (G->bt_listen->Check(idx->Nick(), 0, args) != EXECUTED) {
	    G->LOG_MISC.Put(G->Lang( 0x199, "ss", idx->Nick(), host));
	    Close();
	 }
      } else 
	 NEW ( DccChatLogin ( *this, idx->Host() ) );
   }
}

int IdentWait::ExpMem ( void ) {
   FUNCTION;
   return sizeof(IdentWait);
}
