/*
 * IgnoreRecord.h - class definition for IgnoreRecord class
 */

#ifndef _KEYEDLIST_
#include "KeyedList.h"
#endif

#ifndef _IGNORERECORD_
#define _IGNORERECORD_

class IgnoreRecord : public KeyedList<UHOSTLEN> {
  protected:
   time_t expires;
   time_t added;
   char user[HANDLEN + 1];
   char * msg;
   int flags;
  public:
   enum {
      PERM = 1,
   };
   
   inline IgnoreRecord ( void ) : KeyedList<UHOSTLEN> ( ) { }
   IgnoreRecord ( char * );
   IgnoreRecord ( const char *, const char *, const char *, time_t );
   ~IgnoreRecord ( void );
   
   IgnoreRecord * Find ( char * );
   int ExpMem ( void );
   void Expire ( void );
   void Display ( Socket *, const char * );
   int Write ( FILE * );
   
   MEMORY_TYPE(G->memtype_ignore);
   inline const char * Mask ( void ) { return key; }
   inline const char * Reason ( void ) { return msg; }
   inline const char * Setter ( void ) { return user; }
   inline time_t Expires ( void ) { return expires; }
   inline time_t Added ( void ) { return added; }
   inline IgnoreRecord * Next ( void ) { return (IgnoreRecord *)next; }
   inline void RemFlag ( int x ) { flags &= ~x; }
   inline void AddFlag ( int x ) { flags |= x; }
   inline int Flags ( void ) { return flags; }
};

#endif
