/*
 * IntList.C - member functions for class IntList
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "IntList.h"
#define CLASS "IntList"

IntList::IntList ( IntList & header, int newkey, int flags, ModuleEntry * m)
: List (m) {
   FUNCTION;
   IntList * ptr = 0;
   
   if ((flags & NODUPS) && (ptr = header.Find (newkey))) {
      header.Remove ( ptr );
      delete (ptr);
   } 
   header.Add ( this, flags & APPEND);
   key = newkey;
}

IntList::~IntList ( void ) {
   FUNCTION;
}

IntList * IntList::Find ( int thekey ) {
   FUNCTION;
   IntList * ptr = Next();
   
   while (ptr && (thekey != ptr->key))
     ptr = ptr->Next();
   return ptr;
}

int IntList::Remove ( int thekey ) {
   FUNCTION;
   IntList * ptr = Find ( thekey );
   
   if (ptr) {
      Remove(ptr);
      delete ptr;
   }
   return ptr != 0;
}
