/*
 * IntegerVariable.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "IntegerVariable.h"
#include "ScriptContext.h"
#define CLASS "IntegerVariable"

IntegerVariable::IntegerVariable ( char * n, int * v, int f, ModuleEntry * m )
: Variable ( n, m, INTEGER ) {
   FUNCTION;
   ScriptContext * ptr = G->scripts;
   
   val = v;
   readonly = f;
   while ((ptr = ptr->Next()))
     ptr->AddIntVar(this);
}

IntegerVariable::~IntegerVariable ( void ) {
   FUNCTION;
   ScriptContext * ptr = G->scripts;
   
   while ((ptr = ptr->Next()))
     ptr->RemIntVar(this);
}

int IntegerVariable::ExpMem ( void ) {
   FUNCTION;
   return sizeof(IntegerVariable);
}
