/*
 * KeyedList.C - member functions for class KeyedList<len>
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "KeyedList.h"
#define CLASS "KeyedList"

template <int len> void KeyedList<len>::KeyedList_Cons
( KeyedList<len> & header,  const char * newkey, int flags) {
   FUNCTION;
   KeyedList<len> * ptr = 0;
   
   strncpy(key, newkey, len);
   key[len] = 0;
   if ((flags & NODUPS) && (ptr = header.Find (newkey))) {
      header.Remove ( ptr );
      delete (ptr);
   } 
   header.Add ( this, flags & APPEND);
}

template <int len> KeyedList<len>::~KeyedList ( void ) {
   FUNCTION;
}
					      
template <int len> KeyedList<len> * KeyedList<len>::Find ( const char * thekey ) {
   FUNCTION;
   KeyedList * ptr = Next();
   
   while (ptr && strcasecmp(thekey, ptr->key))
     ptr = ptr->Next();
   return ptr;
}

template <int len> int KeyedList<len>::Remove ( const char * thekey ) {
   FUNCTION;
   KeyedList<len> * ptr = Find ( thekey );
   
   if (ptr) {
      Remove(ptr);
      delete ptr;
   }
   return ptr != 0;
}

template <int len> KeyedList<len> * KeyedList<len>::Match ( const char * mask ) {
   FUNCTION;
   KeyedList<len> * ptr, * ret = 0;
   int val = 0, newval;
   
   for (ptr = Next(); ptr; ptr = ptr->Next())
     if ((newval = G->WildMatch(ptr->key, mask)) > val) {
	val = newval;
	ret = ptr;
     } 
   return ret;
}

template <int len> int KeyedList<len>::ExpMem ( void ) {
   FUNCTION;
   KeyedList<len> * ptr = this;
   int tot = sizeof(KeyedList<len>);
   
   while ((ptr = ptr->Next()))
     tot += sizeof(KeyedList<len>);
   return tot;
}

template class KeyedList<HANDLEN>;
template class KeyedList<NICKMAX>;
template class KeyedList<MISCLEN>;
template class KeyedList<CHANLEN>;
template class KeyedList<UHOSTLEN>;
