/*
 * KeyedList.h - class definition template for KeyedList classes
 */

#ifndef _LIST_
#include "List.h"
#endif

#ifndef _KEYEDLIST_
#define _KEYEDLIST_

template <int len> class KeyedList : public List {
  protected:
   char key[len + 1];
  public:
   enum {
      INSERT = 0,
	APPEND = 1,
	NODUPS = 2,
   };
   inline KeyedList ( void ) : List () { key[0] = 0; }
   inline KeyedList ( KeyedList<len> &a, const char *b , int c= 0, 
		     ModuleEntry * m = 0) : List ( m ) {
			KeyedList_Cons(a,b,c);
		     }
   ~KeyedList ( void );
   
   void KeyedList_Cons ( KeyedList &, const char *, int = 0);
   KeyedList * Find ( const char * );
   int Remove ( const char *);
   inline int Remove ( KeyedList * ptr) { return List::Remove (ptr); }
   KeyedList * Match ( const char *);
   
   inline const char * Key ( void ) { return key; }
   inline void SetKey ( const char * k ) {
      strncpy(key, k, len);
      key[len] = 0;
   }
   DEF_NEXT(KeyedList<len>);
   int ExpMem ( void );
};
#endif
