/*
 * ModuleLanguage.C - member functions for ModuleLanguage class
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ModuleLanguage.h"
#include "Socket.h"
#define CLASS "LanguageEntry"

LanguageEntry::~LanguageEntry ( void ) {
   FUNCTION;
   if (text)
     my_free(text, G->memtype_language);
}

void LanguageEntry::Dump ( ModuleLanguage * mlang, Socket * idx ) {
   FUNCTION;
   if (text) 
     idx->Printf("%10s 0x%x   %s\n", mlang ? mlang->Key() : "", key, text);
   if (mlang && next)
     Next()->Dump(mlang, idx);
}
   
LanguageEntry::LanguageEntry ( ModuleLanguage * mlang, int idx, char * ltext) :
IntList ( mlang->langtab[idx & 31], idx, IntList::APPEND | IntList::NODUPS ) {
   FUNCTION;
   text = (char *)my_malloc ( strlen(ltext) + 1, G->memtype_language );
   strcpy(text, ltext);
}

int LanguageEntry::ExpMem (void) {
   FUNCTION;
   LanguageEntry * ptr = this;
   int tot = 0;
   
   while ((ptr = (LanguageEntry *)ptr->Next())) 
     tot += sizeof(LanguageEntry) + strlen(ptr->text) + 1;
   return tot;
}
