/*
 * List.h - class definition for List class
 */

#ifndef _MAIN_
#include "main.h"
#endif

#ifndef _LIST_
#define _LIST_

class List {
  public:
   static ModuleEntryEggdrop * G;
  protected:
   List * next;
   ModuleEntry * mod;

   enum { 
      INSERT = 0,
	APPEND 
   };
  public:
   inline List ( ModuleEntry * m = 0 ) { mod = m; next = 0; }
   inline List ( List & header, int append = 0, ModuleEntry * m = 0 ) {
      mod = m;
      header.Add (this, append );
   }
   inline List ( List & header, List & old, int append = 0 ) {
      mod = old.mod;
      header.Add(this, append);
   }
   virtual ~List ( void );
   
   void Add ( List * , int = 0);
   int Remove ( List * );
   int Count ( void );
   virtual int ExpMem ( void ) = 0;
   void Flush ( void );
   void Cleanup ( ModuleEntry * );
   
   inline List * Next ( void ) { return next; }
   inline void SetNext ( List * n ) { next = n; } /* use at own risk */
   inline void * operator new ( size_t , int);
   inline void operator delete ( void * );
   inline ModuleEntry * Module( void ) { return mod; }
};

#ifndef _MEMTYPE_
#include "MemType.h"
#endif

#ifndef _DEBUGGER_
#include "Debugger.h"
#endif

inline void * List::operator new (size_t s, int x ) {
   return G->memtype_misc->Malloc(s,x);
}

inline void List::operator delete (void * ptr) {
   G->memtype_misc->Free(ptr);
}

#endif
