/*
 * LogFile.h - class definition for the LogFile class
 */

#ifndef _KEYEDLIST_
#include "KeyedList.h"
#endif

#ifndef _LOGFILE_
#define _LOGFILE_

#ifndef _LOGMODES_
#include "LogModes.h"
#endif

class LogFile : public KeyedList<UHOSTLEN> {
  protected:
   FILE * f;
   char chname[UHOSTLEN];
   LogModes flags;
  public:
   inline LogFile ( void ) : KeyedList<UHOSTLEN> () { }
   LogFile ( const char *, const char *, LogModes );
   ~LogFile ( void );

   inline const char * FileName ( void ) { return key; }
   inline const char * Channel ( void ) { return chname; }
   inline LogModes Mask ( void ) { return flags; }
   void Flush ( void );
   void Output ( char * );
   void Display ( Socket * );
   void Close ( void );
   void Backup ( void );
   DEF_NEXT(LogFile);
   int ExpMem ( void );
   MEMORY_TYPE(G->memtype_log);
};
#endif
