/*
 * LogModes.h - class definition for the LogModes class
 */

#ifndef _LOGMODES_
#define _LOGMODES_

class LogModes {
   unsigned int value;
  public:
   enum { 
      NONE = 0, MISC = 1, MSGS = 2, PUBLIC = 4, JOIN = 8,
	MODES = 0x10, CMDS = 0x20, BOTS = 0x040, RAW = 0x80,
	FILES = 0x100, LEV1 = 0x200, LEV2 = 0x400, LEV3 = 0x800,
	LEV4 = 0x1000, LEV5 = 0x2000, LEV6 = 0x4000, LEV7 = 0x8000,
	LEV8 = 0x10000, LEVS = LEV1|LEV2|LEV3|LEV4|LEV5|LEV6|LEV7|LEV8,
	SERV = 0x20000, BOTNET_SEND = 0x40000, WALL = 0x80000,
	SRVOUT = 0x100000, BOTNET = 0x200000, BOTSHARE = 0x400000,
	SOCKET = 0x800000, ALL = 0xffffffff
   };
   inline LogModes ( const char * x ) { Set(x); }
   inline LogModes ( unsigned int x = 0 ) { Set(x); }

   inline unsigned int Value ( void ) { return value; };
   inline unsigned int Add ( unsigned int x ) { return value |= x; }
   inline unsigned int Remove ( unsigned int x ) { return value &= ~x; }
   inline unsigned int Set ( unsigned int x ) { return value = x; }
   inline unsigned int operator += ( LogModes & x ) { return value |= x.value; }
   inline unsigned int operator -= ( LogModes & x ) { return value &= ~x.value; }
   inline unsigned int operator = ( LogModes & x ) { return value = x.value; }
   inline unsigned int operator = ( int x ) { return value = x; }
   inline void Clear ( void ) { value = 0; }
   
   unsigned int Set ( const char * );
   unsigned int Set ( char );
   inline void UnSet ( char s ) {
      value = ~value;
      Set(s);
      value = ~value;
   }
   const char * Mask ( void );
   const char * Names ( void );
   void Put ( Channel * x , const char * , ... );
   void Put ( const char *, Channel * x = 0 );
};

#endif
