/*
 * MemType.h - class definition for MemType class
 */

#ifndef _KEYEDLIST_
#include "KeyedList.h"
#endif

#ifndef _MODULEENTRYEGGDROP_
#include "ModuleEntryEggdrop.h"
#endif

#ifndef _MEMTYPE_
#define _MEMTYPE_

class MemType : public KeyedList<MISCLEN> {
  protected:
   List ** ptr;
   int expmem;
   int lasttable;
   int tablesize;
   struct memtype_internal_struct {
      char where[60];
      int size;
      void * ptr;
   } * data;
  public:
   MemType ( void );
   MemType ( const char *, List **, ModuleEntry * m = 0);

   ~MemType ( void );

   int ExpectedMemory ( void );
   int ExpMem ( void );
   void * Malloc (size_t, int);
   void Free (void *);
   void Status ( Socket * );
   void Debug ( Socket * );
   void Dump ( Socket *, char * );
   
   inline MemType * Next ( void ) { return (MemType *)next; }
   inline int TableSize ( void ) { return tablesize; }
   MEMORY_TYPE(G->memtype_list);
};

#endif
