/*
 * MessageQueue.C - member functions for class MessageQueue
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "MessageQueue.h"
#define CLASS "MessageQueue"

MessageQueue::MessageQueue ( MessageQueue & h, const char * d, int l, MemType * mt) 
: IntList ( h, l, IntList::APPEND) {
   FUNCTION;
   if (!mt)
     mt = G->memtype_socket;
   memtype = mt;
   data = (char *)my_malloc(l + 1, memtype);
   strncpy(data, d, l);
   data[l] = 0;
}

MessageQueue::~MessageQueue ( void ) {
   FUNCTION;
   if (data)
     my_free(data,memtype);
}

int MessageQueue::ExpMem ( void ) {
   FUNCTION;
   MessageQueue * ptr = this;
   int tot = sizeof(MessageQueue);
   
   while ((ptr = ptr->Next()))
     tot += sizeof(MessageQueue) + ptr->key + 1;
   return tot;
}

int MessageQueue::Flush ( int lines, Socket * sock ) {
   FUNCTION;
   int orig = lines;
   MessageQueue * mq;
   
   while (lines && next) {
      lines--;
      mq = (MessageQueue *)next;
      next = mq->next;
      mq->next = 0;
      if (mq->Dump(sock) < -1) {
	 lines++;
	 break;
      }
      DELETE(mq);
   }
   return orig - lines;
}

