/*
 * MiscVariable.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "MiscVariable.h"
#include "ScriptContext.h"
#define CLASS "MiscVariable"

MiscVariable::MiscVariable ( char * n, int f, ModuleEntry * m )
: Variable ( n, m, MISC ) {
   FUNCTION;
   ScriptContext * ptr = G->scripts;
   
   flags = f;
   while ((ptr = ptr->Next()))
     ptr->AddMiscVar(this);
}
   
MiscVariable::~MiscVariable ( void ) {
   FUNCTION;
   ScriptContext * ptr = G->scripts;
   
   while ((ptr = ptr->Next()))
     ptr->RemMiscVar(this);
}

int MiscVariable::ExpMem ( void ) {
   FUNCTION;
   return sizeof(MiscVariable);
}
