/*
 * ModuleEntryeggdrop.h - The module entry for the core
 */

#ifndef _MODULEENTRY_
#include "ModuleEntry.h"
#endif

#ifndef _MODULEENTRYEGGDROP_
#define _MODULEENTRYEGGDROP_

#define HS_ISDCC  1
#define HS_HILITE 2

class ModuleEntryEggdrop : public ModuleEntry {
   void SubstAddCol (char *, int, int);
  public:
   MemType * memtype_list;
   MemType * memtype_misc;
   MemType * memtype_userent;
   MemType * memtype_chanrec;
   MemType * memtype_ban;
   MemType * memtype_user;
   MemType * memtype_bind;
   MemType * memtype_socket;
   MemType * memtype_language;
   MemType * memtype_log;
   MemType * memtype_help;
   MemType * memtype_ignore;
   MemType * memtype_hook;
   MemType * memtype_hostcache;
   MemType * memtype_dep;
   MemType * memtype_static;
   MemType * memtype_modules;
   MemType * memtype_script;
   MemType * memtype_chanset;
   UserRecord * userlist;
   UserRecord * lastuser;
   UserEntry * entrytype_list;
   UserEntry * entrytype_hosts;
   UserEntry * entrytype_pass;
   UserEntry * entrytype_comment;
   UserEntry * entrytype_xtra;
   UserEntry * entrytype_info;
   UserEntry * entrytype_laston;
   UserEntry * entrytype_unknown;
   UserEntry * entrytype_botfl;
   IgnoreRecord * ignores;
   BanRecord * global_bans;
   BindTable * bind_list;
   BindTable * bt_dcc;
   BindTable * bt_filt;
   BindTable * bt_chon;
   BindTable * bt_chof;
   BindTable * bt_load;
   BindTable * bt_unld;
   BindTable * bt_chat;
   BindTable * bt_act;
   BindTable * bt_bcst;
   BindTable * bt_away;
   BindTable * bt_lnkch;
   BindTable * bt_time;
   BindTable * bt_note;
   BindTable * bt_strnote;
   BindTable * bt_lchjn;
   BindTable * bt_lchpt;
   BindTable * bt_die;
   BindTable * bt_listen;
   BindTable * bt_name;
   ChannelRecord * null_chanrec;
   Command * command_list;
   Socket * socklist;
   Socket * Log;
   Socket * Stderr;
   Socket * Stdout;
   HelpReference * help_list;
   LogFile * log_list;
   LogModes LOG_MISC;
   LogModes LOG_CMDS;
   LogModes LOG_SOCKET;
   LogModes conmask;
   HookList * hook_list;
   HookList * hook_secondly;
   HookList * hook_minutely;
   HookList * hook_5minutely;
   HookList * hook_hourly;
   HookList * hook_daily;
   HookList * hook_idle;
   HookList * hook_pre_rehash;
   HookList * hook_rehash;
   HookList * hook_read_userfile;
   HookList * hook_write_userfile;
   HostnameCache * host_cache;
   ModuleLanguage * langtab_list;
   Dependancy * dep_list;
   StaticMods * statics;
   ModuleEntry * module_list;
   ModuleEntry * module_eggdrop;
   ModuleEntryEncryption * module_encrypt;
   ScriptContext * scripts;
   Variable * variable_list;
   Version AnyVer;
   Version ServerVer;
   Version IrcVer;
   const char * DCC_CHAT_PASS;
   const char * DCC_CHAT;
   const char * DCC_CHAT_LOGIN;
   const char * DCC_CHAT_NEWUSER;
   const char * DCC_CHAT_NEWPASS;
   const char * TELNET_PORT;
   const char * IDENT_WAIT;
   const char * IDENT_LOOKUP;
   const char * SPECIAL;
   Channel * chanset;
   int backgrd;
   int share_greet;
   int max_dcc;
   int require_p; 
   int use_console_r;
   int reserved_port;
   int debug_output;
   int noshare;
   int gban_total;
   int make_userfile;
   int default_flags;
   int dcc_total;
   int do_restart;
   int port_range;
   int ignore_time;
   int protect_readonly;
   int dcc_flood_thr;
   int allow_new_telnets;
   int max_sendq;
   int allow_dk_cmds;
   int hostcache_age;
   int hostcache_count;
   int resolve_timeout;
   int protect_telnet;
   int keep_all_logs;
   int use_stderr;
   int shtime;
   int con_chan;
   int term_z;
   int cache_hit;
   int cache_miss;
   int firewallport;
   int flood_telnet_thr;
   int flood_telnet_time;
   time_t connect_timeout;
   time_t ident_timeout;
   time_t password_timeout;
   time_t now;
   time_t online_since;
   fd_set fds_read;
   fd_set fds_write;
   char moddir[121];
   char long_version[VERSION_LEN+1];
   char tempdir[121];
   char notify_new[121];
   char helpdir[121];
   char natip[121];
   char origbotname[NICKMAX + 1];
   char botnetnick[HANDLEN+1];
   char botuser[21];
   char admin[121];
   char userfile[121];
   char myip[121];
   char motdfile[121];
   char whois_fields[121];
   char owner[121];
   char pid_file[41];
   char configfile[121];
   char savedconfigfile[121];
   char firewall[121];

   void (*shareout) (Channel *, char *, ...);
   UserRecord * (*check_chanlist) (const char *, UserRecord *, int);

   int (*vsnprintf) (char *, size_t, const char *, va_list);
   void * (*memset) (void *, int, size_t);
   int (*strcasecmp) (const char *, const char *);
   BindReturn (*cmd_die) (void **, const char *);
   BindReturn (*cmd_note) (void **, const char *);
   BindReturn (*cmd_boot) (void **, const char *);

   char context_stack[16][64];
   int context_ptr;
   
   ModuleEntryEggdrop ( ModuleEntry & );
   ~ModuleEntryEggdrop ( void );
   
   virtual int Base64To ( char * );
   virtual char * ToBase64 (unsigned int);
   virtual char * ToBase10 (unsigned long);
   virtual int SPrintF (char *, int, char *, ...);
   virtual struct in_addr * GetMyIp (void);
   virtual void MemCpy (char *, char *, int);
   virtual int StrCpy (char *, const char *);
   virtual void Days (time_t,time_t,char *);
   virtual void DaysAgo (time_t,time_t,char *);
   virtual void DaysDur (time_t,time_t,char *);
   virtual char * Split (char **);
   virtual char * SplitNick (char **);
   virtual void SplitC (char *,char *,char);
   virtual void Fatal (const char *);
   virtual int MoveFile (char *, char *);
   virtual int CopyFile (char *, char *);
   virtual void MakePass (char *);
   virtual int WildMatchPer (register unsigned char *, register unsigned char *);
   virtual int _WildMatch (register unsigned char *, register unsigned char *);
   virtual void MaskHost (const char *,char*);
   virtual void HelpSubst (char*,const char*,FlagRecord*,int,const char*);
   virtual void RMSpace (char *);
   virtual int AddNote (const char *,const char *,char *,Socket *,int);
   virtual int StripModes (const char *);
   virtual char * StripMaskType (int);
   virtual int LoadLanguage (const char *);
   virtual void Reload ( void );
   virtual Socket * FindValidIdx (int);
   virtual void Rehash ( void );
   virtual void Chanprog ( void );
   virtual int SaveConfig ( DccChat * );
   virtual int LoadConfig ( DccChat * );
   
   inline void * MemSet (void * a, int b, size_t c) {
      return memset(a,b,c);
   }
   inline int StrCaseCmp (const char * a, const char * b) {
      return strcasecmp(a,b);
   }
   inline int VSNPrintf (char * a, size_t b, const char * c, va_list d) {
      return vsnprintf(a,b,c,d);
   }
   inline int WildMatch(const char * a,const char * b) {
      return _WildMatch((unsigned char *)a,(unsigned char *)b);
   }
};

#ifndef _MEMTYPE_
#include "MemType.h"
#endif

inline void * ModuleEntry::operator new (size_t s, int x ) {
   return G->memtype_modules->Malloc(s,x);
}

inline void ModuleEntry::operator delete (void * ptr) {
   G->memtype_modules->Free(ptr);
}
#endif
