/*
 * ModuleLanguage.C - member functions for ModuleLanguage class
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ModuleLanguage.h"
#include "ModuleEntry.h"
#define CLASS "ModuleLanguage"

ModuleLanguage::~ModuleLanguage ( void ) {
   FUNCTION;
}

ModuleLanguage::ModuleLanguage ( char * name ) :
KeyedList<MISCLEN> ( *G->langtab_list, name ) {
   FUNCTION;
   ModuleEntry * ment;
   
   if ((ment = G->module_list->Find(name, &G->AnyVer)))
     ment->language = this;
}

ModuleLanguage * ModuleLanguage::Module ( const char * name ) {
   FUNCTION;
   ModuleLanguage * ml = (ModuleLanguage *)G->langtab_list->Find(name);
   if (!ml) {
      G->LoadLanguage(name);
      ml = (ModuleLanguage *)G->langtab_list->Find(name);
   }
   return ml;
}

void ModuleLanguage::Dump ( Socket * idx ) {
   FUNCTION;
   int i;
   
   for (i = 0; i < 32; i++)
     langtab[i].Dump(this, idx);
}

int ModuleLanguage::ExpMem ( void ) {
   FUNCTION;
   ModuleLanguage * ptr = this;
   int tot = sizeof(ModuleLanguage), l;
   
   while ((ptr = ptr->Next())) {
      tot += sizeof(ModuleLanguage);
      for (l = 0; l < 32; l++)
	tot += ptr->langtab[l].ExpMem();
   }
   return tot;
}
