/*
 * ModuleLanguage.h - class definitions for the ModuleLanguage class
 */

#ifndef _KEYEDLIST_
#include "KeyedList.h"
#endif

#ifndef _LANGUAGENTRY_
#include "LanguageEntry.h"
#endif

#ifndef _MODULELANGUAGE_
#define _MODULELANGUAGE_

class ModuleLanguage : public KeyedList<MISCLEN> {
  protected:
   LanguageEntry langtab[32];
   friend LanguageEntry;
  public:
   inline ModuleLanguage ( void ) : KeyedList<MISCLEN> () {
   }
   ModuleLanguage ( char * ); 
   ~ModuleLanguage ( void );
   
   inline ModuleLanguage * Next ( void ) {
      return (ModuleLanguage *)next;
   }
   int ExpMem ( void );
   MEMORY_TYPE(G->memtype_language);
   inline LanguageEntry * Entry ( int x ) {
      return &langtab[x & 31];
   }
   ModuleLanguage * Module ( const char * );
   void Dump ( Socket * );
};

#ifndef MAKING_MODS
extern ModuleLanguage * core_langtab;
#endif

#endif
