/*
 * StringVariable.C
 */
/*
 * This file is part of the eggdrop 2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "StringVariable.h"
#include "ScriptContext.h"
#define CLASS "StringVariable"

StringVariable::StringVariable ( char * n, char * b, int l, int f,
				ModuleEntry * m ) 
: Variable ( n, m, STRING ) {
   FUNCTION;
   ScriptContext * ptr = G->scripts;

   buf = b;
   length = l;
   flags = f;
   while ((ptr = ptr->Next()))
     ptr->AddStringVar(this);
}

StringVariable::~StringVariable ( void ) {
   FUNCTION;
   ScriptContext * ptr = G->scripts;
   
   while ((ptr = ptr->Next()))
     ptr->RemStringVar(this);
}

int StringVariable::ExpMem ( void ) {
   FUNCTION;
   return sizeof(StringVariable);
}

