/*
 * DccTelnet.h
 */

#ifndef _LISTENINGSOCKET_
#include "ListeningSocket.h"
#endif

#ifndef _TELNETPORT_
#define _TELNETPORT_

class TelnetPort : public ListeningSocket {
  protected:
   int origport;
   ScriptContext * sc;
  public:
   TelnetPort ( ScriptContext * sc, const char *, int, const char *, const char *);
   TelnetPort ( void );
   ~TelnetPort ( void );
   
   Socket * Create ( int );

   void Eof (void);
   void Activity (char *, int);
   void Display2 (Socket *);
   int Dump ( char *, int );
   int DetectFlood (const char * host);
   int ExpMem ( void );
   TelnetPort * Find ( int );
   
   inline TelnetPort * Next ( void ) {
      TelnetPort * ptr = this;
      while ((ptr = (TelnetPort *)ptr->next) && (ptr->type != G->TELNET_PORT));
      return ptr;
   }
   inline int OrigPort ( void ) { return origport; }
   inline ScriptContext * Script ( void ) { return sc; }
};
#endif

