/*
 * UserEntry.h - class definitions for the UserEntry class
 */

#ifndef _LIST_
#include "List.h"
#endif

#ifndef _USERENTRY_
#define _USERENTRY_

class UserEntry : public List {
  protected:
   UserRecord * owner;
   UserEntry * type;
   
  public:
   inline UserEntry ( void ) : List ( ) { }
   inline UserEntry ( UserRecord * u) : List () { owner = u; }
   UserEntry ( UserRecord *, UserEntry * e);
   UserEntry ( const char *, ModuleEntry * m = 0 );
   ~UserEntry ( void );

   int ExpMem ( void );
  
   virtual void GotShare ( char *, Socket * );
   virtual void PruneUser ( Socket * );
   virtual int Write ( FILE *, Socket * );
   virtual int ScriptGet ( ScriptContext *, int, ScriptArgument ** );
   virtual int ScriptSet ( ScriptContext *, int, ScriptArgument ** );
   virtual void Display (Socket * );
   virtual void Unpack ( UserRecord *, MessageQueue * );
   virtual void Pack ( UserEntry * );
   virtual int MatchThis ( const char * );
   virtual UserEntry * Create ( UserRecord * );
   UserEntry * Find ( UserEntry * );
   UserEntry * Find ( const char * c );
   
   inline UserRecord * Owner ( void ) { return owner; }
   inline UserEntry * Type ( void ) { return type; }
   inline void SetOwner ( UserRecord * o ) { owner = o; }
   inline const char * Name ( void ) {
      return (char *)(owner ? type->type : type);
   }
   MEMORY_TYPE(G->memtype_userent);
   DEF_NEXT(UserEntry);
};
#endif
