/*
 * UserEntryBotfl.C - member functions for the UserEntryBotfl class
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "UserEntryBotfl.h"
#include "UserRecord.h"
#include "Socket.h"
#include "FlagRecord.h"
#include "ScriptContext.h"
#include "ScriptArgument.h"
#include "UserEntryUnknown.h"
#define CLASS "UserEntryBotfl"

UserEntryBotfl::~UserEntryBotfl ( void ) {
   FUNCTION;
}

UserEntry * UserEntryBotfl::Create ( UserRecord * u ) {
   FUNCTION;
   return NEW ( UserEntryBotfl ( u, this ) );
}

void UserEntryBotfl::Unpack ( UserRecord * u, MessageQueue * e ) {
   FUNCTION;
   UserEntryBotfl * ue = (UserEntryBotfl *)u->GetEntry(this);
   MessageQueue * x = e->Next();
   FlagRecord fr (FlagRecord::BOT);
   
   if (x) {
      fr.BreakDown(x->Data());
      ue->Set(fr.Bot());
   }
}

void UserEntryBotfl::Pack ( UserEntry * ue ) {
   FUNCTION;
   UserEntryUnknown * ueu = 
     (UserEntryUnknown *)ue->Owner()->GetEntry(G->entrytype_unknown);
   FlagRecord fr ( FlagRecord::BOT );
   char x[100];

   fr.SetBot(((UserEntryBotfl *)ue)->Flags());
   fr.Build(x);
   ueu->NewLine((char *)type, x);
}

int UserEntryBotfl::Write (FILE * f, Socket * idx) {
   FUNCTION;
   char x[100];
   FlagRecord fr (FlagRecord::BOT);

   if (!idx) {
      context;
      fr.SetBot(flags);
      fr.Build(x);
      return fprintf(f,"=botfl %s\n",x) != EOF;
   }
   return 1;
}

int UserEntryBotfl::ScriptGet (ScriptContext * sc, int, ScriptArgument **) {
   FUNCTION;
   char x[100];
   FlagRecord fr (FlagRecord::BOT);

   fr.SetBot(flags);
   fr.Build(x);
   sc->SetString(x);
   return SCRIPT_OK;
}

int UserEntryBotfl::ScriptSet (ScriptContext * sc, int argc, ScriptArgument ** argv) {
   FUNCTION;
   FlagRecord fr (FlagRecord::BOT), fr2 (owner);
   
   BADARGS(4,4,G->Lang(0x1C8, ""));
   if (fr2.GlobBot()) {
      /* silently ignore for users */
      fr.BreakDown(argv[3]->AsString());
      flags = fr.Bot();
   }
   return SCRIPT_OK;
}

int UserEntryBotfl::ExpMem ( void ) {
   FUNCTION;
   return sizeof(UserEntryBotfl);
}

void UserEntryBotfl::Display (Socket * idx) {
   FUNCTION;
   FlagRecord fr (FlagRecord::BOT);
   char x[100];
   
   context;
   if (flags) {
      fr.SetBot(flags);
      fr.Build(x);
      idx->Send(G->Lang(0x1C9, "s", x));
   }
}

void UserEntryBotfl::Set (long atr) {
   FUNCTION;
   FlagRecord fr (owner,FlagRecord::GLOBAL | FlagRecord::BOT);
   context;
   if (fr.GlobBot()) {
      fr.SetBot(atr);
      fr.Sanity();
      flags = fr.Bot();
   }
}
