/*
 * UserEntryBotfl.h - class definitions for the UserEntryBotfl class
 */

#ifndef _USERENTRY_
#include "UserEntry.h"
#endif

#ifndef _USERENTRYBOTFL_
#define _USERENTRYBOTFL_

class UserEntryBotfl : public UserEntry {
  protected:
   long flags;
   
  public:
   inline UserEntryBotfl ( UserRecord * u, UserEntry * t ) 
     : UserEntry ( u, t ) {
	flags = 0;
   }
   inline UserEntryBotfl ( void ) : UserEntry ( "BOTFL" ) { }
   ~UserEntryBotfl ( void );
   
   void Unpack ( UserRecord *, MessageQueue * );
   void Pack ( UserEntry * );
   UserEntry * Create ( UserRecord * );

   int Write ( FILE *, Socket * );
   int ScriptGet ( ScriptContext *, int, ScriptArgument **);
   int ScriptSet ( ScriptContext *, int, ScriptArgument **);
   void Display (Socket * );
   int ExpMem ( void );
   virtual void Set ( long );

   inline long HasFlags ( long x ) { return flags & x; };
   inline long Flags ( void ) { return flags; };
};
#endif
