/*
 * UserEntryComment.C - member functions for the UserEntryComment class
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "UserEntryComment.h"
#include "Socket.h"
#include "UserRecord.h"
#include "FlagRecord.h"
#define CLASS "UserEntryComment"

UserEntryComment::~UserEntryComment ( void ) {
   FUNCTION;
}

UserEntry * UserEntryComment::Create ( UserRecord * u ) {
   FUNCTION;
   return NEW ( UserEntryComment ( u, this ) );
}

void UserEntryComment::GotShare ( char * line, Socket * ) {
   FUNCTION;
   Set(line);
}

int UserEntryComment::Write ( FILE * f, Socket * ) {
   FUNCTION;
   return fprintf(f,"=%s %s\n",type->Name(), safe_str(string)) != EOF;
}

void UserEntryComment::PruneUser ( Socket *) {
   FUNCTION;
   DELETE ( this );
}

void UserEntryComment::Display ( Socket * idx ) {
   FUNCTION;
   FlagRecord fr (idx->User());
   context;
   if (fr.GlobMaster())
     idx->Send(G->Lang(0x263, "s", string));
}
   
void UserEntryComment::Set ( char * buf ) {
   FUNCTION;
   int x = G->noshare;
   FlagRecord fr (owner);
   
   context;
   G->noshare = 1;
   UserEntryString::Set(buf);
   G->noshare = x;
   if (!G->noshare && G->shareout && !fr.GlobBot() && !fr.GlobUnshared())
     G->shareout(NULL,"c%s %s %s\n", type->Name(), owner->Handle(),
		 safe_str(string));
   context;
}
