/*
 * UserEntryComment.h - class definitions for the UserEntryComment class
 */

#ifndef _USERENTRYSTRING_
#include "UserEntryString.h"
#endif

#ifndef _USERENTRYCOMMENT_
#define _USERENTRYCOMMENT_

class UserEntryComment : public UserEntryString {
  public:
   inline UserEntryComment ( UserRecord * u, UserEntry * t )
     : UserEntryString ( u, t ) {
     }
   inline UserEntryComment ( const char * c = "COMMENT", ModuleEntry * m = 0 )
     : UserEntryString ( c, m ) {
   }
   ~UserEntryComment ( void );
   
   UserEntry * Create ( UserRecord * );   
   void GotShare ( char *, Socket * );
   void PruneUser ( Socket *);
   int Write ( FILE * f, Socket * );
   void Display (Socket * );
   void Set ( char * );   
};

#ifndef _USERRECORD_
#include "UserRecord.h"
#endif

inline UserEntryComment * GetComment ( UserRecord * u ) {
   return (UserEntryComment *)u->GetEntry(List::G->entrytype_comment);
}

inline UserEntryComment * FindComment ( UserRecord * u ) {
   return (UserEntryComment *)u->FindEntry(List::G->entrytype_comment);
}

#endif
