
/*
 * UserEntryHosts.h - class definitions for the UserEntryHosts class
 */

#ifndef _USERENTRY_
#include "UserEntry.h"
#endif

#ifndef _USERENTRYHOSTS_
#define _USERENTRYHOSTS_

class UserEntryHostsList : public KeyedList<UHOSTLEN> {
  public:
   inline UserEntryHostsList ( void ) : KeyedList<UHOSTLEN> () {
   }
   inline UserEntryHostsList (UserEntryHostsList & x, const char * y, int z) 
     : KeyedList<UHOSTLEN> (x,y,z) {
     }
   MEMORY_TYPE(G->memtype_userent);
};
   
class UserEntryHosts : public UserEntry {
  protected:
   UserEntryHostsList list;
   friend class UserEntryTypeHosts;
   
  public:
   inline UserEntryHosts ( UserRecord * u, UserEntry * uet)
     : UserEntry ( u, uet ) {
     }
   inline UserEntryHosts ( void ) : UserEntry ( "HOSTS" ) { }
   ~UserEntryHosts ( void );
   
   void Unpack ( UserRecord *, MessageQueue * );
   void Pack ( UserEntry * );
   UserEntry * Create ( UserRecord * );
   
   void PruneUser ( Socket * );
   int Write ( FILE *, Socket * );
   int ScriptGet ( ScriptContext *, int, ScriptArgument ** );
   int ScriptSet ( ScriptContext *, int, ScriptArgument ** );
   void Display (Socket * );
   int ExpMem ( void );
   int MatchThis ( const char * );

   int FindHost ( const char *, int );
   void Add ( const char *);
   
   inline KeyedList<UHOSTLEN> * Find ( const char * x ) { return list.Find(x); }
   inline KeyedList<UHOSTLEN> * Match ( const char * x ) {
      return list.Match(x); 
   }
   inline int Del ( const char * del ) { return list.Remove(del); }
   inline KeyedList<UHOSTLEN> * First ( void ) { return &list; }
};
#endif
