/*
 * UserEntryInfo.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "UserEntryInfo.h"
#include "Socket.h"
#define CLASS "UserEntryInfo"

UserEntryInfo::~UserEntryInfo ( void ) {
   FUNCTION;
}

UserEntry * UserEntryInfo::Create ( UserRecord * u ) {
   FUNCTION;
   return NEW ( UserEntryInfo ( u, this ) );
}

int UserEntryInfo::Write ( FILE * f, Socket * idx ) {
   FUNCTION;
   if (!idx || G->share_greet) 
     return fprintf(f,"=%s %s\n",type->Name(), safe_str(string)) != EOF;
   return 1;
}

void UserEntryInfo::PruneUser ( Socket * ) {
   FUNCTION;
   if (G->share_greet) 
     DELETE ( this );
}

void UserEntryInfo::GotShare ( char * data, Socket * idx ) {
   FUNCTION;
   if (G->share_greet) {
      G->LOG_CMDS.Put(G->Lang(0x260, "sss", idx->Nick(), type->Name(),owner->Handle()));
      Set(data);
   }
}

void UserEntryInfo::Set ( char * buf ) {
   FUNCTION;
   int o = G->noshare;
   FlagRecord fr ( owner );
   
   G->noshare = 1;
   UserEntryString::Set(buf);
   G->noshare = o;
   if (!G->noshare && G->shareout && G->share_greet &&
       !fr.GlobBot() && !fr.GlobUnshared())
     G->shareout(NULL,"c%s %s %s\n", type->Name(), owner->Handle(),
		 safe_str(string));
}
