/*
 * UserEntryInfo.h - class definitions for the UserEntryString class
 */

#ifndef _USERENTRYSTRING_
#include "UserEntryString.h"
#endif

#ifndef _USERENTRYINFO_
#define _USERENTRYINFO_

class UserEntryInfo : public UserEntryString {
  public:
   inline UserEntryInfo ( UserRecord * u, UserEntry * t ) 
     : UserEntryString ( u, t ) {
   }
   inline UserEntryInfo ( const char * st = "INFO", ModuleEntry * m = 0)
     : UserEntryString ( st, m ) { }
   ~UserEntryInfo ( void );

   UserEntry * Create ( UserRecord * );
   
   void GotShare ( char *, Socket * );
   void PruneUser ( Socket * );
   int Write ( FILE *, Socket * );
   void Set ( char * );
};

#ifndef _USERRECORD_
#include "UserRecord.h"
#endif

inline UserEntryInfo * FindInfo ( UserRecord * u ) {
   return (UserEntryInfo *)u->FindEntry(List::G->entrytype_info);
}

inline UserEntryInfo * GetInfo ( UserRecord * u ) {
   return (UserEntryInfo *)u->GetEntry(List::G->entrytype_info);
}

#endif
