/*
 * UserEntryLaston.h - class definitions for the UserEntryLaston class
 */

#ifndef _USERENTRYSTRING_
#include "UserEntryString.h"
#endif

#ifndef _USERRECORD_
#include "UserRecord.h"
#endif

#ifndef _USERENTRYLASTON_
#define _USERENTRYLASTON_

class UserEntryLaston : public UserEntryString {
  protected:
   time_t when;
   
  public:
   inline UserEntryLaston ( UserRecord * u, UserEntry * t ) 
     : UserEntryString ( u, t ) {
      when = 0;
   }
   inline UserEntryLaston ( const char * c = "laston", ModuleEntry * m = 0) 
     : UserEntryString ( c, m ) { }
   ~UserEntryLaston ( void );
  
   void Unpack ( UserRecord *, MessageQueue * );
   void Pack ( UserEntry * );
   UserEntry * Create ( UserRecord * );
   
   int Write ( FILE *, Socket * );
   int ScriptGet ( ScriptContext *, int, ScriptArgument **);
   int ScriptSet ( ScriptContext *, int, ScriptArgument **);
   int ExpMem ( void );
   void Display ( Socket * );
   
   inline void Set ( char * x, time_t t) {
      when = t;
      UserEntryString::Set(x);
   }
   inline time_t When ( void ) { return when; }
   inline const char * Where ( void ) { return string; }
};

inline void TouchLaston (UserRecord * u, char * where, time_t timeval ) {
   UserEntryLaston * uel = (UserEntryLaston *)u->GetEntry(List::G->entrytype_laston);
   if (uel)
     uel->Set(where, timeval);
}

inline UserEntryLaston * FindLaston ( UserRecord * u ) {
   return (UserEntryLaston *)u->GetEntry(List::G->entrytype_laston);
}

#endif
