/*
 * UserEntryPass.C - member functions for the UserEntryPass class
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "UserEntryPass.h"
#include "FlagRecord.h"
#include "ModuleEntryEncryption.h"
#include "ScriptContext.h"
#define CLASS "UserEntrPass"

UserEntryPass::~UserEntryPass ( void ) {
   FUNCTION;
}

UserEntry * UserEntryPass::Create ( UserRecord * u ) {
   FUNCTION;
   return NEW ( UserEntryPass ( u, this ) );
}

void UserEntryPass::Display ( Socket * ) {
   FUNCTION;
}

void UserEntryPass::Set ( char * buf ) {
   FUNCTION;
   char newp[32];
   register char * pass = (char *)buf;
   FlagRecord fr (owner);

   if (string)
     my_free(string,G->memtype_userent);
   if (!pass || !pass[0] || (pass[0] == '-'))
     string = NULL;
   else {
      unsigned char * p = (unsigned char *) pass;
      
      if (pass[0] == '+') {
	 if (strlen(pass) > 31)
	   pass[31] = 0;
      } else if (strlen(pass) > 15)
	pass[15] = 0;
      while (*p) {
	 if ((*p <= 32) || (*p == 127))
	   *p = '?';
	 p++;
      }
      if (fr.GlobBot() || (pass[0] == '+'))
	 strcpy(newp,pass);
      else 
	G->module_encrypt->EncryptPass(pass, newp);
      string = (char *)my_malloc(strlen(newp)+1,G->memtype_userent);
      strcpy(string,newp);
   }
   if (!G->noshare && G->shareout && !fr.GlobBot() && !fr.GlobUnshared())
     G->shareout(NULL,"cPASS %s %s\n", owner->Handle(), safe_str(string));
}
 
int UserEntryPass::MatchThis ( const char * ) {
   FUNCTION;
   return 0;
}

int UserEntryPass::ScriptGet ( ScriptContext *, int, ScriptArgument ** ) {
   FUNCTION;
   return SCRIPT_ERROR;
}
