/*
 * UserEntryPass.h - class definitions for the UserEntryPass class
 */

#ifndef _USERENTRYCOMMENT_
#include "UserEntryComment.h"
#endif

#ifndef _USERRECORD_
#include "UserRecord.h"
#endif

#ifndef _USERENTRYPASS_
#define _USERENTRYPASS_

class UserEntryPass : public UserEntryComment {
  public:
   inline UserEntryPass ( UserRecord * u, UserEntry * t )
     : UserEntryComment (u, t) {
     }
   inline UserEntryPass ( ) : UserEntryComment ( "PASS" ) { }
   ~UserEntryPass ( void );
   
   UserEntry * Create ( UserRecord * );

   void Display (Socket * );
   void Set ( char * );
   int ScriptGet ( ScriptContext *, int, ScriptArgument ** );
   int MatchThis ( const char * );
};

inline void SetPassword ( UserRecord * u, char * p ) {
   UserEntryPass * uep = (UserEntryPass *)u->GetEntry(List::G->entrytype_pass);
   uep->Set(p);
}
#endif
