/*
 * UserEntryString.h - class definitions for the UserEntryString class
 */

#ifndef _USERENTRY_
#include "UserEntry.h"
#endif

#ifndef _USERENTRYSTRING_
#define _USERENTRYSTRING_

class UserEntryString : public UserEntry {
  protected:
   char * string;
   
  public:
   inline UserEntryString ( UserRecord * u, UserEntry * t ) 
     : UserEntry ( u, t ) {
      string = 0;
   }
   inline UserEntryString ( const char * st, ModuleEntry * m = 0)
     : UserEntry ( st, m ) { }
   ~UserEntryString ( void );
   
   void Unpack ( UserRecord *, MessageQueue * );
   void Pack ( UserEntry * );
   UserEntry * Create ( UserRecord * );
   
   int Write ( FILE *, Socket * );
   int ScriptGet ( ScriptContext *, int, ScriptArgument **);
   int ScriptSet ( ScriptContext *, int, ScriptArgument **);
   void Display (Socket * );
   int ExpMem ( void );
   int MatchThis ( const char *);
   virtual void Set ( char * );
   
   inline const char * Value ( void ) { return string; }
};

#endif
