/*
 * UserEntryUnknown.C - member functions for the UserEntryUknown class
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "UserEntryUnknown.h"
#define CLASS "UserEntryUnknown"

UserEntryUnknown::~UserEntryUnknown ( void ) {
   FUNCTION;
}

int UserEntryUnknown::ExpMem ( void ) {
   FUNCTION;
   return sizeof(UserEntryUnknown) + list.ExpMem();
}

UserEntry * UserEntryUnknown::Create ( UserRecord * u ) {
   FUNCTION;
   return NEW ( UserEntryUnknown ( u, this ) );
}

int UserEntryUnknown::Write ( FILE * f, Socket * idx) {
   FUNCTION;
   QueueQueue * qptr = &list;

   if (!idx) 
     while ((qptr = qptr->Next())) {
	MessageQueue * mqptr = qptr->Head();
	
	while ((mqptr = mqptr->Next()))
	  if (fprintf(f, "=%s %s\n", qptr->Key(), mqptr->Data()) == EOF)
	    return 0;
     }
   return 1;
}

void UserEntryUnknown::Unpack ( UserEntry * type ) {
   FUNCTION;
   QueueQueue * ptr, *nptr = 0;
   
   if (type) {
      if ((ptr = list.Find(type->Name()))) {
	 type->Unpack(owner, ptr->Head());
	 list.Remove(ptr);
	 DELETE ( ptr );
      }
   } else 
     nptr = list.Next();
   while ((ptr = nptr)) {
      nptr = ptr->Next();
      if ((type = G->entrytype_list->Find(ptr->Key()))) {
	 type->Unpack(owner, ptr->Head());
	 list.Remove(ptr);
	 DELETE ( ptr );
      }
   }
}
 
void UserEntryUnknown::NewLine ( const char * tag, const char * data) {
   FUNCTION;
   QueueQueue * qptr = list.Find(tag);
   
   if (!qptr)
     qptr = NEW ( QueueQueue ( list, tag ) );
   NEW ( MessageQueue2 ( *qptr->Head(), data, strlen(data)) );
}
