/*
 * UserEntryUnknown.h - class definitions for the UserEntryUnknown class
 */

#ifndef _USERENTRY_
#include "UserEntry.h"
#endif

#ifndef _QUEUEQUEUE_
#include "QueueQueue.h"
#endif

#ifndef _USERENTRYUNKOWN_
#define _USERENTRYUNKOWN_

class UserEntryUnknown : public UserEntry {
  protected:
   QueueQueue list;
   
  public:
   inline UserEntryUnknown ( void ) : UserEntry ( ) { }
   inline UserEntryUnknown ( UserRecord * a,  UserEntry * b)
     : UserEntry (a, b) {
     }
   inline UserEntryUnknown ( int ) : UserEntry ( "~UNKOWN~" ) { }
   ~UserEntryUnknown ( void );

   UserEntry * Create ( UserRecord * );
   
   int ExpMem ( void );

   void Unpack ( UserEntry * );
   void NewLine ( const char *, const char * );
   int Write ( FILE * f, Socket * );
   
   inline UserEntry * Next ( void ) { return (UserEntry *)next; }
   MEMORY_TYPE(G->memtype_userent);
};

#ifndef _USERRECORD_
#include "UserRecord.h"
#endif

inline UserEntryUnknown * GetUnkown ( UserRecord * u ) {
   return (UserEntryUnknown *)u->GetEntry(List::G->entrytype_unknown);
}

#endif
