/*
 * UserEntryXtra.h - class definitions for the UserEntryXtra class
 */

#ifndef _USERENTRY_
#include "UserEntry.h"
#endif

#ifndef _XTRAKEYS_
#include "XtraKeys.h"
#endif

#ifndef _USERENTRYXTRA_
#define _USERENTRYXTRA_

class UserEntryXtra : public UserEntry {
  protected:
   XtraKeys list;
   friend class UserEntryTypeXtra;
   
  public:
   UserEntryXtra ( UserRecord *, UserEntry * );
   inline UserEntryXtra ( ) : UserEntry ( "XTRA" ) { }
   ~UserEntryXtra ( void );
   
   void Unpack ( UserRecord *, MessageQueue * );
   void Pack ( UserEntry * );
   UserEntry * Create ( UserRecord * );
   
   void GotShare ( char *, Socket *);
   int Write ( FILE *,Socket * );
   int ScriptGet ( ScriptContext *, int, ScriptArgument **);
   int ScriptSet ( ScriptContext *, int, ScriptArgument **);
   void Display (Socket * );
   int ExpMem ( void );
   
   inline XtraKeys * FindKey ( const char * x ) {
      return list.Find(x);
   }
   inline XtraKeys * GetKey ( const char * x ) {
      XtraKeys * y = FindKey(x);
      if (!y)
	y = NEW ( XtraKeys(list, x, "") );
      return y;
   }
   void SetKey ( const char *, const char * );
};

#ifndef _USERRECORD_
#include "UserRecord.h"
#endif

inline UserEntryXtra * FindXtra ( UserRecord * u ) {
   return (UserEntryXtra *)u->FindEntry(List::G->entrytype_xtra);
}

inline UserEntryXtra * GetXtra ( UserRecord * u ) {
   return (UserEntryXtra *)u->GetEntry(List::G->entrytype_xtra);
}

inline const char * GetXtra ( UserRecord * u, const char * key ) {
   UserEntryXtra * uex;
   XtraKeys * xk = 0;
   
   if ((uex = FindXtra(u)) && (xk = uex->FindKey(key)))
     return xk->Data();
   return 0;
}
   
     
#endif
