/*
 * UserRecord.h - class definition for UserRecord class
 */

#ifndef _KEYEDLIST_
#include "KeyedList.h"
#endif

#ifndef _USERENTYBOTFL_
#include "UserEntryBotfl.h"
#endif

#ifndef _USERENTYTYPE_
#include "UserEntry.h"
#endif

#ifndef _FLAGRECORD_
#include "FlagRecord.h"
#endif

#ifndef _USERRECORD_
#define _USERRECORD_

class UserRecord : public KeyedList<HANDLEN> {
  protected:
   unsigned long flags;
   unsigned long flags_udef;
   ChannelRecord *chanrec;
   UserEntry entries;
   friend class UserEntry;
   friend class FlagRecord;
   
  public:
   inline UserRecord ( void ) : KeyedList<HANDLEN> ( ), entries (this) {
      SetKey("**");
   }
   UserRecord ( UserRecord *, const char *, char *, FlagRecord & );
   ~UserRecord ( void );

   MEMORY_TYPE(G->memtype_user);
   DEF_NEXT(UserRecord);
   int ExpMem ( void );
   UserRecord * Find ( const char * );
   UserRecord * FindHost ( const char * );
   UserRecord * FindExactHost ( const char * );
   int PassMatch ( const char * );
   int DelHost ( const char * );
   void AddHost ( const char * );
   void Display ( Socket * );
   void Backup( void );
   inline void Set ( FlagRecord & fr, const char * s = 0) {
      fr.Get(this,s);
   }
   int Write ( FILE *, Socket * s = 0, int = 0 );
   void WriteUserfile ( Socket * );
   int ReadUserfile ( const char *, Socket * );
   int CheckDccAttrs ( unsigned int );
   int CheckDccChanAttrs ( const char *, int );
   int ChangeHandle ( char * );
   void DisplayMatch ( DccChat *, char *, int, int, char * );
   
   inline UserEntry * Entries ( void ) { return &entries; }
   inline const char * Handle ( void ) { return key; }
   inline void SetHandle ( const char * x ) { SetKey (x); }
   inline ChannelRecord * ChanRecs ( void ) { return chanrec; }
   inline void SetChanRecs ( ChannelRecord * cr ) { chanrec = cr; }
   inline UserEntry * FindEntry ( UserEntry * x) {
      return entries.Find(x);
   }
   inline UserEntry * GetEntry ( UserEntry * et ) {
      UserEntry * e = FindEntry(et);
      return e ? e : et ? et->Create(this) : 0;
   }
};
#endif
