/*
 * Assoc.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "Assoc.h"
#define CLASS "Assoc"

Assoc::Assoc ( int k, const char * n ) : 
IntList ( *ASS->assoc_list, k, APPEND | NODUPS ) {
   FUNCTION;
   Assoc * ptr = ASS->assoc_list;
   int l = strlen(n);
   
   context;
   while ((ptr != this) && (ptr = ptr->Next())) 
     if (ptr->Name() && !strcasecmp(ptr->Name(), n)) {
	DELETE (ptr);
	break;
     }
   context;
   if (l > ASS->assoc_size)
     l = ASS->assoc_size;
   context;
   name = (char *)my_malloc(l + 1, ASS->memtype_assoc);
   context;
   strncpyz(name, n, l);
   context;
}

Assoc::~Assoc ( void ) {
   FUNCTION;
   if (name)
     my_free(name, ASS->memtype_assoc);
}

int Assoc::ExpMem(void) {
   FUNCTION;
   int size = sizeof(Assoc);
   Assoc * ptr = this;
   
   context;
   while ((ptr = ptr->Next()))
     size += sizeof(Assoc) + strlen(ptr->name) + 1;
   return size;
}

Assoc * Assoc::Find ( const char * n ) {
   FUNCTION;
   Assoc * ptr = this;
   
   while ((ptr = ptr->Next()) && strcasecmp(ptr->Name(), n));
   return ptr;
}
