/*
 * ModuleEntryAssoc.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "Assoc.h"
#include "IntegerVariable.h"
#include "HelpReference.h"
#include "Socket.h"
#define CLASS "ModuleEntryAssoc"

static Version assoc_ver;
static struct patches assoc_patches[] = {
#include "patch.h"
};

ModuleEntryAssoc::ModuleEntryAssoc ( ModuleEntry * old, char ** r )
: ModuleEntry ( "assoc", assoc_ver.Set(2,0), assoc_patches, old ) {
   FUNCTION;
   Version required;
   
   ASS = this;
   if (!(BOTNET = (class ModuleEntryBotnet *)
	 Depend("botnet", required.Set(2,0))))
     *r = "You need the botnet module to use this module.";
   else {
      memtype_assoc = NEW ( MemType("assoc", (List **)&assoc_list,this));
      assoc_list = NEW ( Assoc ( this ) );
      assoc_size = 20;
      NEW ( IntegerVariable ( "assoc_length", &assoc_size, 0, this ) );
      NEW ( HelpReference ( "assoc.help",this ) );
   }
}

ModuleEntryAssoc::~ModuleEntryAssoc ( void ) {
   FUNCTION;
   DELETE ( assoc_list );
}

int ModuleEntryAssoc::ExpMem ( void ) {
   FUNCTION;
   return sizeof(ModuleEntryAssoc) + ModuleEntry::ExpMem ();
}

void ModuleEntryAssoc::Report (Socket * idx, int details) {
   FUNCTION;
   context;
   if (details) 
     idx->Send(Lang(0x010,"dd", ASS->assoc_list->Count(),
		    ASS->assoc_list->ExpMem()));
}
