/*
 * assoc.c - the assoc module, moved here mainly from botnet.c for module
 * work
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#define MAKING_ASSOC
#include "Socket.h"
#include "BindTable.h"
#include "UserRecord.h"
#include "Version.h"
#include "ModuleEntryAssoc.h"
#include "ModuleEntryBotnet.h"
#include "TandemBot.h"
#include "Bot.h"
#include "DccChat.h"
#include "ScriptContext.h"
#include "ScriptArgument.h"
#include "Command.h"
#include "Assoc.h"
#include <stdlib.h>
#define CLASS ""

static ModuleEntryEggdrop * G;
ModuleEntryAssoc * ASS;

static void send_assoc (Socket * idx, int chan, const char * nick, 
			const char * buf) {
   FUNCTION;
   char assoc_work[512];
   Bot * idx2 = (Bot *)G->socklist;
   FlagRecord bfl ( FlagRecord::BOT );
   
   G->SPrintF(assoc_work, 511, "assoc %D %s %s", chan,
	      nick ? nick : G->botnetnick, buf);
   while ((idx2 = idx2->Next()))
     if ((idx2->TypeFlags() & DCT_REALBOT) && (idx2 != idx)
	 && (idx2->Numver() >= NEAT_BOTNET) && idx2->User())
       if (!bfl.Set(idx2->User())->BotIsolate())
	 idx2->SendZapf(G->botnetnick, idx2->Nick(), assoc_work);
}

static BindReturn link_assoc (void ** args, const char *) {
   FUNCTION;
   char * bot = (char *)args[0], * via = (char *)args[1];
   TandemBot * tb = ASS->BOTNET->tandbot->Find(bot);
   Bot * idx = tb ? tb->NextBot() : 0;
   Assoc * a = ASS->assoc_list;
   char assoc_work[512];
   FlagRecord bfl ( FlagRecord::BOT );
   
   if (!strcasecmp(via,G->botnetnick) && idx->User() &&
       !bfl.Set(idx->User())->BotIsolate())
     while ((a = a->Next())) 
       if (a->Key() < GLOBAL_CHANS) {
	  G->SPrintF(assoc_work, 511, "assoc %D %s %s", a->Key(),
		     G->botnetnick, a->Name());
	  idx->SendZapf(G->botnetnick, idx->Nick(), assoc_work);
       }
   return EXECUTED;
}

static BindReturn kill_all_assoc(void **, const char *) {
   FUNCTION;
   DELETE ( ASS->assoc_list );
   ASS->assoc_list = NEW ( Assoc () );
   return EXECUTED;
}

static BindReturn cmd_assoc (void ** args, const char *) {
   FUNCTION;
   char * num, *par = (char *)args[1];
   int chan;
   Socket * idx = (Socket *)args[0];
   Assoc * a = ASS->assoc_list;
   
   context;
   if (!par[0]) {
      G->LOG_CMDS.Put(ASS->Lang(0x001, "s", idx->Nick()));
      if (!a->Next()) 
	idx->Send(ASS->Lang(0x002, 0));
      else {
	 idx->Send(ASS->Lang(0x003, 0));
	 while ((a = a->Next()))
	   idx->Send(ASS->Lang(0x004, "c5s", (a->Key() < GLOBAL_CHANS) 
				? ' ' : '*',a->Key() % GLOBAL_CHANS,a->Name()));
	 idx->Send(ASS->Lang(0x005, 0));
      }
   } else {
      num = G->Split(&par);
      if (num[0] == '*') {
	 chan = GLOBAL_CHANS + atoi(num + 1);
	 if ((chan < GLOBAL_CHANS) || (chan >= (2 * GLOBAL_CHANS))) {
	    idx->Send(ASS->Lang(0x006, "d", GLOBAL_CHANS - 1));
	    return EXECUTED;
	 }
      } else {
	 if (!(chan = atoi(num))) {
	    idx->Send(ASS->Lang(0x007, 0));
	    return EXECUTED;
	 } else if ((chan < 1) || (chan >= GLOBAL_CHANS)) {
	    idx->Send(ASS->Lang(0x008, "d", GLOBAL_CHANS - 1));
	    return EXECUTED;
	 }
      }
      if (!par[0]) {
	 /* remove an association */
	 if (!(a = a->Find(chan)))
	   idx->Send(ASS->Lang(0x009, "sd",(chan < GLOBAL_CHANS) ? "" : "*",
			       chan % GLOBAL_CHANS));
	 else {
	    DELETE (a);
	    G->LOG_CMDS.Put(ASS->Lang(0x00A, "sd",idx->Nick(), chan));
	    idx->Send(ASS->Lang(0x00B, "sd",(chan < GLOBAL_CHANS) 
				? "" : "*", chan % GLOBAL_CHANS));
	    DccChat::Chanout(chan, ASS->Lang(0x01F, "s", idx->Nick()));
	    if (chan < GLOBAL_CHANS) 
	      send_assoc(0, chan, idx->Nick(), "0");
	 }
      } else if ((int)strlen(par) > ASS->assoc_size)
	   idx->Send(ASS->Lang(0x00C, "d", ASS->assoc_size));
      else if ((par[0] >= '0') && (par[0] <= '9')) 
	idx->Send(ASS->Lang(0x00D, 0));
      else {
	 a = NEW ( Assoc ( chan, par ) );
	 G->LOG_CMDS.Put(ASS->Lang(0x00E, "sds", idx->Nick(), chan, a->Name()));
	 idx->Send(ASS->Lang(0x00F, "sds",(chan < GLOBAL_CHANS) ? "" : "*", 
			  chan % GLOBAL_CHANS, a->Name()));
	 DccChat::Chanout(chan, ASS->Lang(0x01E, "ss", idx->Nick(), a->Name()));
	 if (chan < GLOBAL_CHANS) 
	   send_assoc(0, chan , idx->Nick(), a->Name());
      }
   }
   return EXECUTED;
}

static int script_killassoc (ScriptContext * sc, int argc, ScriptArgument ** argv) {
   FUNCTION;
   int chan;
   Assoc * a;
   
   context;
   BADARGS(2, 2, " chan");
   chan = argv[1]->AsInteger();
   if ((chan < 1) || (chan > (2 * GLOBAL_CHANS))) {
      sc->SetString("invalid channel #");
      return SCRIPT_ERROR;
   }
   if ((a = ASS->assoc_list->Find(chan))) {
      DELETE ( a );
      DccChat::Chanout(chan, ASS->Lang(0x01F, "s", "*script*"));
      send_assoc(0, chan, "*script*", "0");
   }
   return SCRIPT_OK;
}

static int script_assoc (ScriptContext * sc, int argc, ScriptArgument ** argv) {
   FUNCTION;
   Assoc * a;
   const char * ch = argv[1]->AsString();
   
   context;
   BADARGS(2, 3, " chan ?name?");
   if ((argc == 2) && ((ch[0] < '0') || (ch[0] > '9'))) {
      a = ASS->assoc_list->Find(ch);
      sc->SetString((a->Key() == -1) ? "" : G->ToBase10(a->Key()));
   } else {
      int chan = argv[1]->AsInteger();
      
      if ((chan < 1) || (chan > (2 * GLOBAL_CHANS))) {
	 sc->SetString("invalid channel #");
	 return SCRIPT_ERROR;
      }
      if (argc == 3) {
	 a = NEW ( Assoc ( chan, argv[2]->AsString() ) );
	 send_assoc(0, chan, "*script*", a->Name());
	 DccChat::Chanout(chan,ASS->Lang(0x01E,"ss","*script*", a->Name()));
      } else
	a = ASS->assoc_list->Find(chan);
      sc->SetString(a ? a->Name() : "");
   }
   return SCRIPT_OK;
}

static BindReturn zapf_assoc (void ** args, const char *) {
   FUNCTION;
   char * s, *nick, *botnick = (char *)args[0], tmp[512], *par = tmp;
   TandemBot * tb = ASS->BOTNET->tandbot->Find(botnick);
   Bot * idx = tb ? tb->NextBot() : 0;
   int linking = 0, chan;
   FlagRecord bfl ( FlagRecord::BOT );
   Assoc * a;
   
   context;
   if (idx && !bfl.Set(idx->User())->BotIsolate()) {
      strncpyz(par, (char *)args[1], 511);
      if (!strcasecmp(idx->Nick(), botnick))
	linking = idx->HasStatus(Bot::LINKING);
      s = G->Split(&par);
      chan = G->Base64To(s);
      if ((chan > 0) && (chan < GLOBAL_CHANS)) {
	 nick = G->Split(&par);
	 a = ASS->assoc_list->Find(chan);
	 if (par[0] == '0') {
	    if (a) {
	       DELETE ( a );
	       DccChat::Chanout(chan,ASS->Lang(0x1D,"ss",botnick,nick));
	    }
	 } else if ((linking && (!a || bfl.BotHub()))
		    || (ASS->assoc_list->Find(par) != a)) {
	    a = NEW ( Assoc ( chan, par ) );
	    DccChat::Chanout(chan,ASS->Lang(0x1C,"sss",botnick,nick,a->Name()));
	    if (linking) 
	      send_assoc(idx, chan, nick, a->Name());
	 }
      }
   }
   return (BindReturn)0;
}

static command_binds mydcc[] = {
   {"assoc", "", cmd_assoc, 0},
};

static command_binds mybot[] = {
   {"assoc", "", zapf_assoc, 0},
};

static command_binds mylink[] = {
   { "*", "", link_assoc, "assoc"},
};

static command_binds mydisc[] = {
   {"!", "", kill_all_assoc, 0},
};

static BindReturn get_name (void ** args, const char *) {
   FUNCTION;
   Assoc * a;
   
   if (*(int *)args[0] > 0) {
      if ((a = ASS->assoc_list->Find(*(int *)args[0])))
	strncpyz((char *)args[1], a->Name(), *(int *)args[2]);
      else
	return EXECUTED;
   } else if ((a = ASS->assoc_list->Find((char *)args[1]))) 
	*((int *)args[0]) = a->Key();
   else
     return EXECUTED;
   return EXEC_LOG;
}

static command_binds myname[] = {
   { "*", "", get_name, 0},
};

extern "C" {
   char *assoc_start (ModuleEntryEggdrop *, ModuleEntry *);
};

char * assoc_start (ModuleEntryEggdrop * global_funcs, ModuleEntry * me) {
   FUNCTION;
   char * r = 0;
   
   G = global_funcs;
   context;
   ASS = NEW ( ModuleEntryAssoc ( me, &r ) );
   if (!r) {
      G->bt_dcc->AddBinds(mydcc, 1, ASS);
      ASS->BOTNET->bt_bot->AddBinds(mybot, 1, ASS);
      ASS->BOTNET->bt_link->AddBinds(mylink, 1, ASS);
      ASS->BOTNET->bt_disc->AddBinds(mydisc, 1, ASS);
      G->bt_name->AddBinds(myname, 1, ASS);
      NEW ( Command ( "assoc", script_assoc, ASS ) );
      NEW ( Command ( "killassoc", script_killassoc, ASS ) );
   }
   return r;
}    
