/*
 * BlowfishBox.h
 */

#ifndef _KEYEDLIST_
#include "KeyedList.h"
#endif

#ifndef _BLOWFISHBOX_
#define _BLOWFISHBOX_

#define bf_N             16

union aword {
  UWORD_32bits word;
  UBYTE_08bits byte [4];
#ifdef WORDS_BIGENDIAN
  struct {
    unsigned int byte0:8;
    unsigned int byte1:8;
    unsigned int byte2:8;
    unsigned int byte3:8;
  } w;
#else
  struct {
    unsigned int byte3:8;
    unsigned int byte2:8;
    unsigned int byte1:8;
    unsigned int byte0:8;
  } w;
#endif  /* WORDS_BIGENDIAN */
};

class BlowfishBox : public KeyedList<MISCLEN> {
  protected:
   UWORD_32bits P[bf_N + 2];
   UWORD_32bits S[4][256];
   char keybytes;
   time_t lastuse;
   
   friend class ModuleEntryBlowfish;
  public:
   static int Boxes (void);
   inline BlowfishBox ( void ) : KeyedList<MISCLEN> () {}
   BlowfishBox (const char *, ModuleEntry * m = 0);
   ~BlowfishBox ( void );
   int ExpMem ( void );
   void * operator new ( size_t, int );
   void operator delete ( void * );
   void Encipher (UWORD_32bits *, UWORD_32bits *);
   void Decipher (UWORD_32bits *, UWORD_32bits *);
   void Init ( void );
   inline BlowfishBox * Find (const char * x) {
      return (BlowfishBox *)KeyedList<MISCLEN>::Find(x);
   }
   inline BlowfishBox * Next ( void ) { return (BlowfishBox *)next; }
};
#endif
