/*
 * BotService.C
 */
/*
 * This file is part of the eggdrop 2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "BotService.h"
#include "TandemBot.h"
#include "JupeList.h"
#define CLASS "BotService"

BotService::BotService ( BotLink & bl, char * x) 
: Bot (bl,  x, "BOT SERVICE", Bot::SERVICE ) {
   FUNCTION;
   SetType("BOTSERVICE");
}

BotService::~BotService ( void ) {
   FUNCTION;
}

void BotService::SendMotd (const char * from, const char *) {
   FUNCTION;
   Bot * ptr;
   char * p = strchr(from, '@');
   TandemBot * tb = BS->BOTNET->tandbot->Find(p ? p + 1 : from);
   
   if ((ptr = tb->NextBot())) {
      ptr->SendPriv(BS->service_name, from, "BOTNET SERVICES MOTD:");
      ptr->SendPriv(BS->service_name, from, 
		    "This services module provides various botnet services.");
      ptr->SendPriv(BS->service_name, from, "Look forward to future developments");
      ptr->SendPriv(BS->service_name, from, "END of MOTD:");
   }
}

void BotService::SendReject (const char * from, const char *, const char *) {
   FUNCTION;
   char * p = strchr(from, '@');
   TandemBot * tb = BS->BOTNET->tandbot->Find(p ? p + 1 : from);
   Bot * ptr;
   
   if ((ptr = tb->NextBot())) 
     ptr->SendPriv(BS->service_name, from, "Sorry, you can't reject service bots.");
}

void BotService::SendTrace (const char *, const char * from, const char * buf) {
   FUNCTION;
   char * p = strchr(from, '@');
   TandemBot * tb = BS->BOTNET->tandbot->Find(p ? p + 1 : from);
   Bot * ptr;
   
   if ((ptr = tb->NextBot())) 
     ptr->SendTraced(from, buf);
}

void BotService::SendWho (const char * from, const char * p, int ok) {
   FUNCTION;
   char buf[512],buf2[13];
   TandemBot * t = BS->BOTNET->tandbot, * tb;
   JupeList * jp;
   time_t age;
   Bot * ptr = 0;
   
   ok = 0;
   if ((p = strchr(from, '@'))) {
      p++;
      if ((tb = BS->BOTNET->tandbot->Find(p)) && (ptr = tb->NextBot())) {
	 G->SPrintF(buf, 511, "Botnet service module, version: %s", 
		    BS->VersionStr());
	 ptr->SendPriv( BS->service_name, from, buf);
	 while ((t = t->Next()))
	   if (!strcasecmp(t->UplinkName(), BS->service_name)) {
	      if (!ok) {
		 ptr->SendPriv( BS->service_name, from, "Juped Bots connected:");
		 ok = 1;
	      }
	      if ((jp = BS->jupe_list->Match(t->Name()))) {
		 if ((age = jp->Age())) {
		    strncpy(buf2, ctime(&age) + 4, 12);
		    buf2[12] = 0;
		    G->SPrintF(buf, 511, "   %s%   %s% : %s (expires %s)",
			       t->Name(), HANDLEN - strlen(t->Name()), jp->Who(),
			       HANDLEN - strlen(jp->Who()), jp->Reason(),buf2);
		 } else
		   G->SPrintF(buf, 511, "   %s%   %s% : %s (PERMANENT)", 
			      t->Name(), HANDLEN - strlen(t->Name()), jp->Who(),
			      HANDLEN - strlen(jp->Who()), jp->Reason());
	      } else
		G->SPrintF(buf, 511, "   %s  (manually entered)", t->Name(),
			   HANDLEN- strlen(t->Name()));
	      ptr->SendPriv( BS->service_name, from, buf);
	   }
      }
   }
}

void BotService::SendPing (void) {
   FUNCTION;
   ProcessPong("");
}

void BotService::SendPong (void) {
   FUNCTION;
}

void BotService::SendUnLink (const char * who, TandemBot * tb, const char * p) {
   FUNCTION;
   p = strchr(who, '@');
   tb = BS->BOTNET->tandbot->Find(p ? p + 1 : who);
   Bot * ptr;
   
   if ((ptr = tb->NextBot())) 
     ptr->SendPriv(BS->service_name, who, "Sorry, you can't unlink service bots.");
}   

void BotService::SendLink (const char *, const char *, const char *) {
   FUNCTION;
}

void BotService::SendTraced (const char *, const char *) {
   FUNCTION;
}
			 
void BotService::SendZapf (const char * a, const char *, const char * c) {
   FUNCTION;
   char buf[512];
   
   if (BS->warn_flud && !strncasecmp(c, "flud", 4)) {
      switch (BS->warn_flud) {
	case 1:
	 G->SPrintF(buf, 511, "FLUDNET BOT DETECTED : %s", a);
	 SendChat(BS->service_name, buf); 
	 BS->BOTNET->ChatOut(buf);
	 break;
	case 2:
	 NEW ( JupeList ( a, "FLUDNT BOT", G->botnetnick, 
			 BS->autojupe_time * 60));
	 BS->CheckJupes();
	 break;
      }
   }
}

void BotService::SendFakeAlert (const char *, const char *) {
   FUNCTION;
}

/* dump list of links to a new bot */
void BotService::SendLinkInfo (void) {
   FUNCTION;
   context;
   BS->CheckJupes();
}

void BotService::SendPriv (const char *, const char *, const char *) {
   FUNCTION;
}

void BotService::SendBye2 ( const char * ) {
   FUNCTION;
}
