/*
 * JupeList.C
 */
/*
 * This file is part of the eggdrop 2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "JupeList.h"
#include "Reconnections.h"
#define CLASS "JupeList"

JupeList::JupeList ( const char * mask, const char * reasonin,
		    const char * whoin, int agein )
: KeyedList<HANDLEN> (*BS->jupe_list, mask, KeyedList<HANDLEN>::APPEND |
		      KeyedList<HANDLEN>::NODUPS) {
   FUNCTION;
   reason = (char *)my_malloc(strlen(reasonin) + 1, BS->memtype_botservice);
   strcpy(reason, reasonin);
   strncpy(who, whoin, HANDLEN);
   who[HANDLEN] = 0;
   age = agein ? G->now + agein : 0;
}

JupeList::~JupeList ( void ) {
   FUNCTION;
   if (reason)
     my_free(reason, BS->memtype_botservice);
}
 
int JupeList::ExpMem ( void ) {
   FUNCTION;
   int tot = BS->recons->ExpMem() + sizeof(JupeList);
   JupeList * ptr = this;
   
   while ((ptr = ptr->Next())) 
     tot += sizeof(JupeList) + (ptr->reason ? (strlen(ptr->reason) + 1) : 0);
   return tot;
}
