/*
 * JupeList.h
 */

#ifndef _KEYEDLIST_
#include "KeyedList.h"
#endif

#ifndef _MODULEENTRYBOTSERVICE_
#include "ModuleEntryBotservice.h"
#endif

#ifndef _JUPELIST_
#define _JUPELIST_

class JupeList : public KeyedList<HANDLEN> {
  protected:
   char * reason;
   char who[HANDLEN + 1];
   time_t age;
   
  public:
   inline JupeList (void) : KeyedList<HANDLEN> () {
      reason = 0;
      who[0] = 0;
      age = 0;
   }
   JupeList (const char *, const char *, const char *, int);
   ~JupeList ( void );  
   
   inline JupeList * Match ( const char * which ) {
      return (JupeList *)KeyedList<HANDLEN>::Match (which);
   }
   inline const char * Reason ( void ) { return reason; }
   inline const char * Who ( void ) { return who; }
   inline time_t Age ( void ) { return age; }
   inline const char * Mask ( void ) { return key; }
   inline JupeList * Next ( void ) { return (JupeList *)next; }
   MEMORY_TYPE(BS->memtype_botservice);
   int ExpMem (void);
};
#endif
