/*
 * Reconnections.C
 */
/*
 * This file is part of the eggdrop 2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "Reconnections.h"
#include "JupeList.h"
#define CLASS "Reconnections"

int Reconnections::ExpMem ( void ) {
   FUNCTION;
   int tot = sizeof(Reconnections);
   Reconnections * ptr = this;
   
   while ((ptr = ptr->Next()))
     tot += sizeof(Reconnections);
   return tot;
}

Reconnections::~Reconnections ( void ) {
   FUNCTION;
   BS->logger.Put ( 0, "RECON: %s is being removed", key);
   BS->recons->Remove(this);
}

void Reconnections::Again ( void ) {
   FUNCTION;
   count++;
   BS->logger.Put ( 0, "RECON: %s is being updated at %d to %d", key, G->now, count);
   if ((count > BS->recon_cnt) && ((G->now - age) < BS->recon_time)) {
      char x[512];
      BS->logger.Put ( 0, "RECON: %s is being jupped,  naughty bot", key);      
      G->SPrintF(x, 511, "Enough! %d reconnects in < %d secconds - Juping %s",
		 BS->recon_cnt, BS->recon_time, key);
      NEW( JupeList(key, x, BS->service_name, BS->autojupe_time * 60) );
      DELETE ( this );
   }
}
   
void Reconnections::Expires ( void ) {
   FUNCTION;
   Reconnections * ptr, * optr = this;
   
   while ((ptr = optr->Next())) {
      if ((G->now - ptr->age) > BS->recon_time) {
	 BS->logger.Put ( 0, "RECON: %s is being expired at %d", ptr->key, G->now);
	 DELETE (ptr);
      } else
	optr = ptr;
   }
}
