/*
 * Reconnections.h
 */

#ifndef _KEYEDLIST_
#include "KeyedList.h"
#endif

#ifndef _MODULEENTRYBOTSERVICE_
#include "ModuleEntryBotservice.h"
#endif

#ifndef _RECONNECTIONS_
#define _RECONNECTIONS_
class Reconnections : public KeyedList<HANDLEN> {
  protected:
   int count;
   time_t age;
  public:
   inline Reconnections ( void ) : KeyedList<HANDLEN> ( ) {}
   inline Reconnections ( const char * name ) 
     : KeyedList<HANDLEN> ( *BS->recons, name, KeyedList<HANDLEN>::NODUPS ) {
	BS->logger.Put ( 0, "RECON: %s is being added at %d", key, G->now);
	age = G->now;
	count = 1;
     }
   ~Reconnections ( void );
   
   void Again ( void );
   DEF_NEXT(Reconnections);
   MEMORY_TYPE(BS->memtype_botservice);
   inline Reconnections * Find ( const char * name ) {
      return (Reconnections *)KeyedList<HANDLEN>::Find ( name );
   }
   void Expires ( void );
   int ExpMem ( void );
};
#endif
