/*
 * botservice.c - a botnet module to provide various botnet services
 */
/*
 * This file is part of the eggdrop 2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */
/*
 * TODO:
 *    add some method of expempting a bot/mask from juping
 *    add a way of reprenting *other* botservice bots
 *    save jupes
 */

#include "botnet.h"
#include "Bot.h"
#include "BotLink.h"
#include "UserRecord.h"
#include "BindTable.h"
#include "HookList.h"
#include "TandemBot.h"
#include "ModuleEntryBotservice.h"
#include "ScriptContext.h"
#include "ScriptArgument.h"
#include "Reconnections.h"
#include "JupeList.h"
#include "Command.h"
#include "BotService.h"
#define CLASS ""

#define SERVICE_VERSION 2000000

static ModuleEntryEggdrop * G;
ModuleEntryBotservice * BS;

static void infoq_service (Bot * sock, char * par) {
   FUNCTION;
   char buf[512], buf2[13];
   TandemBot * t = BS->BOTNET->tandbot;
   JupeList * jp;
   time_t age;
   
   if (sock) {
      G->SPrintF(buf, 511, "%s - Botnet service module", BS->VersionStr());
      sock->SendPriv(BS->service_name, par, buf);
      while ((t = t->Next())) 
	if (!strcasecmp(t->UplinkName(), BS->service_name)) {
	   if ((jp = BS->jupe_list->Match(t->Name()))) {
	      if ((age = jp->Age())) {
		 strncpy(buf2, ctime(&age) + 4, 12);
		 buf2[12] = 0;
		 G->SPrintF(buf, 511, "Juped bot: (by %s: %s) (expires %s)", 
			    jp->Who(), jp->Reason(), buf2);
	      } else
		G->SPrintF(buf, 511, "Juped bot: (by %s: %s) (PERMANENT)", 
			   jp->Who(), jp->Reason());
	   } else
	     G->SPrintF(buf, 511, "Juped bot: (manually entered)");
	   sock->SendPriv(t->Name(), par, buf);
	}
   }
}

static void chatter_service (Bot *, char *, int,  char *) {
   FUNCTION;
}

static void chan_service (Bot *, PartyLiner *, char *) {
   FUNCTION;
}

static void chat_service (Bot *, char * botnick, char * data) {
   FUNCTION;
   BS->BOTNET->LOG_BOTS.Put(0, "DCCBROADCAST: [%s] %s", botnick, data);
}

static void act_service  (Bot *, PartyLiner *, char *) {
   FUNCTION;
}

static void unlinked_service (Bot *, TandemBot *, const char *) {
   FUNCTION;
}   

static void nlinked_service (Bot * sock, const char * bot, const char * next,
			     char flag, int vernum, const char *) {
   FUNCTION;
   BS->CheckJupe(sock, bot, next, flag, vernum);
}

static void zapf_broad_service (Bot *, char *, char *, char *) {
   FUNCTION;
}

static void nkch_service (Bot *, PartyLiner *, char *) {
   FUNCTION;
}

static void idle_service (Bot *, char *, int, int, char *) {
   FUNCTION;
}
   
static void away_service (Bot *, PartyLiner *, int) {			 
   FUNCTION;
}

static void join_service (Bot *, int, PartyLiner *, int) {
   FUNCTION;
}
   
static void part_service (Bot *, PartyLiner *,char *, int) {
   FUNCTION;
}

static void update_service (Bot *, TandemBot *) {
   FUNCTION;
}

static void rembot_service (TandemBot *) {
   FUNCTION;
}

static void bye_service (const char *) {
   FUNCTION;
}
   
static void crosslink_service (TandemBot *, TandemBot *) {
   FUNCTION;
}

static void uncrosslink_service (TandemBot *, TandemBot *) {
   FUNCTION;
}

static struct massbot_call_funcs my_massbots = {
   0,
     infoq_service,
     chan_service,
     chatter_service,
     chat_service,
     act_service,
     unlinked_service,
     nlinked_service,
     zapf_broad_service,
     nkch_service,
     idle_service,
     away_service,
     join_service,
     part_service,
     update_service,
     rembot_service,
     bye_service,
     crosslink_service,
     uncrosslink_service,
};
   
static BindReturn cmd_jupebot (void ** args, const char *) {
   FUNCTION;
   Socket * idx = (Socket *)args[0];
   char * bot = G->Split((char **)&args[1]);
   
   if (BS->BOTNET->tandbot->Find(bot))
     idx->Printf("Bot is currently online, can't jupe\n");
   else  {
      G->LOG_CMDS.Put(0, "#%s# jupebot %s", idx->Nick(), bot);
      BS->service_socket->ProcessNLinked(bot, BS->service_name, '!',
					 SERVICE_VERSION, Bot::JUPE);
   }
   return EXECUTED;
}

static BindReturn cmd_unjupebot (void ** args, const char *) {
   FUNCTION;
   char buf[512];
   Socket * idx = (Socket *)args[0];
   TandemBot * tb;
   
   if (!(tb = BS->BOTNET->tandbot->Find((char *)args[1])) ||
       (tb->NextBot() != BS->service_socket)) 
     idx->Printf("Bot is not currently online as a service bot\n");
   else {
      BS->no_respawn = 1;
      BS->jupe_list->Remove((char *)args[1]);
      G->LOG_CMDS.Put(0, "#%s# unjupebot %s", idx->Nick(), args[1]);
      G->SPrintF(buf, 511, "Disconnected %s (jupe removed)", args[1]);
      BS->service_socket->ProcessUnLinked(tb, buf);
      BS->no_respawn = 0;
   }
   return EXECUTED;
}

static BindReturn cmd_pls_jupe (void ** args, const char * mask) {
   FUNCTION;
   Socket * idx = (Socket *)args[0];
   char * par = (char *)args[1];
   void * i;
   
   mask = G->Split(&par);
   if (!par[0]) 
     idx->Printf("Usgae:  +jupe <botmask> <reason>\n");
   else {
      i = NEW( JupeList(mask, par, idx->Nick(), 0) );
      G->LOG_CMDS.Put(0, "#%s# +jupe %s %s", idx->Nick(), mask, par);
      BS->CheckJupes();
   }
   return EXECUTED;
}

static BindReturn cmd_mns_jupe (void ** args, const char *) {
   FUNCTION;
   Socket * idx = (Socket *)args[0];
   char * par = (char *)args[1], buf[512];
   TandemBot * t;
   
   BS->no_respawn = 1;
   if (!par[0]) 
     idx->Printf("Usage:  -jupe <botmask>\n");
   else if (BS->jupe_list->Remove(par)) {
      G->LOG_CMDS.Put(0, "#%s# -jupe %s", idx->Nick(), par);
      t = BS->BOTNET->tandbot;
      while ((t = t->Next()))
	if (G->WildMatch(par, t->Name()) && t->Uplink() &&
	    !strcasecmp(t->UplinkName(),BS->service_name)) {
	   G->SPrintF(buf, 511, "Disconnected %s (jupe removed)", par);
	   BS->service_socket->ProcessUnLinked(t, buf);	   
	}
   } else
     idx->Printf("Failed.\n");
   BS->no_respawn = 0;
   return EXECUTED;
}

static BindReturn cmd_jupes (void ** args, const char *) {
   FUNCTION;
   Socket * idx = (Socket *)args[0];
   JupeList * jp;
   TandemBot * t;
   time_t age;
   char buf2[22];
   
   if (!BS->jupe_list) 
     idx->Printf("No jupes exist!\n");
   else {
      idx->Printf("Jupe list: (* = active)\n");
      idx->Printf("  BY WHO    MASK      REASON\n");
      for (jp = BS->jupe_list->Next(); jp; jp = jp->Next()) {
	 t = BS->BOTNET->tandbot;
	 while ((t = t->Next()))
	   if (G->WildMatch(jp->Mask(), t->Name()) && t->Uplink() &&
	       !strcasecmp(t->UplinkName(),BS->service_name)) 
	     break;
	 if ((age = jp->Age())) 
	   G->SPrintF(buf2, 21, "(Expires %s", ctime(&age) + 4);
	 else 
	   strcpy(buf2, "(PERMANENT");
	 idx->Printf("%c %-9s %-9s %s %s)\n", t ? '*' : ' ', jp->Who(),
		     jp->Mask(), jp->Reason(), buf2);
      }
      idx->Printf("End of Jupe list\n");
   }
   return EXECUTED;
}    
   
static command_binds my_dccs[] = {
   { "jupebot", "S", cmd_jupebot, NULL},
   { "unjupebot", "S", cmd_unjupebot, NULL},
   { "+jupe", "S", cmd_pls_jupe, NULL},
   { "-jupe", "S", cmd_mns_jupe, NULL},
   { "jupes", "S", cmd_jupes, NULL},
};

static int script_jupebot (ScriptContext * sc, int argc, ScriptArgument ** argv) {
   FUNCTION;
   BADARGS(2, 2, "botname");
   if (BS->BOTNET->tandbot->Find(argv[1]->AsString())) {
      sc->SetString("Bot is currently online, can't jupe");
      return SCRIPT_ERROR;
   }
   BS->service_socket->ProcessNLinked(argv[1]->AsString(), BS->service_name,
				      '!', SERVICE_VERSION, Bot::JUPE);
   return SCRIPT_OK;
}

static int script_unjupebot (ScriptContext * sc, int argc, ScriptArgument ** argv) {
   FUNCTION;
   char buf[512];
   TandemBot * tb;
   
   BADARGS(2, 2, "botname");
   if (!(tb = BS->BOTNET->tandbot->Find(argv[1]->AsString())) ||
       (tb->NextBot() != BS->service_socket)) {
      sc->SetString("Bot is not currently online as a service bot");
      return SCRIPT_ERROR;
   }
   G->SPrintF(buf, 511, "Disconnected %s (jupe removed)", argv[1]->AsString());
   BS->service_socket->ProcessUnLinked(tb, buf);
   return SCRIPT_OK;
}

static void jupe_minutely (void ) {
   FUNCTION;
   JupeList * jp, * jp2 = BS->jupe_list;
   char buf[512], buf2[30];
   TandemBot * t, * t2;
   
   if (!BS->linked) {
      BotLink * bl = NEW ( BotLink (Socket::NONSOCK, BNET->BOT_LINK, 0, "*", 0));
      
      if (!*BS->service_name) 
	G->Fatal("No Service Name!");
      bl->SetNumver(SERVICE_VERSION);
      bl->SetNick(BS->service_name);
      BS->service_socket = NEW ( BotService ( *bl, "BOTNET SERVICE MODULE") );
      BS->Vers()->AsString(buf2, 30);
      G->SPrintF(buf, 511, "BOTNET SERVICE MODULE v%s linked in as %s",
		 buf2, BS->service_name);
      BS->linked = 1;
   }
   BS->no_respawn = 1;
   BS->recons->Expires();
   while ((jp = jp2->Next())) {
      if (jp->Age() && (G->now > jp->Age())) {
	 BS->BOTNET->LOG_BOTS.Put(0, "Expiring jupe %s (%s: %s)", jp->Mask(),
				  jp->Who(), jp->Reason());
	 t2 = BS->BOTNET->tandbot;
	 while ((t = t2->Next()))
	   if (G->WildMatch(jp->Mask(), t->Name()) && t->Uplink() &&
	       !strcasecmp(t->UplinkName(),BS->service_name)) {
	      G->SPrintF(buf, 511, "Disconnected %s (jupe expired)", jp->Mask());
	      BS->service_socket->ProcessUnLinked(t, buf);
	   } else
	   t2 = t;
	 BS->jupe_list->Remove(jp);
	 DELETE(jp);
      } else
	jp2 = jp;
   }
   BS->no_respawn = 0;
}

static BindReturn disc_service ( void ** args, const char *) {
   FUNCTION;
   TandemBot * tb = (TandemBot *)args[0];
   JupeList * jp;
   char s[512];   
   BotLink * bl;
   
   if (tb && !BS->no_respawn) {
      if (!strcasecmp(tb->Name(), BS->service_name) && 
	  !(BS->service_socket->Flags() && Socket::LOST)) {
	 context;
	 bl = NEW ( BotLink (Socket::NONSOCK, BNET->BOT_LINK, 0, "*", 0));
	 bl->SetNumver(SERVICE_VERSION);
	 bl->SetNick(BS->service_name);
	 BS->service_socket = NEW ( BotService ( *bl, "BOTNET SERVICE MODULE") );
	 BS->service_socket->SendChat(BS->service_name, 
				      "BOTNET SERVICE MODULE RECONNECTED");
	 BS->BOTNET->ChatOut("BOTNET SERVICE MODULE RECONNECTED");
      } else if ((jp = (JupeList *)BS->jupe_list->Find(tb->Name()))) {
	 G->SPrintF(s, 511, "Jupeing bot %s, request by %s: %s",
		    tb->Name(), jp->Who(), jp->Reason());
	 BS->service_socket->SendChat(BS->service_name, s);
	 BS->service_socket->ProcessNLinked(tb->Name(),BS->service_name,
					    '!', SERVICE_VERSION, Bot::JUPE);
      }
   }
   return EXECUTED;
}

static command_binds my_disc [] = {
   { "*", "", disc_service, "botservice"}
};

static BindReturn die_saver( void **, const char *) {
   FUNCTION;
   BS->no_respawn = 1;
   return EXECUTED;
}

static command_binds my_die [] = {
   { "*", "", die_saver, "botservice"}
};

extern "C" {
   char * botservice_start (ModuleEntryEggdrop *, ModuleEntry *);
};

char * botservice_start (ModuleEntryEggdrop * funcs, ModuleEntry * me) {
   FUNCTION;
   char * r = 0;
   
   G = funcs;
   context;
   BS = NEW ( ModuleEntryBotservice ( me, & r ) );
   if (!r) {
      BS->BOTNET->AddMassbotFuncs(&my_massbots);
      BS->massbots = &my_massbots;
      BS->BOTNET->bt_disc->AddBinds(my_disc, 1, BS);
      G->bt_die->AddBinds(my_die, 1, BS);
      G->bt_dcc->AddBinds(my_dccs, 5, BS);
      G->hook_minutely->Add(jupe_minutely, BS);
      context;
      NEW ( Command ( "jupebot", script_jupebot, BS ) );
      NEW ( Command ( "unjupebot", script_unjupebot, BS ) );
      context;
   }
   return r;
}
