/*
 * Channel2.h - class extras relevant to the channels module
 */

#ifndef _CHANNEL_
#include "Channel.h"
#endif

#ifndef _CHANNELSETTINGS_
#include "ChannelSettings.h"
#endif

#ifndef _CHANNEL2_
#define _CHANNEL2_

class Channel2 : public Channel {
  protected:
   ChannelSettings settings;
   
   Channel2 ( const char * );
   friend ChannelSettings;
   friend ModuleEntryChannels;
  public:
   enum { STATIC = 0x10, FLAGGED = 0x20, };

   Channel2 ( void );
   Channel2 ( Channel2 & );
   ~Channel2 ( void );
   
   virtual Channel2 * NewChannel ( const char * );
   virtual int DelBan ( char *, int );
   virtual int AddBan ( const char *, const char * , char *, time_t, int );
   virtual int SetStickyBan ( char *, int );

   int ExpMem ( void );
   
   int EqualsBan ( const char * );
   int MatchBan ( const char * );
   int Write ( FILE * );
   int Add ( ScriptContext *, const char *, int, ScriptArgument **);
   int Modify ( ScriptContext *, int, ScriptArgument ** );
   ChannelSettings * FindSettings ( ChannelSettings * );
   inline ChannelSettings * Settings ( void ) {
      return &settings;
   }
   
   inline Channel2 * Next ( void ) { return (Channel2 *)next; }
   
   inline int AddStatus ( int x ) { return status |= x; }
   inline int RemStatus ( int x ) { return status &= ~x; }
   inline int Status ( void ) { return status; }
   
   inline int Static ( void ) { return status & STATIC; }
   inline int Flagged ( void ) { return status & FLAGGED; }
   
   inline void SetStatic ( void ) { status |= STATIC; }
   inline void SetFlagged ( void ) { status |= FLAGGED; }
   
   inline void UnsetStatic ( void ) { status &= ~STATIC; }
   inline void UnsetFlagged ( void ) { status &= ~FLAGGED; }
};

inline Channel2 * FindChan ( const char * x ) {
   return (Channel2 *)List::G->chanset->Find(x);
}
#endif
