/*
 * ChannelSettings.C
 */
/*
 * This file is part of the eggdrop 2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "Channel2.h"
#define CLASS "ChannelSettings"

ChannelSettings::ChannelSettings ( void ) : List () {
   FUNCTION;
   type = 0;
   chan = 0;
}
   
ChannelSettings::ChannelSettings ( ModuleEntry * m )
: List ( ((Channel2 *)G->chanset)->settings, List::APPEND, m ) {
   FUNCTION;
   
   chan = (Channel2 *)G->chanset;
   type = 0;
}

ChannelSettings::ChannelSettings ( Channel2 * c, ChannelSettings * s )
: List ( c->settings, List::APPEND ) {
   FUNCTION;
   chan = c;
   type = s;
}

ChannelSettings::~ChannelSettings ( void ) {
   FUNCTION;
   Channel2 * ptr = (Channel2 *)G->chanset;
   ChannelSettings * csptr;
   
   if (chan && !type) {
      ptr->Settings()->Remove(this);
      while ((ptr = ptr->Next())) 
	if ((csptr = ptr->FindSettings(this))) {
	   ptr->Settings()->Remove(csptr);
	   DELETE (csptr);
	}
   }
}

int ChannelSettings::ExpMem ( void ) {
   FUNCTION;
   int tot = 0;
   Channel2 *chan;
   ChannelSettings * chansets;
   
   if (!type) 
     for (chan = (Channel2 *)G->chanset; chan; chan = chan->Next()) {
	chansets = chan->Settings();
	while ((chansets = chansets->Next()))
	  tot += chansets->ExpMem ( );
     }
   return tot;
};

int ChannelSettings::Set (const char *, const char *, Socket *) {
   FUNCTION;
   return 0;
}

void ChannelSettings::View (Socket *) {
   FUNCTION;
}

int ChannelSettings::Write (FILE *) {
   FUNCTION;
   return 1;
}

int ChannelSettings::Get (ScriptContext *) {
   FUNCTION;
   return SCRIPT_ERROR;
}

void ChannelSettings::Create ( Channel2 * ) {
   FUNCTION;
}
