#include "Client.h"
#include "ClientLogin.h"
#include "Bot.h"
#include "PartyLiner.h"
#include "TandemBot.h"
#include "FlagRecord.h"
#include "BindTable.h"
#include "PartyLiner.h"
#define CLASS "Client"

Client::Client ( ClientLogin & other) : DccChat ( other.Key() ) {
   FUNCTION;
   FlagRecord atr;
   
   type = CL->CLIENT;
   type_flags = DCT_CHAT | DCT_MASTER | DCT_SHOWWHO | DCT_VALIDIDX
     | DCT_SIMUL | DCT_CANBOOT;
   flags = other.Flags();
   status = other.Status();
   address = other.Address();
   localport = other.LocalPort();
   remoteport = other.RemotePort();
   user = other.User();
   strcpy(nick, other.Nick());
   strcpy(host, other.Host());
   timeval = G->now;
   timeout_val = 0;
   StealThings(other);
   strcpy(con_chan, "*");
   channel = 1;
   ClearStatus(STAT_CHAT);
   atr.Set(user);
   ConsoleFlags(atr.GlobMaster() ? G->conmask.Value() : 0);
   DumpWelcome();
   ClearStatus(STAT_ECHO);
}

Client::~Client ( void ) {
   FUNCTION;
}

void Client::Display2 ( Socket * idx) {
   FUNCTION;
   idx->Send("SOD-CLIENT LEARN TO PH34R IT");
}

void Client::Activity ( char * x, int l) {
   FUNCTION;
   char * cmd, buf[513], * a;
   
   while (*x == ' ')
     x++;
   if (*x == ':')
     G->Split(&x);
   cmd = G->Split(&x);
   if (!strcmp(cmd, "JOIN"))
     Join (CL->Split(&x));
   else if (!strcmp(cmd, "PART")) {
      a = CL->Split(&x);
      Part (a, CL->Split(&x));
   } else if (!strcmp(cmd, "PING"))
     Ping (x);
   else if (!strcmp(cmd, "PRIVMSG")) {
      a = CL->Split(&x);
      Privmsg (a, CL->Split(&x));
   } else if (!strcmp(cmd, "NOTICE")) {
      a = CL->Split(&x);
      Notice (a, CL->Split(&x));
   } else if (!strcmp(cmd, "MODE")) {
      a = CL->Split(&x);
      Mode (a, x);
   } else if (!strcmp(cmd, "WHO")) 
	Who (CL->Split(&x));
   else {
      G->SPrintF(buf, 512, "GOT unknown CLIENT CMD: %s (%s)", cmd, x);
      G->LOG_MISC.Put(buf);
      buf[0] = '.';
      strncpyz(buf + 1, x, l);
      DccChat::Activity (buf, l + 1);
   }
}

int Client::ExpMem ( void ) {
   FUNCTION;
   return sizeof(Client) - sizeof(DccChat) + DccChat::ExpMem();
}

int Client::Dump ( char * buf, int l ) {
   FUNCTION;
   char buf2[2048];
   
   if (motd) {
      l = G->SPrintF(buf2, 2048, ":%s. 377 %s :%s", G->botnetnick, nick, buf);
      buf = buf2;
   } else if (buf[0] != ':') 
	return l;
   Socket::Dump(buf, l);
   return l;
}

void Client::DumpMotd ( void ) {
   FUNCTION;
   Send(CL->Lang(0x00D, "ss", G->botnetnick, nick));
   motd = 1;
   ShowMotd();
   motd = 0;
   Send(CL->Lang(0x00E, "s", nick));
}

void Client::DumpWelcome ( void ) {
   FUNCTION;
   int i, j;
   Client * ptr;
   char buf[101];
   
   G->Vers()->AsString(buf, 100);
   for (i = 0x00F; i < 0x013; i++)
     Send(CL->Lang(i, "sss", G->botnetnick, nick, buf));
   DumpLusers();
   DumpMotd();
   i = channel;
   channel = 234567;
   j = key;
   strcpy(con_chan,"***");
   CheckChon();
   if ((ptr = (Client *)G->socklist->Find(j,CL->CLIENT))) {
      if (!strcmp(ptr->con_chan,"***"))
	strcpy(ptr->con_chan,"*");
      if (ptr->channel == 234567) 
	ptr->channel = i;
      ptr->CheckLChjn();
   }
}

void Client::DumpLusers ( void ) {
   FUNCTION;
   DccChat * ptr = (DccChat *)G->socklist;
   Bot * bptr = (Bot *)G->socklist;
   int c = 0, b = 0;
   
   while ((ptr = ptr->Next()))
     c++;
   while ((bptr = bptr->Next()))
     b++;
   Send(CL->Lang(0x013, "ssdd", G->botnetnick, nick, CL->BN->party->Count(),
		 CL->BN->tandbot->Count() + 1));
   Send(CL->Lang(0x014, "ssd", G->botnetnick, nick, -1 ));
   Send(CL->Lang(0x015, "ssdd", G->botnetnick, nick, c, b));
}

void Client::Ping ( char * x ) {
   FUNCTION;
   Printf(":%s. PONG %s\n", G->botnetnick, x);
}

void Client::Join ( char * arg ) {
   FUNCTION;
   int newchan = 0,langv = 0;
   void * argv[3] = { &newchan, arg, 0 };
   char * arg2, *oarg;
   DccChat * ptr = (DccChat *)G->socklist;
   
   while ((arg2 = strchr(arg, ',')))
     arg = arg2 + 1;
   oarg = arg;
   if (*arg == '+')
     arg++;
   if (arg[0] == '*') {
      if (((arg[1] < '0') || (arg[1] > '9'))) {
	 if (G->bt_name->Check("", 0, argv) != EXEC_LOG)
	   langv = 0x097;
      } else if (arg[1])
	   newchan = GLOBAL_CHANS + atoi(arg + 1);
      if (!langv && ((newchan < GLOBAL_CHANS) || 
		     (newchan >= (GLOBAL_CHANS * 2)))) 
	langv = 0x098;
   } else {
      if (((arg[0] < '0') || (arg[0] > '9')) && arg[0]) {
	 if (G->bt_name->Check("", 0, argv) != EXEC_LOG)
	   langv = 0x097;
      } else if (arg[0])
	   newchan = atoi(arg);
      if (!langv && ((newchan < 0) || (newchan >= (GLOBAL_CHANS * 2)))) 
	langv = 0x099;
   }
   if (!langv) {
      /* if coming back from being off the argty line, make sure they're
       not away */
      if ((channel < 0) && away)
	SetAway(0);
      if (channel == newchan) 
	langv = newchan ? 0x09B : 0x09A;
      else {
	 while ((ptr = ptr->Next()))
	   if ((ptr->Channel() == newchan) && !strcasecmp(ptr->Nick(),nick))
	     break;
	 if (ptr) 
	   langv = 0x296;
	 else {
	    if (channel >= 0) 
	      CheckLChpt(G->Lang(0x118, ""));
	    SetChannel(newchan);
	    CheckLChjn();
	 }
      }
   }
   if (langv)
     Send( G->Lang(langv, "s", arg));
}

void Client::Part ( char * arg, char * msg ) {
   FUNCTION;
   int newchan;
   void * argv[3] = { &newchan, arg, 0 };
   char * arg2, * oarg;
   
   while ((arg2 = strchr(arg, ',')))
     arg = arg2 + 1;
   oarg = arg;
   if (*arg == '+')
     arg++;
   if (((*arg >= '0') && (*arg <= '9'))
       || (G->bt_name->Check("", 0, argv) != EXEC_LOG))
     newchan = atoi(arg);
   
   if (newchan == channel) {
      context;
      CheckLChpt(msg);
      Send(CL->Lang(0x016, "ssss", nick, host, oarg, msg));
      channel = -1;
   }
}

void Client::Privmsg ( char * arg, char * msg ) {
   FUNCTION;
   int destchan;
   void * argv[3] = { &destchan, arg, 0 };
   char * arg2;
   
   if (msg[0]) {
      arg2 = strchr(arg, ',');
      while (arg) {
	 if (arg2)
	   *arg2++ = 0;
	 if ((*arg == '+') || (*arg == '#')) {
	    if (*arg == '+')
	      arg++;
	    if (((*arg >= '0') && (*arg <= '9'))
		|| (G->bt_name->Check("", 0, argv) != EXEC_LOG))
	      destchan = atoi(arg);
	    
	    CL->last = this;
	    if (destchan == channel) 
	      DccChat::Activity (msg, strlen(msg));
	    CL->last = 0;
	 } else {
	    context;
	    while ((*msg == ' ') || (*msg == '<') || (*msg == '>'))
	      msg++; /* these are now illegal *starting* notes characters */
	    G->AddNote(arg, nick, msg, 0, 0);
	 }
	 arg = arg2 ? arg2 + 1 : 0;
      }
   }
}

void Client::Notice ( char * desto, char * msg ) {
   FUNCTION;
   Privmsg ( desto, msg );
}

void Client::Mode (char * a, char * b) {
   FUNCTION;
   if (*a != '+') {
      if (strcasecmp(a, nick))
	Send(CL->Lang(0x018, "ss", G->botnetnick, nick));
      else {
	 char s[2];
	 LogModes md;
	 FlagRecord fr(FlagRecord::GLOBAL | FlagRecord::CHANNEL);
	 int pls = 1;
	 
	 fr.Set(user, con_chan);
	 if ((b[0] != '+') && (b[0] != '-'))
	   ConsoleFlags().Clear();
	 for (; *b; b++) {
	    if (*b == '+')
	      pls = 1;
	    else if (*b == '-')
	      pls = 0;
	    else {
	       s[0] = *b;
	       s[1] = 0;
	       md.Set(s);
	       if (!fr.GlobMaster() && pls) 
		 md.Remove ( LogModes::FILES | LogModes::LEVS 
			    | (fr.ChanMaster() ? 0 : LogModes::MISC |
			       LogModes::CMDS | LogModes::WALL) );
	       if (!fr.GlobOwner() && pls) 
		 md.Remove ( LogModes::RAW | LogModes::SRVOUT | 
			    LogModes::BOTNET | LogModes::BOTSHARE );
	       if (!fr.GlobBotmast() && pls) 
		 md.Remove ( LogModes::BOTS );
	       if (pls)
		 ConsoleFlags() += md;
	       else
		 ConsoleFlags() -= md;
	    }
	 }
      }
   } else 
     Send(CL->Lang(0x019, "ss", G->botnetnick, nick));
}

void Client::SendWho ( PartyLiner * ptr ) {
   FUNCTION;
   char buf[UHOSTLEN + 1], flags[3], *host, chan[20], *user = buf;
   
   flags[0] = ptr->Away() ? 'G' : 'H';
   flags[1] = fconv(ptr->Flag());
   if (flags[1] == '-')
     flags[1] = ' ';
   flags[2] = 0;
   strncpyz(user, ptr->From(), UHOSTLEN);
   if ((host = strchr(user, '@'))) 
     *host++ = 0;
   else {
      host = user;
      user = "telnet";
   }
   G->SPrintF(chan, 19, "+%d", ptr->Chan());
   Send(CL->Lang(0x01B, "sssssssss", G->botnetnick, nick, chan, user, host,
		 ptr->BotName(), ptr->Nick(), flags, ptr->Away()));
}
   
void Client::Who ( char * a ) {
   FUNCTION;
   PartyLiner * ptr = CL->BN->party;
   
   if (*a == '+') {
      int chan = atoi(a + 1);
      context;
      while ((ptr = ptr->Next()))
	if (ptr->Chan() == chan) 
	  SendWho(ptr);
   } else {
      char * x = strchr(a, '@');
      
      if (x) {
	 TandemBot * tb;
	 
	 *x ++ = 0;
	 if ((tb = CL->BN->tandbot->Find(x)))
	   ptr = tb->PartyLiners();
	 else 
	   ptr = 0;
      }
      if (ptr && (ptr = (PartyLiner *)ptr->Find(a)))
	SendWho(ptr);
   }
   Send(CL->Lang(0x01A, "sss", G->botnetnick, nick, a));
}
