/* 
 * ModuleEntryClient.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ModuleEntryClient.h"
#include "Client.h"
#define CLASS "ModuleEntryClient"

static Version client_version;
static struct patches client_patches[] = { 
#include "patch.h"
};

ModuleEntryClient::ModuleEntryClient( ModuleEntry * old, char ** r) 
: ModuleEntry ( "client", client_version.Set(2,0), client_patches, old ) {
   FUNCTION;
   Version required;
   
   CL = this;
   if (!(BN = (class ModuleEntryBotnet *)Depend("botnet", required.Set(2,0))))
     *r = "Your botnet version is incompatible";
   else {
      CLIENT = "SOD-CLIENT";
      CLIENT = "SOD-CLIENT-LOGIN";
      last = 0;
   }
}

ModuleEntryClient::~ModuleEntryClient ( void ) {
   FUNCTION;
   Client * ptr;
   
   while ((ptr = ((Client *)G->socklist)->Next())) {
      ptr->Close();
      DELETE (ptr);
   }
}

int ModuleEntryClient::ExpMem ( void ) {
   FUNCTION;
   return sizeof(ModuleEntryClient) + ModuleEntry::ExpMem ();
}

char * ModuleEntryClient::Split ( char ** rest ) {
   FUNCTION;
   register char * o, * r;
   
   if (!rest) 
     return *rest = "";
   for (o = *rest; *o == ' '; o++);
   if (*o == ':') {
      *rest = 0;
      return ++o;
   }
   for (r = o; *o && (*o != ' '); o++);
   if (*o)
     *o++ = 0;
   *rest = o;
   return r;
}
