/* 
 * ModuleEntryConsole.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "UserEntryConsole.h"
#include "ModuleEntryConsole.h"
#include "IntegerVariable.h"
#include "StringVariable.h"
#include "Socket.h"
#include "HelpReference.h"
#define CLASS "ModuleEntryConsole"

static Version console_version;
static struct patches console_patches[] = { 
#include "patch.h"
};

ModuleEntryConsole::ModuleEntryConsole( ModuleEntry * old, char ** r) 
: ModuleEntry ( "console", console_version.Set(2,0), console_patches, old ) {
   FUNCTION;
   Version required;
   
   CONSOLE = this;
   if (!Depend("eggdrop", required.Set(2,0)))
     *r = "Your eggdrop core is incompatible.";
   else {
      console_autosave = 0;
      force_channel = 0;
      info_party = 0;
      NEW ( IntegerVariable ( "console_autosave", &console_autosave, 0, this ) );
      NEW ( IntegerVariable ( "force_channel", &force_channel, 0, this ) );
      NEW ( IntegerVariable ( "info_party", &info_party, 0, this ) );
      NEW ( HelpReference ( "console.help" ,this ) );
      entrytype_console = NEW ( UserEntryConsole (this) );
   }
}

ModuleEntryConsole::~ModuleEntryConsole ( void ) {
   FUNCTION;
}

int ModuleEntryConsole::ExpMem ( void ) {
   FUNCTION;
   return sizeof(ModuleEntryConsole) + ModuleEntry::ExpMem ();
}
