/*
 * UserEntryConsole.h
 */

#ifndef _USERENTRYLASTON_
#include "UserEntryLaston.h"
#endif

#ifndef _USERENTRYCONSOLE_
#define _USERENTRYCONSOLE_

class UserEntryConsole : public UserEntryLaston {
  protected:
   int stripflags;
   int echoflags;
   LogModes conflags;
   int conchan;

   friend BindReturn console_store (void **, const char *);

  public:
   inline UserEntryConsole ( UserRecord * u, UserEntry * t )
     : UserEntryLaston ( u, t ) {
   }
   inline UserEntryConsole ( ModuleEntry * t )
     : UserEntryLaston ( "console", t ) { }
   ~UserEntryConsole ( void );
   
   void Unpack ( UserRecord *, MessageQueue * );
   void Pack ( UserEntry * );
   UserEntry * Create ( UserRecord * );
   
   int Write ( FILE *, Socket * );
   int ScriptGet ( ScriptContext *, int, ScriptArgument ** );
   int ScriptSet ( ScriptContext *, int, ScriptArgument ** );
   int ExpMem ( void );
   void Display ( Socket * );
   
   inline const char * Channel ( void ) { return string; }
   inline LogModes & ConsoleFlags ( void ) { return conflags; }
   inline int StripFlags ( void ) { return stripflags; }
   inline int EchoFlags ( void ) { return echoflags; }
   inline int ConsoleChan ( void ) { return conchan; }
   inline int Page ( void ) { return when; }
};
#endif
