/*
 * console.c - saved console settings based on console.tcl by
 * cmwagner/billyjoe/D. Senso
 */

#include "DccChat.h"
#include "BindTable.h"
#include "UserRecord.h"
#include "UserEntryLaston.h"
#include "UserEntryUnknown.h"
#include "UserEntryString.h"
#include "UserEntryConsole.h"
#include "MessageQueue.h"
#include "HelpReference.h"
#include "ModuleEntry.h"
#include "ModuleEntryConsole.h"
#include <stdlib.h>
#include "ScriptContext.h"
#include "ScriptArgument.h"
#define CLASS ""

ModuleEntryConsole * CONSOLE;
static ModuleEntryEggdrop * G;
BindReturn console_store (void **, const char *);

static BindReturn console_chon (void ** args, const char *) {
   FUNCTION;
   DccChat * idx = (DccChat *)args[0];
   UserEntryConsole * i = (UserEntryConsole *)
     idx->User()->FindEntry(CONSOLE->entrytype_console);
   void * argv[3];
   int k;
   
   /* only setup settings on initial signon */
   if (idx->TypeFlags() & DCT_CHAT) {
     if (idx->Channel() == 234567) {
	if (i) {
	   if (i->Channel() && i->Channel()[0])
	     idx->SetConsoleChan(i->Channel());
	   if (i->ConsoleFlags().Value()) 
	     idx->ConsoleFlags() = i->ConsoleFlags();
	   if (i->StripFlags())
	     idx->SetStripFlags(i->StripFlags());
	   if (i->EchoFlags())
	     idx->SetStatus(STAT_ECHO);
	   else
	     idx->ClearStatus(STAT_ECHO);     
	   if (i->Page() > 0) {
	      idx->SetStatus(STAT_PAGE);
	      idx->SetMaxLines(i->Page());
	      if (!idx->LineCount())
		idx->ClearCount();
	   }
	   idx->SetChannel(i->ConsoleChan());
	} else if (CONSOLE->force_channel > -1) 
	     idx->SetChannel(CONSOLE->force_channel);
     } else if (CONSOLE->info_party) {
	UserEntryString * uei = 
	  (UserEntryString *)idx->User()->GetEntry(G->entrytype_info);
	if (uei) {
	   DccChat::Chanout(idx->Channel(),
			    CONSOLE->Lang(0x006,"ss",idx->Nick(), uei->Value()));
	   argv[0] = G->botnetnick;
	   argv[1] = &(k = idx->Channel());
	   argv[2] = CONSOLE->Lang(0x007, "ss", idx->Nick(), uei->Value());
	   G->bt_bcst->Check((char *)argv[0], 0, args);
	}
     }
   }
   return EXECUTED;
}

BindReturn console_store (void ** args, const char *) {
   FUNCTION;
   DccChat * idx = (DccChat *)args[0];
   UserEntryConsole * i = (UserEntryConsole *)
     idx->User()->GetEntry(CONSOLE->entrytype_console);

   i->Set(idx->ConsoleChan(), idx->HasStatus(STAT_PAGE)
	  ? idx->MaxLines() : 0);
   i->conflags = idx->ConsoleFlags();
   i->stripflags = idx->StripFlags();
   i->echoflags = idx->HasStatus(STAT_ECHO) ? 1 : 0;
   i->conchan = idx->Channel();
   if (args[1]) {
      idx->Send(CONSOLE->Lang(0x002, ""));
      idx->Send(CONSOLE->Lang(0x003, "s", i->Channel()));
      idx->Send(CONSOLE->Lang(0x004, "sss", i->ConsoleFlags().Mask(),
			G->StripMaskType(i->StripFlags()),
			i->EchoFlags() ? "yes" : "no"));
      idx->Send(CONSOLE->Lang(0x005, "dd", i->Page(), i->ConsoleChan()));
   }
   return EXECUTED;
}

static BindReturn console_chof (void ** args, const char *) {
   FUNCTION;
   if (CONSOLE->console_autosave) {
      void * argv[2] = {args[0], NULL};
      return console_store(argv,NULL);
   }
   return EXECUTED;
}

static command_binds mychon[] = {
     { "*", "", console_chon, "console:chon" }
};

static command_binds mychof[] = {
     { "*", "", console_chof, "console:chof" }
};

static command_binds mydcc[] = {
     {"store", "", console_store, NULL }
};

extern "C" {
   char * console_start (ModuleEntryEggdrop *, ModuleEntry *);
};

char *console_start (ModuleEntryEggdrop * global_funcs, ModuleEntry * me) {
   FUNCTION;
   char * r = 0;

   G = global_funcs;
   context;
   NEW ( ModuleEntryConsole ( me, &r ) );
   if (!r) {
      context;
      G->bt_chon->AddBinds(mychon,1, CONSOLE);
      G->bt_chof->AddBinds(mychof,1, CONSOLE);
      G->bt_dcc->AddBinds(mydcc,1, CONSOLE);
   }
   context;
   return r;
}
