/*
 * crypt.c -- handles:
 * encryption and decryption of passwords (using standard UNIX crypt function)
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "Version.h"
#include "ScriptContext.h"
#include "ScriptArgument.h"
#include "ModuleEntryCrypt.h"
#include "Command.h"
#define CLASS ""

static ModuleEntryCrypt * ME;
static ModuleEntryEggdrop * G;

static int script_encrypt (ScriptContext * sc, int argc, ScriptArgument ** argv) {
   FUNCTION;
   char *p;
   
   BADARGS(3, 3, " key string");
   sc->SetString(p = ME->Encrypt(argv[1]->AsString(), argv[2]->AsString()));
   my_free(p,G->memtype_misc);
   return SCRIPT_OK;
}

static int script_decrypt (ScriptContext * sc, int argc, ScriptArgument ** argv) {
   FUNCTION;
   char *p;
   
   BADARGS(3, 3, " key string");
   sc->SetString(p = ME->Decrypt(argv[1]->AsString() ,argv[2]->AsString()));
   my_free(p,G->memtype_misc);
   return SCRIPT_OK;
}

extern "C" {
   char *crypt_start (ModuleEntryEggdrop * G, ModuleEntry * me) {
      FUNCTION;
      char * r = 0;
      ::G = G;
      ME = NEW ( ModuleEntryCrypt ( me, &r ) );
      if (!r) {
	 NEW ( Command ( "encrypt", script_encrypt, ME ) );
	 NEW ( Command ( "decrypt", script_decrypt, ME ) );
      }
      context;
      return r;
   }
};
