/*
 * ModuleEntryCtcp.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ModuleEntryCtcp.h"
#include "ModuleEntryServer.h"
#include "HelpReference.h"
#define CLASS "ModuleEntryCtcp"

static Version ctcp_ver;
static struct patches ctcp_patches[] = {
#include "patch.h"
};

ModuleEntryCtcp::ModuleEntryCtcp ( ModuleEntry * o, char ** r )
: ModuleEntry ( "ctcp", ctcp_ver.Set(2,0), ctcp_patches, o) {
   FUNCTION;
   Version required;
   
   if (!(SERVER = (ModuleEntryServer *)Depend("server", required.Set(2,0))))
     *r = "You need the server module to use the ctcp module.";
   NEW ( HelpReference ( "ctcp.help", this ) );
}
			   
ModuleEntryCtcp::~ModuleEntryCtcp ( void ) {
   FUNCTION;
}

int ModuleEntryCtcp::ExpMem ( void ) {
   FUNCTION;
   return ModuleEntry::ExpMem () + sizeof(ModuleEntryCtcp);
}
