/*
 * BindTableFiles.C -- member functions for the BindTableFiles class
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "filesys.h"
#include "ModuleEntryFilesys.h"
#include "BoundCommand.h"
#include "BindTableFiles.h"
#include "Socket.h"
#include "ScriptContext.h"
#include "ScriptArgument.h"
#define CLASS "BindTableFiles"

BindTableFiles::~BindTableFiles ( void ) {
   FUNCTION;
}

int BindTableFiles::FromScript (BoundCommand * be, ScriptContext * sc, int argc,
				ScriptArgument ** argv) {
   FUNCTION;
   const char * mask = argv[0]->AsString();
   void * args [2];
   
   context;
   BADARGS(4, 4, FILESYS->Lang(0x140, ""));
   if (!(args[1] = G->socklist->Find(argv[2]->AsInteger(), FILESYS->DCC_FILES))) {
      sc->SetString(FILESYS->Lang (0x105, ""));
      return SCRIPT_ERROR;
   }  
   args[2] = (void *)argv[2]->AsString();
   sc->SetString((be->Call(args, mask + 5) == EXEC_BRK) ? "break" : "0");
   return SCRIPT_OK;
}
