/*
 * DccFilesPass.C - a user login into the filesystem
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "filesys.h"
#include "ModuleEntryFilesys.h"
#include "UserRecord.h"
#include "DccFilesPass.h"
#include "DccFiles.h"
#define CLASS "DccFilesPass"

DccFilesPass::~DccFilesPass ( void ) {
   FUNCTION;
}

void DccFilesPass::Eof (void) {
   FUNCTION;
   G->LOG_MISC.Put(FILESYS->Lang(0x0D2, "ssd", nick, host, remoteport));
   Close();
}

void DccFilesPass::Timeout (void) {
   FUNCTION;
   context;
   Send(FILESYS->Lang(0x109, ""));
   G->LOG_MISC.Put(FILESYS->Lang(0x0A6, "s", nick,host));
   Close();
}

void DccFilesPass::Display2 (Socket * where) {
   FUNCTION;
   where->Send(FILESYS->Lang(0x0A8, "l", Age()));
}

void DccFilesPass::Activity (char * buf, int x) {
   FUNCTION;
   if (x) {
      if (user->PassMatch(buf)) {
	 if (FILESYS->TooManyFilers()) {
	    Send(FILESYS->Lang(0x093, ""));
	    Send(FILESYS->Lang(0x094, ""));
	    G->LOG_MISC.Put(FILESYS->Lang(0x095, "ss", nick, host));
	 } else {
	    SetType(FILESYS->DCC_FILES);
	    if (HasStatus(STAT_TELNET))
	      Printf("\377\374\001\n");	/* turn echo back on */
	    G->LOG_MISC.Put(FILESYS->Lang(0x096, "ssd", nick, host, remoteport));
	    NEW ( DccFiles ( * this ) );
	    return;
	 }
      } else {
	 Send(FILESYS->Lang(0x098, ""));
	 G->LOG_MISC.Put(FILESYS->Lang(0x099, "ss", nick, host));
      }
      Close();
   }
}
