/*
 * UserEntryDccDir.C - code for handle DccDir user entry
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "filesys.h"
#include "ModuleEntryFilesys.h"
#include "UserRecord.h"
#include "UserEntryDccDir.h"
#define CLASS "UserEntryDccDir"

UserEntryDccDir::~UserEntryDccDir ( void ) {
   FUNCTION;
}

UserEntry * UserEntryDccDir::Create ( UserRecord * u ) {
   FUNCTION;
   return NEW (UserEntryDccDir (u, this ) );
}

void UserEntryDccDir::Set ( char * str ) {
   FUNCTION;
   if (string)
     my_free(string, G->memtype_userent);
   if (str) {
      string = (char *)my_malloc(strlen(str) + 1, G->memtype_userent);
      strcpy(string, str);
   } else
     string = NULL;
}
