/* 
 * UserEntryFstat.h - Filestats user entry
 */

#ifndef _USERENTRY_
#include "UserEntry.h"
#endif

#ifndef _MODULEENTRYFILESYS_
#include "ModuleEntryFilesys.h"
#endif

#ifndef _USERENTRYFSTAT_
#define _USERENTRYFSTAT_

class UserEntryFstat : public UserEntry {
  protected:
   int uploads;
   int upload_ks;
   int dnloads;
   int dnload_ks;

  public:
   inline UserEntryFstat ( UserRecord * u, UserEntry * t) 
     : UserEntry ( u, t ) {
     }
   inline UserEntryFstat ( ModuleEntry * ME )
     : UserEntry ( "fstat", ME ) { }
   ~UserEntryFstat ( void );

   void GotShare ( char *, Socket * );
   void PruneUser ( Socket * );
   int Write ( FILE *, Socket * );
   int ScriptGet ( ScriptContext *, int, ScriptArgument ** );
   int ScriptSet ( ScriptContext *, int, ScriptArgument ** );
   void Display (Socket * );
   int ExpMem ( void );

   void AddFileUp ( int );
   void AddFileDown ( int );
   void Clear ( void );
   inline int Uploads ( void ) { return uploads; }
   inline int UploadKs ( void ) { return upload_ks; }
   inline int Dnloads ( void ) { return dnloads; }
   inline int DnloadKs ( void ) { return dnload_ks; }   

   void Unpack ( UserRecord *, MessageQueue * );
   void Pack ( UserEntry * );
   UserEntry * Create ( UserRecord * );
};

#ifndef _USERRECORD_
#include "UserRecord.h"
#endif

inline UserEntryFstat * GetFstat ( UserRecord * u ) {
   return (UserEntryFstat *)u->GetEntry(FILESYS->entrytype_fstat);
}

#endif
