/*
 * ModuleEntryGetops.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ModuleEntryGetops.h"
#include "IntegerVariable.h"
#include "StringVariable.h"
#include "HelpReference.h"
#define CLASS "ModuleEntryGetops"

/* version info */
static Version getops_ver;
static struct patches getops_patches[] = {
#include "patch.h"
};

ModuleEntryGetops::ModuleEntryGetops ( ModuleEntry * o, char ** r )
: ModuleEntry ( "getops", getops_ver.Set(2,0), getops_patches, o ) {
   FUNCTION;
   Version required;

   GETOPS = this;
   if (!Depend("eggdrop", required.Set(2,0)))
     *r = "Your eggdrop core version is incompatible";
   else if (!(IRC = (ModuleEntryIrc *) Depend("irc", required.Set(2,0))))
     *r = "You need the irc module to use the getops module.";
   else if (!(SERVER = (ModuleEntryServer *) Depend("server", required.Set(2,0))))
     *r = "You need the server module to use the getops module.";
   else if (!(BOTNET = (ModuleEntryBotnet *) Depend("botnet", required.Set(2,0))))
     *r = "You need the botnet module to use the getops module.";
   else {
      allow_unban = 1;
      request_cycle = 1;
      log_events = 1;
      cycle_msg[0] = 0;
      NEW ( HelpReference("getops.help", this) );
      NEW ( IntegerVariable ("allow_unban", &allow_unban, 0, this));
      NEW ( IntegerVariable ("request_cycle", &request_cycle, 0, this));
      NEW ( IntegerVariable ("log_events", &log_events, 0, this));
      NEW ( StringVariable ("cycle_msg", cycle_msg, 120, 0, this));
   }
}

ModuleEntryGetops::~ModuleEntryGetops ( void ) {
   FUNCTION;
   DELETE ( already_sent );
}

int ModuleEntryGetops::ExpMem ( void ) {
   FUNCTION;
   return ModuleEntry::ExpMem() + sizeof(ModuleEntryGetops);
}
