/*
 * This is the getops module based on the getops-2.0.1.tcl by numerous people
 * it should hopefully interact fully with that tcl or another module
 * 
 * TODO: allow channel by-channel getops settings
 *       desynch handling?
 * 
 * 2.0.1 by beldin (1.3.x ONLY version)
 * actually, iso needed to be modded for 1.3 :P, and validchan is builtin
 * and I'll tidy a couple of functions up to
 * 
 * 2.0 by DarkDruid
 * It'll work with dynamic channels(dan is a dork for making it not..)
 * It will also only ask one bot at a time for ops so there won't be any more
 * annoying mode floods, and it's more secure that way
 * I also took that annoying wallop and resynch stuff out :P
 * And I guess this will with with 1.3.x too
 * 
 * 1.9 by The_O
 * will now op a bot that is in the channel with a different nick
 * than the userfile handle
 * 
 * getops-1.8.tcl by dtM, a GainOps-like script for eggdrop 1.1.x
 * 
 * This script originated from getops-1.2.tcl by poptix, which, I found out,
 * did not work. I modified it to where it worked very nicely and
 * efficiently. Thanks to poptix for the ideas and something to do. :)
 * 
 * thanks to beldin/david/cfusion/oldgroo and anyone else who gave me
 *  suggestions/fixes :)
 */

#define MAKING_GETOPS
#include "Bot.h"
#include "BanRecord.h"
#include "UserRecord.h"
#include "BindTable.h"
#include "HelpReference.h"
#include "TandemBot.h"
#include "ModuleEntry.h"
#include "ModuleEntryBotnet.h"
#include "ModuleEntryGetops.h"
#include "ModuleEntryIrc.h"
#include "ModuleEntryServer.h"
#include "server.h"
#include "channels.h"
#include "irc.h"
#include <stdlib.h>
#include "ScriptContext.h"
#include "Channel3.h"
#include "ChannelMember.h"
#include "ChannelRecord.h"
#define CLASS ""

ModuleEntryGetops * GETOPS;
static ModuleEntryEggdrop * G;

static BindReturn gain_entrance ( void ** args, const char * mask ) {
   FUNCTION;
   UserRecord * u = G->userlist;
   Channel3 * chan = (Channel3 *)args[0];
   ChannelMember * m, * m2 = NULL;
   Bot * idx = 0;
   char buf[512];
   FlagRecord fr ( FlagRecord::GLOBAL | FlagRecord::CHANNEL );
   void * i;
   TandemBot * tb;
   
   context;
   if (chan->Active()) {
      if (strcasecmp(mask, "op")) {
	 while ((u = u->Next()))
	   if ((tb = GETOPS->BOTNET->tandbot->Find(u->Handle())) && (idx = tb->NextBot())) {
	      if (strcasecmp(mask, "unban"))
		G->SPrintF(buf, 511, "gop %s %s %s", chan->Key(), GETOPS->SERVER->botname);
	      else
		G->SPrintF(buf, 511, "gop %s %s %s!%s", chan->Key(), GETOPS->SERVER->botname,
			   GETOPS->SERVER->botuserhost);
	      idx->SendZapf(G->botnetnick, u->Handle(), buf);
	      if (GETOPS->log_events)
		G->LOG_MISC.Put(GETOPS->Lang(0x004, "sss", mask, u->Handle(), chan->Key()));
	   }
      } else {      
	 context;
	 for (m = chan->M(); (m = m->Next());)
	   if (m->HasOp()) {
	      m2 = m;
	      u = m->MemberUser();
	      fr.Set(u, chan->Key());
	      if (u && fr.GlobBot() && fr.AnyValidOp()
		  && (tb = GETOPS->BOTNET->tandbot->Find(u->Handle())) &&
		  (idx = tb->NextBot()) && !GETOPS->already_sent->Find(u->Handle())) {
		 i = NEW ( KeyedList<HANDLEN> (*GETOPS->already_sent, u->Handle()) );
		 G->SPrintF(buf, 511, "gop op %s %s", chan->Key(), GETOPS->SERVER->botname);
		 idx->SendZapf(G->botnetnick, u->Handle(), buf);
		 if (GETOPS->log_events)
		   G->LOG_MISC.Put(GETOPS->Lang(0x005, "ss", u->Handle(), chan->Key()));
		 break;
	      }
	   }
	 if (!m) {
	    DELETE( GETOPS->already_sent );
	    GETOPS->already_sent = NEW (  KeyedList<HANDLEN> () );
	 }
	 if (!m2 && GETOPS->request_cycle)
	   GETOPS->SERVER->SendNotice(Q_SERVER, chan->Key(), GETOPS->cycle_msg);
      }
   }
   return EXECUTED;
}

static struct command_binds need_binds [] = {
   { "*", "", gain_entrance, "getops" },
};


static BindReturn getops_gop_resp ( void ** args, const char * ) {
   FUNCTION;
   char * from = (char *)args[0];
   char * par = (char *)args[1];
   
   if (GETOPS->log_events)
     G->LOG_MISC.Put(GETOPS->Lang(0x006, "ss", from, par));
   return EXECUTED;
}

static BindReturn getops_gop ( void ** args, const char * ) {
   FUNCTION;
   char * from = (char *)args[0], * par = (char *)args[1], *which, buf[512];
   char * chan;
   UserRecord * u = G->userlist->Find(from);
   Channel3 * ch;
   FlagRecord fr (FlagRecord::GLOBAL | FlagRecord::CHANNEL );
   TandemBot * tb = GETOPS->BOTNET->tandbot->Find(from);
   Bot * idx = tb ? tb->NextBot() : 0;
   ChannelMember * m;
   BanRecord * b;

   if (idx && fr.Set(u)->GlobBot()) {
      which = G->Split(&par);
      chan = G->Split(&par);
      if ((ch = FindChan3(chan))) {
	 if (!strcasecmp(which, "invite")) {
	    if (GETOPS->log_events)
	      G->LOG_MISC.Put(GETOPS->Lang(0x007, "ss", from, chan));
	    GETOPS->SERVER->SendInvite(Q_SERVER, par, chan);
	 } else if (!strcasecmp(which, "limit")) {
	    if (GETOPS->log_events)
	      G->LOG_MISC.Put(GETOPS->Lang(0x008, "ss", from, chan));
	    ch->AddMode('+', 'l', G->ToBase10(ch->MaxMembers() + 2));
	 } else if (!strcasecmp(which, "key")) {
	    if (GETOPS->log_events)
	      G->LOG_MISC.Put(GETOPS->Lang(0x009, "ss", from, chan));
	    if (ch->Mode() & CHANKEY) 
	       G->SPrintF(buf, 511, "gop takekey %s %s", chan, ch->ChanKey());
	    else 
	       G->SPrintF(buf, 511, "gop_resp %s", GETOPS->Lang(0x00A, "s", chan));
	    idx->SendZapf(G->botnetnick, from, buf);
	 } else if (!strcasecmp(which, "takekey")) {
	    if (GETOPS->log_events)
	      G->LOG_MISC.Put(GETOPS->Lang(0x00B, "sss", from, chan, par));
	    GETOPS->SERVER->SendJoin(Q_SERVER, chan, par);
	 } else if (!strcasecmp(which, "op")) {
	    fr.Set(u,chan);
	    if (fr.AnyValidOp()) {
	       if (GETOPS->log_events)
		 G->LOG_MISC.Put(GETOPS->Lang(0x00C, "ss", from, chan));
	       if ((m = ch->M()->Find(par)) && (u == m->MemberUser())) {
		  if (ch->Meop()) {
		     if (m->HasOp())
		       G->SPrintF(buf, 511, "gop_resp %s", GETOPS->Lang(0x00D, ""));
		     else {
			G->SPrintF(buf, 511, "gop_resp %s", GETOPS->Lang(0x00E,
								 "ss", par, chan));
			ch->AddMode('+', 'o', par);
		     }
		  } else 
		    G->SPrintF(buf, 511, "gop_resp %s", GETOPS->Lang(0x00F, "s",
							     chan));
	       } else
		 G->SPrintF(buf, 511, "gop_resp %s", GETOPS->Lang(0x010, "ss", par,
							  chan));
	       idx->SendZapf(G->botnetnick, from, buf);
	    } else if (GETOPS->log_events)
	      G->LOG_MISC.Put(GETOPS->Lang(0x011, "ss", from, chan));
  	 } else if (!strcasecmp(which, "unban")) {
	    if (GETOPS->allow_unban) {
	       if (GETOPS->log_events)
		 G->LOG_MISC.Put(GETOPS->Lang(0x012, "sss", from, par, chan));
	       for (b = ch->Bans(); (b = b->Next());) 
		 if (G->WildMatch(b->Key(), par))
		   ch->AddMode('-', 'b', b->Key());
	    } else {
	       idx->SendZapf(G->botnetnick, from, GETOPS->Lang(0x013, ""));
	       if (GETOPS->log_events)
		 G->LOG_MISC.Put(GETOPS->Lang(0x014, "sss", from, par, chan));
	    }
	 } else if (GETOPS->log_events)
	   G->LOG_MISC.Put(GETOPS->Lang(0x015, "ss", from, which));
      } else {
	 if (GETOPS->log_events)
	   G->LOG_MISC.Put(GETOPS->Lang(0x016, "ss", chan, from));
	 G->SPrintF(buf, 511, "gop_resp %s", GETOPS->Lang(0x017, "s", chan));
	 idx->SendZapf(G->botnetnick, from, buf);
      }
   } else if (GETOPS->log_events)
	G->LOG_MISC.Put(GETOPS->Lang(0x018, "s", from));
   return EXECUTED;
}

static struct command_binds bot_binds [] = {
   { "gop", "", getops_gop, NULL },
   { "gop_resp", "", getops_gop_resp, NULL }
};

extern "C" {
   char * getops_start ( ModuleEntryEggdrop *, ModuleEntry * );
};

char * getops_start ( ModuleEntryEggdrop * F, ModuleEntry * me ) {
   FUNCTION;
   char * r = 0;

   G = F;
   context;
   GETOPS = NEW ( ModuleEntryGetops ( me, &r ) );
   if (!r) {
      strcpy(GETOPS->cycle_msg, GETOPS->Lang(0x003, ""));
      GETOPS->IRC->bt_need->AddBinds(need_binds, 1, GETOPS);
      GETOPS->BOTNET->bt_bot->AddBinds(bot_binds, 2, GETOPS );
      GETOPS->already_sent = NEW ( KeyedList<HANDLEN> () );
   }
   return r;
}
