/*
 * BindTableJPSR.C -- member functions for the BindTableJPSR class
*/
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
*/

#include "BindTableJPSR.h"
#include "channels.h"
#include "UserRecord.h"
#include "ScriptContext.h"
#include "ScriptArgument.h"
#include "Channel3.h"
#include "ModuleEntryIrc.h"
#include "BoundCommand.h"
#define CLASS "BindTableJPSR"

BindTableJPSR::~BindTableJPSR ( void ) {
   FUNCTION;
}

BindReturn BindTableJPSR::ToScript (BindEntry * be, void ** argv, const char * mask) {
   FUNCTION;
   UserRecord * u = (UserRecord *)argv[3];
   Channel3 * c = (Channel3 *)argv[4];
   
   context;
   return be->Call(mask, 4, (char *)argv[1], (char *)argv[2], 
		   u ? u->Handle() : "*", c->Key());
}

int BindTableJPSR::FromScript (BoundCommand * be, ScriptContext * sc, int argc,
			       ScriptArgument ** argv) {
   FUNCTION;
   void * args[4];
   
   BADARGS(5, 5, mod->Lang(0x0C2, ""));
   args[0] = (void *)argv[1]->AsString();
   args[1] = (void *)argv[2]->AsString();
   args[2] = G->userlist->Find(argv[3]->AsString());
   if (!(args[3] = FindChan(argv[4]->AsString()))) {
      sc->SetString(I->CHANNELS->Lang(0x103, "s", argv[4]->AsString()));
      return SCRIPT_ERROR;
   }
   be->Call(args, argv[0]->AsString() + 6);
   return SCRIPT_OK;
}
