/*
 * BindTableSTNM.C -- member functions for the BindTableSTNM class
*/
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
*/

#include "BindTableSTNM.h"
#include "UserRecord.h"
#include "channels.h"
#include "ScriptContext.h"
#include "ScriptArgument.h"
#include "Channel3.h"
#include "ModuleEntryIrc.h"
#include "BoundCommand.h"
#define CLASS "BindTableSTNM"

BindTableSTNM::~BindTableSTNM ( void ) {
   FUNCTION;
}

BindReturn BindTableSTNM::ToScript (BindEntry * be, void ** argv, const char * mask) {
   FUNCTION;
   UserRecord * u = (UserRecord *)argv[2];
   Channel3 * c = (Channel3 *)argv[3];
   
   context;
   return be->Call(mask, 5, argv[0], argv[1], u ? u->Handle() : "*", c->Key(),
		   argv[4]);
}

int BindTableSTNM::FromScript (BoundCommand * be, ScriptContext * sc, int argc,
			       ScriptArgument ** argv) {
   FUNCTION;
   void * args[5];
   
   BADARGS(6, 6, mod->Lang(0x0C1, ""));
   args[0] = (void *)argv[1]->AsString();
   args[1] = (void *)argv[2]->AsString();
   args[2] = G->userlist->Find(argv[3]->AsString());
   args[4] = (void *)argv[5]->AsString();

   if (!(args[3] = FindChan(argv[4]->AsString()))) {
      sc->SetString(I->CHANNELS->Lang(0x103, "s", argv[4]->AsString()));
      return SCRIPT_ERROR;
   }
   be->Call(args, argv[0]->AsString() + 6);
   return SCRIPT_OK;
}
