/*
 * ChannelBan.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ChannelBan.h"
#include "Channel3.h"
#define CLASS "ChannelBan"

ChannelBan::ChannelBan (Channel3 * c, const char * s, const char * w, int f) 
: KeyedList<UHOSTLEN> ( f ? *c->Exceptions() : *c->ChanBans(), s,
		       APPEND | NODUPS) {
   FUNCTION;
   strncpyz(who, w, UHOSTLEN);
   Touch();
   chan = c;
   flag = f;
}

ChannelBan::~ChannelBan ( void ) {
   FUNCTION;
   if (key[0]) {
      if (flag) 
	chan->Exceptions()->Remove(this);
      else
	chan->ChanBans()->Remove(this);
   } else
     while (next) {
	DELETE ( next );
     }
}

int ChannelBan::ExpMem ( void ) {
   FUNCTION;
   return sizeof(ChannelBan);
}
