/*
 * ChannelBan.h - a ban set on a channel
 */

#ifndef _KEYEDLIST_
#include "KeyedList.h"
#endif

#ifndef _MODULEENTRYIRC_
#include "ModuleEntryIrc.h"
#endif

#ifndef _CHANNELBAN_
#define _CHANNELBAN_

class ChannelBan : public KeyedList<UHOSTLEN> {
  protected:
   char who [UHOSTLEN + 1];
   time_t timer;
   Channel3 * chan;
   int flag;
   
  public:
   inline ChannelBan ( void ) : KeyedList<UHOSTLEN> () {
      who[0] = 0;
      timer = 0;
   }
   ChannelBan ( Channel3 *, const char *, const char *,int = 0 );
   ~ChannelBan ( void );
   
   int ExpMem ( void );
   DEF_NEXT(ChannelBan);
   MEMORY_TYPE(I->memtype_chaninfo);
   inline time_t Age ( void ) { return G->now - timer; }
   inline time_t Timer ( void ) { return timer; }
   inline void Touch ( void ) { timer = G->now; }
   inline const char * Setter ( void ) { return who; }
   inline ChannelBan * Find (const char * x) { 
      return (ChannelBan *)KeyedList<UHOSTLEN>::Find(x);
   }
};
#endif
