/*
 * ChannelSettingsChanmode.h
 */

#ifndef _CHANNELSETTINGS_
#include "ChannelSettings.h"
#endif

#ifndef _CHANNELSETTINGSCHANMODE_
#define _CHANNELSETTINGSCHANMODE_

class ChannelSettingsChanmode : public ChannelSettings {
  protected:
   int pls_prot;        /* modes to enforce */
   int mns_prot;        /* modes to reject */
   int limit_prot;           /* desired limit */
   char key_prot[121];       /* desired key */
   char pass_prot[121];      /* desired password */
   friend ModuleEntryIrc;
   
   inline ChannelSettingsChanmode ( Channel2 * c, ChannelSettings * m ) 
     : ChannelSettings ( c, m ) {
	pls_prot = CHANTOPIC|CHANNOMSG;
	mns_prot = CHANKEY|CHANLIMIT|CHANSEC|CHANINV;
	limit_prot = -1;
	key_prot[0] = 0;
     }
   ChannelSettingsChanmode ( ModuleEntry * );
   ~ChannelSettingsChanmode ( void );
  public:
   void GetModeProtect (char *, int = 1);
   
   int ExpMem ( void );
   int Set (const char *, const char *, Socket *);
   void View (Socket *);
   int Write (FILE *);
   int Get (ScriptContext *);
   void Create (Channel2 *);
   
   inline int Plus ( void ) { return pls_prot; }
   inline int Minus ( void ) { return mns_prot; }
   inline int Limit ( void ) { return limit_prot; }
   inline const char * Key ( void ) { return key_prot; }
   inline const char * Pass ( void ) { return pass_prot; }
};

#endif
