/*
 * ChannelSettingsFlags.h
 */

#ifndef _CHANNELSETTINGS_
#include "ChannelSettings.h"
#endif

#ifndef _CHANNEL3_
#include "Channel3.h"
#endif

#ifndef _CHANNELSETTINGSFLAGS_
#define _CHANNELSETTINGSFLAGS_

typedef struct { char * name; int value; int lang; } FLAGTABLE;
extern FLAGTABLE flag_table[];

class ChannelSettingsFlags : public ChannelSettings {
  protected:
   friend ModuleEntryIrc;
   
   inline ChannelSettingsFlags ( Channel2 * c, ChannelSettings * m ) 
     : ChannelSettings ( c, m ) {
	chan->RemStatus (Channel3::CLEARBANS | Channel3::ENFORCEBANS
			 | Channel3::OPONJOIN | Channel3::BITCH
			 | Channel3::REVENGE | Channel3::AUTOVOICE 
			 | Channel3::BOGUS);
	chan->AddStatus (Channel3::DYNAMICBANS | Channel3::GREET | 
			 Channel3::PROTECTOPS | Channel3::LOGSTATUS |
			 Channel3::STOPNETHACK | Channel3::CYCLE | 
			 Channel3::USERBANS);
     }
   ChannelSettingsFlags ( ModuleEntry * m );
   ~ChannelSettingsFlags ( void );
  public:
   int Set (const char *, const char *, Socket *);
   void View (Socket *);
   int Write (FILE *);
   int Get (ScriptContext *);
   void Create (Channel2 *);
   int ExpMem ( void );
};
#endif
