/*
 * ChannelSettingsFlood.C
 */
/*
 * This file is part of the eggdrop 2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ChannelSettingsFlood.h"
#include "ModuleEntryChannels.h"
#include "ScriptContext.h"
#include "Socket.h"
#include "Channel2.h"
#define CLASS "ChannelSettingsFlood"

ChannelSettingsFlood::ChannelSettingsFlood ( ModuleEntry * m ) 
: ChannelSettings ( m ) {
   FUNCTION;
   Channel2 * ptr = chan;
   
   pub_thr = pub_time = ctcp_thr = ctcp_time = join_thr = join_time = 0;
   kick_thr = kick_time = deop_thr = deop_time = 0;
   while ((ptr = ptr->Next()))
     Create ( ptr );
}

ChannelSettingsFlood::~ChannelSettingsFlood ( void ) {
   FUNCTION;
}

int ChannelSettingsFlood::Set (const char * arg, const char * arg2, Socket *) {
   FUNCTION;
   if (!strncmp(arg, "flood-", 6)) {
      int * pthr = 0, * ptime;
      char * p;
      
      if (!arg2 || !arg2[0])
	return -1;
      
      if (!strcmp(arg + 6,"chan")) {
	 pthr = &pub_thr;
	 ptime = &pub_time;
      } else if (!strcmp(arg + 6,"join")) {
	 pthr = &join_thr;
	 ptime = &join_time;
      } else if (!strcmp(arg + 6,"ctcp")) {
	 pthr = &ctcp_thr;
	 ptime = &ctcp_time;
      } else if (!strcmp(arg + 6,"kick")) {
	 pthr = &kick_thr;
	 ptime = &kick_time;
      } else if (!strcmp(arg + 6,"deop")) {
	 pthr = &deop_thr;
	 ptime = &deop_time;
      } else 
	return -1;
      if ((p = strchr(arg2, ':'))) {
	 *p ++ = 0;
	 *pthr = atoi(arg2);
	 *ptime = atoi(p);
	 *--p = ':';
      } else {
	 *pthr = atoi(arg2);
	 *ptime = 1;
      }
      return 2;
   }
   return 0;
}
	 
void ChannelSettingsFlood::View (Socket * idx) {
   FUNCTION;
   idx->Send(CHNS->Lang( 0x06C, ""));
   idx->Send(CHNS->Lang( 0x06D, "33333", pub_thr, ctcp_thr, join_thr,
				  kick_thr, deop_thr));
   idx->Send(CHNS->Lang( 0x06E, "33333", pub_time, ctcp_time, join_time,
				  kick_time, deop_time));
}

int ChannelSettingsFlood::Get ( ScriptContext * sc) {
   FUNCTION;
   const char * list[6];
   char nums[6][64];
   int i;
   
   list[0] = "flood";
   for (i = 1; i < 6; i++)
     list[i] = nums[i];
   G->SPrintF(nums[1], 63, "%d:%d", pub_thr, pub_time);
   G->SPrintF(nums[2], 63, "%d:%d", ctcp_thr, ctcp_time);
   G->SPrintF(nums[3], 63, "%d:%d", join_thr, join_time);
   G->SPrintF(nums[4], 63, "%d:%d", kick_thr, kick_time);
   G->SPrintF(nums[5], 63, "%d:%d", deop_thr, deop_time);
   sc->AppendArray(6, list);
   return SCRIPT_OK;
}

int ChannelSettingsFlood::Write ( FILE * f) {
   FUNCTION;
   fprintf(f, "channel set %s flood-chan %d:%d flood-ctcp %d:%d ",
	   chan->Key(), pub_thr, pub_time, ctcp_thr, ctcp_time);
   return fprintf(f, "flood-join %d:%d flood-kick %d:%d flood-deop %d:%d\n",
		  join_thr, join_time, kick_thr, kick_time, deop_thr, deop_time);
}

int ChannelSettingsFlood::ExpMem ( void ) {
   FUNCTION;
   return sizeof(ChannelSettingsFlood);
}

void ChannelSettingsFlood::Create ( Channel2 * ch ) {
   FUNCTION;
   NEW ( ChannelSettingsFlood ( ch, this ) );
}
