/*
 * ChannelSettingsIdle.C
 */
/*
 * This file is part of the eggdrop 2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ChannelSettingsIdle.h"
#include "ModuleEntryChannels.h"
#include "ScriptContext.h"
#include "Socket.h"
#include "Channel2.h"
#define CLASS "ChannelSettingsIdle"

ChannelSettingsIdle::ChannelSettingsIdle ( ModuleEntry * m ) 
: ChannelSettings ( m ) {
   FUNCTION;
   Channel2 * ptr = chan;
   
   idle = 0;
   while ((ptr = ptr->Next()))
     Create(ptr);
}

ChannelSettingsIdle::~ChannelSettingsIdle ( void ) {
   FUNCTION;
}

int ChannelSettingsIdle::Set (const char * arg, const char * arg2, Socket *) {
   FUNCTION;
   long l;
   
   if (!strcmp(arg, "dont-idle-kick")) {
      idle = 0;
      return 1;
   } else if (!strcmp(arg, "idle-kick")) {
      if (!arg2 || !arg2[0] || ((l = atoi(arg2)) < 0))
	return -1;
      idle = l;
      return 2;
   }
   return 0;
}
	 
int ChannelSettingsIdle::Get ( ScriptContext * sc ) {
   FUNCTION;
   const char * list[2];
   
   list[0] = "idle";
   list[1] = G->ToBase10(idle);
   sc->SetArray(2, list);
   return SCRIPT_OK;
}

int ChannelSettingsIdle::Write ( FILE * f ) {
   FUNCTION;
   return fprintf(f, "channel set %s idle-kick %lu\n", chan->Key(), idle);
}

void ChannelSettingsIdle::View (Socket * idx) {
   FUNCTION;
   idx->Send(CHNS->Lang( idle ? 0x070 : 0x071, "l", idle));
}

int ChannelSettingsIdle::ExpMem ( void ) {
   FUNCTION;
   return sizeof(ChannelSettingsIdle);
}

void ChannelSettingsIdle::Create ( Channel2 * ch ) {
   FUNCTION;
   NEW ( ChannelSettingsIdle ( ch, this ) );
}
