/*
 * ModuleEntryIrc.h
 */

#ifndef _MODULEENTRY_
#include "ModuleEntry.h"
#endif

#ifndef _IRCMODULE_
#include "irc.h"
#endif

#ifndef _MODULEENTRYIRC_
#define _MODULEENTRYIRC_

class ModuleEntryIrc : public ModuleEntry {
  public:
   BindTable * bt_splt;
   BindTable * bt_rejn;
   BindTable * bt_nick;
   BindTable * bt_sign;
   BindTable * bt_join;
   BindTable * bt_part;
   BindTable * bt_mode;
   BindTable * bt_kick;
   BindTable * bt_pubm;
   BindTable * bt_pub;
   BindTable * bt_topc;
   BindTable * bt_need;
   MemType * memtype_chaninfo;
   class ChannelMember * null_member;
   class ChannelSettings * CHANSET_FLOOD;
   class ChannelSettings * CHANSET_CHANMODE;
   class ChannelSettings * CHANSET_IDLE;
   class ChannelSettings * CHANSET_FLAGS;
   class ModuleEntryChannels * CHANNELS;
   class ModuleEntryServer * SERVER;
   LogModes LOG_JOIN;
   LogModes LOG_MODES;
   LogModes LOG_PUBLIC;
   int modesperline;
   int mode_buf_len;
   int invite_key;
   int reversing;
   int bounce_bans;
   int wait_split; /* = 300,*/
   int learn_users; /* = 0; */
   int wait_info; /* = 15; */
   
   ModuleEntryIrc ( ModuleEntry *, char ** );
   ~ModuleEntryIrc ( void );
   
   int ExpMem ( void );
   void Report ( Socket *, int );
};
#endif
