/*
 * ModuleEntryLedit.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ModuleEntryLedit.h"
#include "HelpReference.h"
#define CLASS "ModuleEntryLedit"

static Version ledit_ver, required_eggdrop;
static struct patches ledit_patches[] = {
#include "patch.h"
};

ModuleEntryLedit::ModuleEntryLedit ( ModuleEntry * o, char ** r )
: ModuleEntry ( "ledit", ledit_ver.Set(2,0), ledit_patches, o) {
   FUNCTION;
   if (!Depend("eggdrop", required_eggdrop.Set(2,0)))
     *r = "Your eggdrop core is too old.";
   else {
      NEW ( HelpReference ( "ledit.help" ) );
      DCC_LEDIT = "LEDIT";
   }
}
			   
ModuleEntryLedit::~ModuleEntryLedit ( void ) {
   FUNCTION;
}

int ModuleEntryLedit::ExpMem ( void ) {
   FUNCTION;
   return ModuleEntry::ExpMem () + sizeof(ModuleEntryLedit);
}
