/*
 * ledit.c
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ModuleEntryLedit.h"
#include "DccLedit.h"
#include "BindTable.h"
#define CLASS ""

ModuleEntryLedit * LE;
static ModuleEntryEggdrop * G;

static BindReturn cmd_ledit (void ** args, const char *) {
   FUNCTION;
   DccChat * idx = (DccChat *)args[0];
   char * par = (char *)args[1], * filename;
   
   context;
   filename = G->Split(&par);
   if (!filename[0])
      idx->Send(LE->Lang(0x016, "", NULL));
   else {
      G->LOG_CMDS.Put(LE->Lang(0x009, "ss", idx->Nick(), filename));
      idx->CheckChof(LE->Lang(0x001, "s", filename));
      NEW ( DccLedit ( * idx, (char *)filename ) );
   }
   return EXECUTED;
}

static command_binds mydcc[] = {
   {"ledit", "n", cmd_ledit, 0 },
};

extern "C" {
   char *ledit_start (ModuleEntryEggdrop *, ModuleEntry *);
};

char *ledit_start (ModuleEntryEggdrop * GG, ModuleEntry * me) {
   FUNCTION;
   char * r = 0;
   
   G = GG;
   context;
   LE = NEW ( ModuleEntryLedit ( me, &r ) );
   if (!r) {
      G->bt_dcc->AddBinds(mydcc, 1, LE);
   }
   return r;
}
