/* 
 * ModuleEntryRealay.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ModuleEntryRelay.h"
#include "HelpReference.h"
#include "Relay.h"
#define CLASS "ModuleEntryRelay"

static Version relay_version, required_botnet;
static struct patches relay_patches [] = {
#include "patch.h"
};

ModuleEntryRelay::ModuleEntryRelay ( ModuleEntry * old, char ** r)
: ModuleEntry ("relay", relay_version.Set(2,0), relay_patches, old) {
   FUNCTION;
   RLY = this;
   if (!(BOTNET = (ModuleEntryBotnet *)
	 Depend("botnet", required_botnet.Set(2,0))))
     *r = "You need the botnet module to use this module";
   else {
      RELAY = "RELAY";
      RELAYING = "RELAYING";
      NEW ( HelpReference("relay.help", this) );
   }
}

ModuleEntryRelay::~ModuleEntryRelay ( void ) {
   FUNCTION;
   Relay * ptr, *old = (Relay *)G->socklist;
   
   context;
   G->LOG_MISC.Put(Lang(0x020, ""));
   while ((ptr = old->Next())) {
      ptr->Eof();
      if (ptr->Flags() & Socket::NONSOCK) {
	 DELETE ( ptr );
      } else 
	old = ptr;
   }
}

int ModuleEntryRelay::ExpMem ( void ) {
   FUNCTION;
   return sizeof(ModuleEntryRelay) + ModuleEntry::ExpMem ( );
}
