/* 
 * relay.c -- handles:
 * relaying to another bot
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "botnet.h"
#include "Relay.h"
#include "Relaying.h"
#include "DccChat.h"
#include "UserRecord.h"
#include "BindTable.h"
#include "UserEntryBotaddr.h"
#include "ModuleEntryBotnet.h"
#define CLASS ""

ModuleEntryRelay * RLY;
static ModuleEntryEggdrop * G;

static BindReturn cmd_relay (void ** args, const char *) {
   FUNCTION;
   DccChat * idx = (DccChat *)args[0];
   Relay * ridx = 0;
   Relaying * tidx = 0;
   char * par = (char *)args[1], * par1 = G->Split(&par);
   char * par2 = G->Split(&par);
   const char * host = 0;
   int lang = 0, port = 0;
   
   if (!par1[0] || par[0]) 
     lang = 0x007;
   else {
      UserRecord * u;
      UserEntryBotaddr * bi;
      FlagRecord fr;
      
      G->LOG_CMDS.Put(RLY->Lang(par2[0] ? 0x022 : 0x021, "sss", idx->Nick(),
				par1, par2));
      context;
      if (par2[0]) {
	 host = par1;
	 port = atoi(par2);
      } else {
	 u = G->userlist->Find(par1);
	 if (!u || !fr.Set(u)->GlobBot())
	   lang = 0x008;
	 else if (!strcasecmp(par1, G->botnetnick))
	   lang = 0x009;
	 else if (!(bi = (UserEntryBotaddr *)
		    u->FindEntry(RLY->BOTNET->entrytype_botaddr))) {
	    idx->Send(RLY->Lang(0x00A, "s" ,par1));
	    lang = 0x00B;
	 } else if (G->dcc_total == G->max_dcc)
	      lang = 0x00C;
	 else {
	    host = bi->Value();
	    port = bi->Relay();
	 }
      }
      if (!lang) {
	 idx->Send(RLY->Lang(0x00D, "sd", host, port));
	 idx->Send(RLY->Lang(0x00E, ""));
	 if (!(ridx = NEW ( Relay ( idx, host, port))))
	   lang = 0x00F;
	 else {
	    tidx = ridx->RelayPtr();
	    if (ridx->Scan(port + G->port_range))
	      ridx->Eof();
	    else 
	      tidx->Redo(ridx);
	 }
      }
   }
   if (lang)
     idx->Send(RLY->Lang(lang, "ss", par1, par2));
   return EXECUTED;
}

static command_binds mydcc[] = {
     {"relay", "t", cmd_relay, 0 },
};

extern "C" {
   char *relay_start (ModuleEntryEggdrop *, ModuleEntry *);
};

char *relay_start (ModuleEntryEggdrop * global_funcs, ModuleEntry * me) {
   FUNCTION;
   char * r = 0;
   
   G = global_funcs;
   context;
   NEW ( ModuleEntryRelay ( me, &r ) );
   if (!r)
     G->bt_dcc->AddBinds(mydcc,1, RLY);
   return r;
}
