/*
 * ModuleEntryScriptsock.C
 */
/*
 * This file is part of the eggdrop 2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ModuleEntryScriptsock.h"
#include "ScriptSocket.h"
#define CLASS "ModuleEntryScriptsock"

static Version scriptsock_version, required_eggdrop;
static struct patches scriptsock_patches[] = {
#include "patch.h"
};

ModuleEntryScriptsock::ModuleEntryScriptsock ( ModuleEntry * old, char ** r )
: ModuleEntry ("scriptsock", scriptsock_version.Set(2,0), scriptsock_patches, old) {
   FUNCTION;
   SS = this;
   if (!Depend("eggdrop", required_eggdrop.Set(2,0)))
     *r = "Your eggdrop core version is incompatible";
   else       
     SCRIPT_SOCKET = "SCRIPTSOCK";
}

ModuleEntryScriptsock::~ModuleEntryScriptsock ( void ) {
   FUNCTION;
   Socket * idx = G->socklist, *idx2;
   
   G->LOG_MISC.Put(SS->Lang( 0x00F, ""));
   while ((idx2 = idx->Next())) {
      if (idx->Type() == SCRIPT_SOCKET) {
	 if (((ScriptSocket *)idx)->Back())
	   ((ScriptSocket *)idx)->DropBack();
	 DELETE ( idx2 );
      } else
	idx = idx2;
   }
}

int ModuleEntryScriptsock::ExpMem ( void ) {
   FUNCTION;
   return sizeof(ModuleEntryScriptsock) + ModuleEntry::ExpMem ( );
}
