/*
 * ChannelSettingsSeen.C
 */
/*
 * This file is part of the eggdrop 2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ChannelSettingsSeen.h"
#include "ScriptContext.h"
#include "Socket.h"
#include "Channel2.h"
#include "ModuleEntrySeen.h"
#define CLASS "ChannelSettingsSeen"

ChannelSettingsSeen::ChannelSettingsSeen ( ModuleEntry * m ) 
: ChannelSettings ( m ) {
   FUNCTION;
   Channel2 * ptr = (Channel2 *)G->chanset;
   
   while ((ptr = ptr->Next()))
     Create(ptr);
}

ChannelSettingsSeen::~ChannelSettingsSeen ( void ) {
   FUNCTION;
}

int ChannelSettingsSeen::Set (const char * arg, const char *, Socket *) {
   FUNCTION;
   if (((arg[0] == '+') || (arg[0] == '-')) && !strcmp(arg + 1, "seen")) {
      flag = (arg[0] == '+');
      return 1;
   }
   return 0;
}
	 
int ChannelSettingsSeen::Get ( ScriptContext * sc) {
   FUNCTION;
   sc->SetString(flag ? "+seen" : "-seen");
   return SCRIPT_OK;
}

int ChannelSettingsSeen::Write ( FILE * f ) {
   FUNCTION;
   return fprintf(f, "channel set %s %sseen\n", chan->Key(),flag ? "+" : "-");
}

void ChannelSettingsSeen::View (Socket * idx) {
   FUNCTION;
   idx->Send(SEEN->Lang(0x02C, "c", flag ? '+' : '-'));
}

int ChannelSettingsSeen::ExpMem ( void ) {
   FUNCTION;
   return sizeof(ChannelSettingsSeen);
}

void ChannelSettingsSeen::Create ( Channel2 * ch ) {
   FUNCTION;
   NEW ( ChannelSettingsSeen ( ch, this ) );
}
