/*
 * ModuleEntrySeen.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ModuleEntrySeen.h"
#include "IntegerVariable.h"
#include "HelpReference.h"
#include "ChannelSettingsSeen.h"
#define CLASS "ModuleEntrySeen"

/* version info */
static Version seen_ver, required_eggdrop;
static struct patches seen_patches[] = {
#include "patch.h"
};

ModuleEntrySeen::ModuleEntrySeen ( ModuleEntry * o, char ** r )
: ModuleEntry ( "seen", seen_ver.Set(2,0), seen_patches, o ) {
   FUNCTION;
   SEEN = this;
   if (!Depend("eggdrop", required_eggdrop.Set(2,0)))
     *r = "Your eggdrop core version is incompatible";
   else {
      NEW ( HelpReference("seen.help", this) );
      display_bots = 0;
      NEW ( IntegerVariable ("display_bots", &display_bots, 0, this));
   }
}

ModuleEntrySeen::~ModuleEntrySeen ( void ) {
   FUNCTION;
}

int ModuleEntrySeen::ExpMem ( void ) {
   FUNCTION;
   return ModuleEntry::ExpMem() + sizeof(ModuleEntrySeen);
}
