/*
 * BindTableCtcpr.C -- member functions for the BindTableCtcpr class
*/
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
*/

#include "BindTableCtcpr.h"
#include "UserRecord.h"
#include "ScriptArgument.h"
#include "ScriptContext.h"
#include "BoundCommand.h"
#define CLASS "BindTableCtcpr"

BindTableCtcpr::~BindTableCtcpr ( void ) {
   FUNCTION;
}

BindReturn BindTableCtcpr::ToScript (BindEntry * be, void ** args, const char * mask) {
   FUNCTION;
   UserRecord * u = (UserRecord *)args[2];

   return be->Call(mask, 6, args[0], args[1], u ? u->Handle() : "*", args[3],
		   args[4], args[5]);
}

int BindTableCtcpr::FromScript (BoundCommand * bc, ScriptContext * sc, int argc,
				ScriptArgument ** argv) {
   FUNCTION;
   void * args[6];
   
   BADARGS(7, 7, mod->Lang(0x026, ""));
   args[0] = (void *)argv[1]->AsString();
   args[1] = (void *)argv[2]->AsString();
   args[2] = G->userlist->Find(argv[3]->AsString());
   args[3] = (void *)argv[4]->AsString();
   args[4] = (void *)argv[5]->AsString();
   args[5] = (void *)argv[6]->AsString();
   sc->SetString(bc->Call(args, argv[0]->AsString()) == EXEC_LOG ? "1" : "0");
   return SCRIPT_OK;
}
