/*
 * BindTableFlud.C -- member functions for the BindTableFlud class
*/
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
*/

#include "BindTableFlud.h"
#include "UserRecord.h"
#include "ScriptContext.h"
#include "ScriptArgument.h"
#include "Channel.h"
#include "BoundCommand.h"
#define CLASS "BindTableFlud"

BindTableFlud::~BindTableFlud ( void ) {
   FUNCTION;
}

BindReturn BindTableFlud::ToScript (BindEntry * be,void ** args, const char * mask) {
   FUNCTION;
   UserRecord * u = (UserRecord *)args[3];
   Channel * c = (Channel *)args[5];

   return be->Call(mask, 5, args[1], args[2], u ? u->Handle() : "*",
		   args[3], c ? c->Key() : "*");
}

int BindTableFlud::FromScript (BoundCommand * bc, ScriptContext * sc, int argc,
			       ScriptArgument ** argv) {
   FUNCTION;
   void * args[5];
   
   BADARGS(6, 6, mod->Lang(0x027, ""));
   args[0] = (void *)argv[1]->AsString();
   args[1] = (void *)argv[2]->AsString();
   args[2] = G->userlist->Find(argv[3]->AsString());
   args[3] = (void *)argv[4]->AsString();
   args[4] = 0;
   if ((argv[5]->AsString()[0] != '*')
       && !(args[4] = G->chanset->Find(argv[5]->AsString()))) {
      sc->SetString(mod->Lang(0x028, ""));
      return SCRIPT_ERROR;
   }
   sc->SetString(bc->Call(args, argv[0]->AsString()) == EXEC_LOG ? "1" : "0");
   return SCRIPT_OK;
}
