/*
 * BindTableMsg.C -- member functions for the BindTableMsg class
*/
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
*/

#include "BindTableMsg.h"
#include "UserRecord.h"
#include "ScriptContext.h"
#include "ScriptArgument.h"
#include "BoundCommand.h"
#define CLASS "BindTableMsg"

BindTableMsg::~BindTableMsg ( void ) {
   FUNCTION;
}

BindReturn BindTableMsg::ToScript (BindEntry * be, void ** argv, const char * mask) {
   FUNCTION;
   UserRecord * u = (UserRecord *)argv[2];

   return be->Call(mask, 4, argv[0], argv[1], u ? u->Handle() : "*", argv[3]);
}

int BindTableMsg::FromScript (BoundCommand * bc, ScriptContext * sc, int argc,
			      ScriptArgument ** argv) {
   FUNCTION;
   void * args[4];
    
   BADARGS(5, 5, mod->Lang(0x025, ""));
   args[0] = (void *)argv[1]->AsString();
   args[1] = (void *)argv[2]->AsString();
   args[2] = G->userlist->Find(argv[3]->AsString());
   args[3] = (void *)argv[4]->AsString();
   bc->Call(args,argv[0]->AsString() + 5);
   return SCRIPT_OK;
}
