/*
 * BindTableWall.C -- member functions for the BindTableWall class
*/
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
*/

#include "BindTableWall.h"
#include "ScriptContext.h"
#include "ScriptArgument.h"
#include "BoundCommand.h"
#define CLASS "BindTableWall"

BindTableWall::~BindTableWall ( void ) {
   FUNCTION;
}

BindReturn BindTableWall::ToScript (BindEntry *be, void ** args, const char * mask) {
   FUNCTION;
   return be->Call(mask, 2, args[0], args[1]);
}

int BindTableWall::FromScript (BoundCommand * bc, ScriptContext * sc, int argc,
			       ScriptArgument ** argv) {
   FUNCTION;
   void * args[2];
   
   BADARGS(3, 3, mod->Lang(0x029, ""));
   args[0] = (void *)argv[1]->AsString();
   args[1] = (void *)argv[2]->AsString();
   bc->Call(args, argv[0]->AsString() + 4);
   return SCRIPT_OK;
}
