/*
 * IrcNick.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "server.h"
#include "IrcNick.h"
#include "ModuleEntryServer.h"
#include "ScriptArgument.h"
#define CLASS "IrcNick"

IrcNick::~IrcNick ( void ) {
   FUNCTION;
}
   
char * IrcNick::Read ( ScriptContext *, int, ScriptArgument ** ) {
   FUNCTION;
   return G->origbotname;
}

char * IrcNick::Clear ( ScriptContext *, int, ScriptArgument ** ) {
   FUNCTION;
   return G->origbotname;
}

char * IrcNick::Set ( ScriptContext *, int, ScriptArgument ** argv) {
   FUNCTION;
   const char * newnick = argv[0]->AsString();
   
   if (strcasecmp(G->origbotname, newnick)) {
      if (G->origbotname[0])
	G->LOG_MISC.Put( 0, "* IRC NICK CHANGE: %s -> %s", G->origbotname, newnick);
      strncpyz(G->origbotname, newnick, NICKMAX);
      strncpyz(SVR->newbotname, SVR->botname,NICKMAX);	 
      strncpyz(SVR->botname, G->origbotname,NICKMAX);
      if (SVR->server_online)
	SVR->SendNick(newnick);
   }
   return 0;
}
