/*
 * ModuleEntryServer.h
 */

#ifndef _MODULEENTRY_
#include "ModuleEntry.h"
#endif

#ifndef _SERVERMODULE_
#include "server.h"
#endif

#ifndef _MODULEENTRYSERVER_
#define _MODULEENTRYSERVER_

class ModuleEntryServer : public ModuleEntry {
  public:
   class Server * serv_sock;
   ServerList * serverlist;
   ServerList * curserv;
   const char * SERVER;
   char botname[NICKMAX+1];
   char altnick[NICKMAX + 1];
   char newbotname[NICKMAX + 1];
   char botuserhost[UHOSTLEN+1];
   char oldnick[NICKMAX + 1];
   char bothost[81];
   char newserver[121];
   char newserverpass[121];
   char botrealname [121];
   char ctcp_reply[512];
   int strict_host;
   int keepnick;
   int check_stoned;
   int serverror_quit;
   int check_mode_r;
   int quiet_reject;
   int serv;
   int flood_thr;
   int flood_time;
   int flood_ctcp_thr;
   int flood_ctcp_time;
   int answer_ctcp;
   int trigger_on_ignore;
   int newserverport;
   int cycle_time;
   int default_port;
   int server_online;
   int min_servs;
   int ctcp_reply_len;
   int use_354;
   int maxqmsg;
   int server_lag;
   int never_give_up;
   int waiting_for_awake;
   int server_cycle_wait;
   int use_silence;
   int strict_servernames;
   int lowercase_ctcp;
   int burst;
   int use_ts4;
   int cookie_expire;
   int use_ison;
   time_t last_time;
   time_t server_timeout;
   time_t trying_server;
   BindTable * bt_raw;
   BindTable * bt_wall;
   BindTable * bt_msg;
   BindTable * bt_msgm;
   BindTable * bt_notc;
   BindTable * bt_flud;
   BindTable * bt_ctcp;
   BindTable * bt_ctcr;
   BindTable * bt_initsvr;
   MemType * memtype_server;
   LogModes LOG_SERV;
   LogModes LOG_MSGS;
   ServerHeads * queues[3];

   ModuleEntryServer ( ModuleEntry *, ModuleEntryEggdrop *, char ** );
   ~ModuleEntryServer ( void );

   void Report ( Socket *, int );
   int ExpMem ( void );
   
   void GetMyHostname (char * );
   void PostRehash ( void );
   void FiveMins ( void );
   void DeqMsg ( void );
   void ShowHelp (const char *, char *, FlagRecord *, int );
   
   virtual int MatchMyNick (const char *);
   virtual void FixFrom (char *);
   virtual BindReturn CheckCtcpr (char*,char*,UserRecord *,char *,char*,char*,BindTable *);
   virtual int DetectAvalanche (char *);
   virtual void NukeServer (char *);
   virtual void SendMode (int, const char *, const char *);
   virtual void SendJoin (int, const char *, const char *);
   virtual void SendPart (int, const char *, char *);
   virtual void SendKick (int, const char *, const char *, const char *);
   virtual void SendNotice (int, const char *, char *);
   virtual void SendWho (int, const char *);
   virtual void SendTopic (int, const char *, char *);
   virtual void SendMsg (int, const char *, char *);
   virtual void SendAct (int, const char *, char *);
   virtual void SendInvite (int, const char *, const char *);
   virtual void SendUnSilence (int, char *);
   virtual void SendSilence (int, char *);
   virtual void SendLusers (void);
   virtual void SendNick ( const char * );
   virtual void QueueServer (int, char *, int);
};

inline char * FixColon(char * x) {
   return (x[0] == ':') ? x + 1 : List::G->Split(&x);
}
#endif
