/*
 * ServerHeads.C
 */
/*
 * This file is part of the eggdrop 2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ServerHeads.h"
#define CLASS "ServerHeads"

ServerHeads::~ServerHeads ( void ) {
   FUNCTION;
}

int ServerHeads::ExpMem ( void ) {
   FUNCTION;
   return sizeof(ServerHeads) + head.ExpMem() - sizeof(ServerQueue);
}

void ServerHeads::Queue (char * buf, int len) {
   FUNCTION;
   if (tot < SVR->maxqmsg) {
      last = NEW ( ServerQueue ( *last, buf, len ) );
      tot++;
   } else if (!warned) 
	List::G->LOG_MISC.Put( SVR->Lang(0x06B + which, ""));
   else
     warned = 1;
   if (List::G->debug_output) {
      LogModes LOG_SRVOUT ( LogModes::SRVOUT );
      if (buf[len-1] == '\n')
	buf[len-1] = 0;
      LOG_SRVOUT.Put(SVR->Lang(0x06E + which, "s", buf));
   }
   if (!which && !SVR->trying_server)
     SVR->DeqMsg(); /* DP_MODE needs to be ASAP, flush if possible */
}

int ServerHeads::Flush ( Socket * ptr, int l ) {
   FUNCTION;
   int r = head.Flush(l, ptr);
   
   if (!head.Next()) 
     last = &head;
   tot -= r;
   return r;
}

void ServerHeads::Empty ( void ) {
   FUNCTION;
   ServerQueue * sq;
   
   while ((sq = (ServerQueue *)head.Next())) {
      head.Remove(sq);
      DELETE ( sq );
   }
   tot = 0;
   last = &head;
}	 
