/*
 * ServerList.h
 */

#ifndef _KEYEDLIST_
#include "KeyedList.h"
#endif

#ifndef _SERVERMODULE_
#include "server.h"
#endif

#ifndef _MODULEENTRYSERVER_
#include "ModuleEntryServer.h"
#endif

#ifndef _SERVERLIST_
#define _SERVERLIST_

class ServerList : public KeyedList<UHOSTLEN> {
  protected:
   int port;
   char * pass;
   char * realname;
   char * cookie;
   time_t cookie_time;
   
  public:
   inline ServerList ( void ) : KeyedList<UHOSTLEN> ( ) { }
   ServerList ( const char * );
   ~ServerList ( void );

   void SetRealName ( const char * );
   void Dump ( Socket * );
   void Dump ( ScriptContext * );
   int ExpMem ( void );
   virtual void NextServer ( const char *, int, char * );

   void SetCookie ( const char * );

   inline const char * Cookie ( void ) { return cookie; }
   inline time_t CookieAge ( void ) { return G->now - cookie_time; }
   inline int Port ( void ) { return port; }
   inline const char * Pass ( void ) { return safe_str(pass); }
   inline const char * RealName ( void ) { return safe_str(realname); }
   inline ServerList * Next ( void ) { return (ServerList *)next; }
   MEMORY_TYPE(SVR->memtype_server);
};
#endif
