/*
 * Servers.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "server.h"
#include "Servers.h"
#include "ModuleEntryServer.h"
#include "ScriptArgument.h"
#include "Socket.h"
#include "ScriptContext.h"
#include "ServerList.h"
#define CLASS "Servers"

Servers::~Servers ( void ) {
   FUNCTION;
}
   
char * Servers::Read ( ScriptContext * sc, int, ScriptArgument ** ) {
   FUNCTION;
   char *p;
   
   SVR->serverlist->Dump(sc);
   p = (char *)my_malloc(strlen(sc->AsString()) + 1, G->memtype_misc);
   strcpy(p,sc->AsString());
   sc->Clear();
   return p;
} 

char * Servers::Clear ( ScriptContext * a, int b, ScriptArgument ** c) {
   FUNCTION;
   return Read(a,b,c);
}

char * Servers::Set ( ScriptContext *, int argc, ScriptArgument ** argv ) {
   FUNCTION;
   int i;
   
   if (SVR->serverlist) {
      DELETE (SVR->serverlist);
      SVR->serverlist = NEW ( ServerList () );
   }
   if (argc > 50)
     argc = 50;
   for (i = 0; i < argc; i++)
     if (argv[i]->AsString()[0]) 
       NEW ( ServerList (argv[i]->AsString() ) );
   /* tricky way to make the bot reset its server pointers */
   /* perform part of a '.jump <current-server>': */
   if (SVR->server_online) {
      Socket * servidx = G->socklist->Find(SVR->serv);
      if (servidx) 
	SVR->serverlist->NextServer(servidx->Host(), servidx->RemotePort(), "");
   }
   return 0;
}

