/*
 * Sharebot.h
 */

#ifndef _BOT_
#include "Bot.h"
#endif

#ifndef _MODULEENTRYSHARE_
#include "ModuleEntryShare.h"
#endif

#ifndef _SHAREBOT_
#define _SHAREBOT_

class ShareBot : public Bot {
   class ShareQueue * queue;
   time_t queue_age;
   int share_status;
   
   friend class ShareQueue;
   friend class ModuleEntryShare;
  public:
   enum {
      OFFERED    = 0x01,  /* offered her the user file */
	SENDING    = 0x02,  /* in the process of sending a user list */
	GETTING    = 0x04,  /* in the process of getting a user list */
	AGGRESSIVE = 0x08,  /* aggressively sharing with this bot */
   };
   
   ShareBot ( BotLink &, char *);
   ShareBot ( Bot *);
   inline int SetShareStatus ( int x ) { return share_status |= x; }
   ~ShareBot(void);
   void Activity ( char *, int );
   void Display2(Socket *);
   int ExpMem ( void );
   void StartSendingUsers(void);
   void ShareOutBut (Channel2 *, char *, ...);
   void CancelUserXfer(void);
   void DumpResync ( void );
   int FlushResync ( void );
   void NewResync ( void );
   void QueueResync ( Channel2 *, char * );
   int WriteTmpUserfile (char *, int);
   
   inline time_t QueueAge ( void ) { return (queue ? G->now - queue_age : 0); } 
   inline int CanResync ( void ) { return (queue != 0); }
   inline ShareBot * Next ( void ) {
      ShareBot * ptr = this;
      
      while ((ptr = (ShareBot *)ptr->next) && (ptr->Type() != SH->SHAREBOT));
      return ptr;
   }
   inline int ShareStatus ( void ) { return share_status; }
   inline int HasShareStatus ( int x ) { return share_status & x; }
   inline int ClearShareStatus ( int x ) { return share_status &= ~x; }
};
#endif
