/*
 * TclScript.C - code to support TCL Scripting
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ModuleEntryTcl.h"
#include "TclScript.h"
#include "IntegerVariable.h"
#include "Socket.h"
#define CLASS "ModuleEntryTcl"

/* place patche names in here - see patches.h */
static Version tcl_ver, required_eggdrop;
static struct patches tcl_patches[] = {
#include "patch.h"
};

ModuleEntryTcl::ModuleEntryTcl ( ModuleEntry * old, char ** r ) 
: ModuleEntry ("tcl", tcl_ver.Set(2,0), tcl_patches, old) {
   FUNCTION;
     T = this;
   if (!Depend("eggdrop", required_eggdrop.Set(2,0)))
     *r = "You Eggdrop version is incompatible";
   else {
      entry = NEW ( TclScript ( this ) );
      debug_tcl = 0;
      NEW ( IntegerVariable ( "debug_tcl", &debug_tcl, VAR_PROTECT, this ) );
   }
};

ModuleEntryTcl::~ModuleEntryTcl ( void ) {
   FUNCTION;
   context;
   DELETE ( entry );
}

void ModuleEntryTcl::Report ( Socket * idx, int ) {
   FUNCTION;
   char buf[512];
   
   strcpy(buf, "info library");
   if (Tcl_Eval(entry->Interp(), buf) == TCL_OK)
     idx->Printf("Using TCL library: %s\n",entry->Interp()->result);
}

int ModuleEntryTcl::ExpMem ( void ) {
   FUNCTION;
   return sizeof(ModuleEntryTcl) + ModuleEntry::ExpMem ( );
}
