/*
 * TclScript.C - code to support TCL Scripting
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#define MAKING_TCL
#include "Socket.h"
#include "TclScript.h"
#include "ScriptArgument.h"
#include "Version.h"
#include "ModuleEntryTcl.h"
#include "BindTable.h"
#include "Command.h"
#define CLASS ""

static ModuleEntryEggdrop * G;
ModuleEntryTcl * T;

static int script_tcl (ScriptContext * sc, int argc, ScriptArgument ** argv) {
   FUNCTION;
   int ret;
   
   BADARGS(2, 2, " ?command?");
   ret = T->entry->Evaluate(argv[1]->AsString(), 0);
   sc->SetString(T->entry->AsString());
   return ret;
}

static BindReturn cmd_tcl (void ** args, const char *) {
   FUNCTION;
   char * msg = (char *)args[1];
   Socket * idx = (Socket *)args[0];
   int result;
   
   G->LOG_CMDS.Put(T->Lang (0x003, "ss", idx->Nick(), msg));
   Tcl_SetVar(T->entry->Interp(), "tcl_interactive", "0", TCL_GLOBAL_ONLY);
   result = Tcl_GlobalEval(T->entry->Interp(), msg);
   idx->DumpLots(T->Lang ((result == TCL_OK) ? 0x001 : 0x002, ""), 
		 T->entry->Interp()->result);
   return EXECUTED;
}

static command_binds mycmd[] = {
   {"tcl", "n", cmd_tcl, NULL},
};

extern "C" {
   char *tcl_start (ModuleEntryEggdrop *, ModuleEntry *);
};

char *tcl_start (ModuleEntryEggdrop * global_funcs, ModuleEntry * me) {
   FUNCTION;
   char * r = 0;
   G = global_funcs;
   context;
   T = NEW ( ModuleEntryTcl ( me, & r ) );
   if (!r) {
      G->bt_dcc->AddBinds(mycmd, 1, T );
      NEW ( Command ( "tcl", script_tcl, T) );
   }
   return r;
}
