/*
 * Timer.h
 */

#ifndef _INTLIST_
#include "IntList.h"
#endif

#ifndef _MODULEENTRYTIMERS_
#include "ModuleEntryTimers.h"
#endif

#ifndef _TIMER_
#define _TIMER_
class Timer : public IntList {
  protected:
   unsigned int length;
   void (*func) (int, char *);
   char * extra;
   ScriptContext * sc;
   static int next_timer;
   
  public:
   inline Timer ( void ) : IntList () {}
   Timer ( enum TimerStack, int, ScriptContext *, 
	  void (*)(int, char *), const char *, ModuleEntry *);
   ~Timer ( void );
   
   int ExpMem ( void );
   
   void Check ( void );
   
   MEMORY_TYPE(TM->memtype_timer);
   DEF_NEXT(Timer);
   inline int ToGo ( void ) { return length; }
   inline int HasFunc ( void ) { return func != 0; }
   inline ScriptContext * SC ( void ) { return sc; }
   inline const char * String ( void ) { return extra; }
};
#endif
