/*
 * BindTableSentRcvd.C -- member functions for the BindTableSentRcvd class
*/
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
*/

#include "BindTableSentRcvd.h"
#include "FileSend.h"
#include "FileGetListen.h"
#define CLASS "BindTableSentRcvd"

BindTableSentRcvd::~BindTableSentRcvd ( void ) {
   FUNCTION;
}

BindReturn BindTableSentRcvd::ToScript (BindEntry * be, void ** args, const char * mask) {
   FUNCTION;
   FileSend * idx = (FileSend *)args[0];
   char nfn[DIRLEN+1];
   
   if (idx->Flags() & Socket::LISTENING) {
      FileGetListen * idx2 = (FileGetListen *)args[0];
      
      return be->Call(mask, 3, idx2->From(), idx2->Nick(), idx2->Filename());
   }
   G->SPrintF(nfn, DIRLEN, "%s%s", idx->Dir(), idx->Filename());
   return be->Call(mask, 3, idx->From(), idx->Nick(), nfn);
}   
