/*
 * FileGetListen.h - a file to a user, waiting for them to connect
 */

#ifndef _LISTENINGSOCKET_
#include "ListeningSocket.h"
#endif

#ifndef _MODULEENTRYTRANSFER_
#include "ModuleEntryTransfer.h"
#endif

#ifndef _FILEGETLISTEN_
#define _FILEGETLISTEN_

class FileGetListen : public ListeningSocket {
   char filename[DIRLEN + 1]; /* filename */
   char from[NICKMAX + 1];    /* nick of user who is getting the file */
   
  public:
   FileGetListen ( const char *, const char *, const char *, const char *);
   ~FileGetListen ( void );
   
   void Activity (char *, int);
   void Display2 ( Socket *);
   void Eof ( void );
   void Timeout ( void );
   void CheckEof ( void );
   virtual Socket * Create ( int );
   int ExpMem ( void );

   inline FileGetListen * Next ( void ) {
      FileGetListen * ptr = this;
      
      while ((ptr = (FileGetListen *)ptr->next) && (ptr->Type() != TR->FILE_LISTEN));
      return ptr;
   }
   inline const char * Filename ( void ) { return filename; }
   inline const char * From ( void ) { return from; }
};
#endif
