/*
 * FileQueue.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "FileQueue.h"
#define CLASS "FileQueue"

FileQueue::FileQueue (const char * d, const char * f, const char * fr,
		      const char * t)
: KeyedList<NICKMAX> ( *TR->fileq, t, KeyedList<NICKMAX>::APPEND ) {
   FUNCTION;
   dir = (char *) my_malloc(strlen(d) + 1,TR->memtype_fileq);
   file = (char *) my_malloc(strlen(f) + 1,TR->memtype_fileq);
   strcpy(dir, d);
   strcpy(file, f);
   strncpyz(from, fr, NICKMAX);
}

FileQueue::~FileQueue ( void ) {
   FUNCTION;
   if (!key[0]) {
      while (next)
	DELETE ( next );
   } else {
      TR->fileq->Remove(this);
      if (dir)
	my_free(dir,TR->memtype_fileq);
      if (file)
	my_free(file,TR->memtype_fileq);
   }
}

int FileQueue::ExpMem (void) {
   FUNCTION;
   FileQueue * ptr = this;
   int tot = sizeof(FileQueue);
   
   context;
   while ((ptr = ptr->Next())) 
     tot += strlen(ptr->dir) + strlen(ptr->file) + 2 + sizeof(FileQueue);
   return tot;
}

void FileQueue::Flush ( const char * x ) {
   FUNCTION;
   FileQueue * ptr = this, *n;
   
   while ((n = ptr->Next())) 
     if (strcasecmp(x, n->Key())) {
	DELETE ( n );
     } else 
     ptr = n;
}
