/* 
 * FileQueue.h
 */

#ifndef _KEYEDLIST_
#include "KeyedList.h"
#endif

#ifndef _MODULEENTRYTRANSFER_
#include "ModuleEntryTransfer.h"
#endif

#ifndef _FILEQUEUE_
#define _FILEQUEUE_

class FileQueue : public KeyedList<NICKMAX> {
  protected:
   char *dir;			/* starts with '*' -> absolute dir */
   char *file;			/*    (otherwise -> dccdir) */
   char from[NICKMAX + 1];		/* who will it be sent to */
   
  public:
   inline FileQueue ( void ) : KeyedList<NICKMAX> ( ) {}
   FileQueue ( const char *, const char *, const char * ,const char *);
   ~FileQueue ( void );
   
   int ExpMem ( void );
   MEMORY_TYPE(TR->memtype_fileq);
   DEF_NEXT(FileQueue);
   
   inline char * Dir ( void ) { return dir; }
   inline const char * File ( void ) { return file; }
   inline const char * From ( void ) { return from; }
   void Flush ( const char * );
};
#endif
