/*
 * FileSend.h - A file being sent to the bot
 */

#ifndef _SOCKET_
#include "Socket.h"
#endif

#ifndef _MODULEENTRYTRANSFER_
#include "ModuleEntryTransfer.h"
#endif

#ifndef _FILESEND_
#define _FILESEND_

class FileSend : public Socket {
  protected:
   FILE *f;		      /* pointer to file being sent/received */
   char filename[DIRLEN + 1]; /* filename */
   char dir[DIRLEN + 1];      /* used when uploads go to the current dir */
   long length;               /* total length */
   char from[NICKMAX + 1];    /* nick of user who offered the file */
   
  public:
   inline FileSend ( int fgs, const char * ntype, int tflags, time_t * tv,
		    int fd, const char * nhost, int rpt) 
     : Socket ( fgs, ntype, tflags, tv, fd, nhost, rpt ) {
	f = 0;
	length = 0;
	filename[0] = 0;
	dir[0] = 0;
	from[0] = 0;
     }
   FileSend ( struct in_addr *, int, const char *, UserRecord *,
	     long, const char *, char *, FILE *);
   ~FileSend ( void );
   
   void Activity ( char *, int );
   void Eof ( void );
   void Timeout ( void );
   int ExpMem ( void );
   void Display2 ( Socket * );
   void CheckEof ( void );
   
   inline const char * Filename ( void ) { return filename; }
   inline const char * Dir ( void ) { return dir; }
   inline const char * From ( void ) { return from; }
   inline int Length ( void ) { return length; }
   inline FileSend * Next ( void ) {
      FileSend * ptr = this;
      
      while ((ptr = (FileSend *)ptr->next) && (ptr->Type() != TR->FILE_SEND));
      return ptr;
   }
};

#endif
