/*
 * ModuleEntryTransfer.h
 */

#ifndef _MODULEENTRY_
#include "ModuleEntry.h"
#endif

#ifndef _MODULEENTRYTRANSFER_
#define _MODULEENTRYTRANSFER_

#define DCCSEND_FULL   -1	/* dcc table is full */
#define DCCSEND_NOSOCK -2	/* can't open a listening socket */
#define DCCSEND_BADFN  -3	/* no such file */

class FileGet;
class FileSend;
class FileGetListen;

class ModuleEntryTransfer : public ModuleEntry {
  public:
   BindTable * bt_rcvd;
   BindTable * bt_sent;
   BindTable * bt_eof;
   LogModes LOG_FILES;
   const char * FILE_SEND;
   const char * FILE_GET;
   const char * FILE_LISTEN;
   int copy_to_tmp;
   int dcc_block;
   int dcc_limit;
   time_t transfer_timeout;
   class ModuleEntryServer * SERVER;
   class FileQueue * fileq;
   MemType * memtype_fileq;
   
   ModuleEntryTransfer ( ModuleEntry *, char ** );
   ~ModuleEntryTransfer ( void );
   
   void Report ( Socket *, int );
   int ExpMem ( void );
   
   virtual int AtLimit (const char *);
   virtual void FileQCancel (Socket *, char *);
   virtual int RawDccSend (char *,const char *,const char *);
   virtual void ShowQueuedFiles (Socket *);
   virtual int WildMatchFile (register unsigned char * m,
			       register unsigned char * n);
   virtual void WipeTmpFilename (const char *,Socket *);
   virtual void SendNextFile (const char *);
};

extern ModuleEntryTransfer * TR;
#endif
