/*
 * ModuleEntryUpdate.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ModuleEntryUpdate.h"
#include "HelpReference.h"
#define CLASS "ModuleEntryUpdate"

/* version info */
static Version update_ver, required_eggdrop;
static struct patches update_patches[] = {
#include "patch.h"
};

ModuleEntryUpdate::ModuleEntryUpdate ( ModuleEntry * o, char ** r )
: ModuleEntry ( "update", update_ver.Set(2,0), update_patches, o ) {
   FUNCTION;
   if (!Depend("eggdrop", required_eggdrop.Set(2,0)))
     *r = "Your eggdrop core version is incompatible";
   else
     NEW ( HelpReference("update.help") );
}

ModuleEntryUpdate::~ModuleEntryUpdate ( void ) {
   FUNCTION;
}

int ModuleEntryUpdate::ExpMem ( void ) {
   FUNCTION;
   return ModuleEntry::ExpMem() + sizeof(ModuleEntryUpdate);
}
