/*
 * update.c:-
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */
/*
 * This module upgrades older userfiles to v5 format.
 * By Ian Kaney (ikaney@uk.defiant.org)
 *
 * If you can understand the code below, you're doing better than I...
 */

#include "ModuleEntryUpdate.h"
#define CLASS ""

static ModuleEntryUpdate * ME;
struct ModuleEntryEggdrop * G;

/* Change this to 1 to convert XTRA fields, but it will still do bugger all */
int convxtra = 0;

static void upgrade_userfilev3 (FILE * f) {
   FUNCTION;
   FILE *f2;
   time_t tt;
   char buf[512], s[512], final[512], *t, *u;
   char host[512], part1[512], part2[512], part3[512], part4[512], part5[512];
   char handle[512], pass[16], flags[128]; /* Just to be on the safe side! eh!? */
   int tmp, pos;
   int written;
   int bans, ignores, sticky;

   G->SPrintF(s, DIRLEN, "%s~new", G->userfile);
   f2 = fopen(s, "w");
   tt = G->now;
   t = buf;
   u = buf;
   bans = 0;
   ignores = 0;
   written = 0;
   fprintf(f2, "#5v: %s -- %s -- written %s", G->VersionStr(), G->origbotname, ctime(&tt));
   while (!(feof(f))) {
   tmp = 0;
   written = 0;
   t = buf;
   u = buf;
      fgets(t,180,f);
         if (!feof(f)) {
	    G->SPrintF(s, 511, "%s", t);
	    if ((s[0] == '!') && (s[1] == '!')) { 
	       bans = 0;
	       ignores = 0;
	       t = t + 10;
	       G->SPrintF(s, 511, "=LASTON %s", t);
	    } else if ((s[0] == ':') && (s[1] == ':')) {
	       bans = 1;
	       ignores = 0;
	       t++;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ' ')
	          pos++;
	       s[pos] = 0;
	       G->SPrintF(s, 511, "%s\n", s);
	    } else if ((s[0] == '*') && (s[1] == 'b')) {
	       bans = 1;
	       ignores = 0;
	       strcpy(s, "*b\n");
	    } else if ((s[0] == '-') && (bans == 1)) {
	       sticky = 0;
	       t = t + 10;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ':') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
	       strcpy(host, s);
	       /* Extracted the host */
	       t++;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ':') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
	       if (strchr(s, '*') != NULL) {
		  sticky = 1;
		  s[(strlen(s)-1)] = 0;
	       }
	       strcpy(part1, s);
	       /* Extracted first part */
	       t++;
	       t++;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ':') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
 	       strcpy(part2, s);
	       /* Extracted second part */
	       t++;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ':') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
 	       strcpy(part3, s);
	       /* Extracted third part */
	       t++;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ':') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
 	       strcpy(part4, s);
	       /* Extracted fourth part */
	       t++;
	       strcpy(s, t);
	       strcpy(part5, s);
	       /* Remove gunk */
	       tmp = 0;
	       while (tmp<=(int)strlen(part5)) {
		  if (part5[tmp] == '~')
		     part5[tmp] = ' ';
		  else if (part5[tmp] == '`')
		     part5[tmp] = ',';
		  tmp++;
	       }
	       /* Slap it together! */
	       if (sticky)
 		  G->SPrintF(s, 511, "-%s %s *%s %s %s %s", host, part1, part2, part3, part4, part5);
	       else
 		  G->SPrintF(s, 511, "-%s %s %s %s %s %s", host, part1, part2, part3, part4, part5);
	    } else if ((s[0] == '*') && (s[1] == 'i')) {
	       bans = 0;
	       ignores = 1;
	       strcpy(s, "*i\n");
	    } else if ((s[0] == '-') && (ignores == 1)) {
	       sticky = 0;
	       t = t + 10;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ':') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
	       strcpy(host, s);
	       /* Extracted the host */
	       t++;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ':') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
	       strcpy(part1, s);
	       /* Extracted first part */
	       t++;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ':') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
 	       strcpy(part2, s);
	       /* Extracted second part */
	       t++;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ':') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
 	       strcpy(part3, s);
	       /* Extracted third part */
	       t++;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ':') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
	       strcpy(part4, s);
	       /* Remove gunk */
	       tmp = 0;
	       while (tmp<=(int)strlen(part4)) {
		  if (part4[tmp] == '~')
		     part4[tmp] = ' ';
		  else if (part4[tmp] == '`')
		     part4[tmp] = ',';
		  tmp++;
	       }
	       /* Slap it together! */
 	       G->SPrintF(s, 511, "-%s %s %s %s %s", host, part1, part2, part3, part4);
            } else if (s[0] == '#') {
	       bans = 0;
	       ignores = 0;
	       /* COMMENT */
	    } else if (s[0] == ';') { 
	       bans = 0;
	       ignores = 0;
	       /* COMMENT */
	    } else if (s[0] == '-') { 
	       written = 1;
	       bans = 0;
	       ignores = 0;
	       t = t + 10;
	       strcpy(s, t);
	       tmp = 0;
	       for (pos = 0 ; pos<(int)strlen(s) ; pos++) {
		  if (s[pos] == ',') {
		     tmp = 1;
		     break;
		  }
		  t++;
	       }
	       if (tmp == 0) {
		  strcpy(host, s);
		  G->SPrintF(s, 511, "=HOSTS %s", host);
		  fputs(s, f2);
	       }
	       if (tmp == 1) {
		  tmp = 0;
		  s[pos] = 0;
		  strcpy(host, s);
		  G->SPrintF(s, 511, "=HOSTS %s\n", host);
		  fputs(s, f2);
		  t++;
		  t++;
		  strcpy(s, t);
		  strcpy(host, s);
		  G->SPrintF(s, 511, "=HOSTS %s", host);
		  fputs(s, f2);
	       }
	    } else if (s[0] == '+') { 
	       bans = 0;
	       ignores = 0;
	       t = t + 10;
	       if (convxtra)
		  G->SPrintF(s, 511, "=XTRA EMAIL %s", t);
	    } else if (s[0] == '*') { 
	       bans = 0;
	       ignores = 0;
	       t = t + 10;
	       G->SPrintF(s, 511, "=DCCDIR %s", t);
	    } else if (s[0] == '=') { 
	       bans = 0;
	       ignores = 0;
	       t = t + 10;
	       G->SPrintF(s, 511, "=COMMENT %s", t);
	    } else if (s[0] == ':') { 
	       bans = 0;
	       ignores = 0;
	       t = t + 10;
	       G->SPrintF(s, 511, "=INFO %s", t);
	    } else if (s[0] == '.') { 
	       bans = 0;
	       ignores = 0;
	       written = 1;
	       t = t + 10;
	       /* ditch xtra fields for the moment */
	    } else if (s[0] == '!') { 
	       bans = 0;
	       ignores = 0;
	    } else {
	       bans = 0;
	       ignores = 0;
	       strcpy(handle, s);
	       handle[9] = 0;
	       G->RMSpace(handle);
	       t = t + 11;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ' ') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
	       strcpy(pass, s);
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] == ' ') {
		  pos++;
		  t++;
	       }
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ' ') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
	       strcpy(flags, s);
	       G->SPrintF(final, 511, "%s %s\n", handle, flags);
	       fputs(final,f2);
	       if (strcmp(pass, "-")) {
		  G->SPrintF(final, 511, "=PASS %s\n", pass);
		  fputs(final,f2);
	       }
	       written = 1;
	    }
	 if (!written) {
	    G->RMSpace(s);
	    strcat(s, "\n");
	    fputs(s,f2);
	 }
         }
   }
   fclose(f);
   fclose(f2);
   unlink(G->userfile);
   G->SPrintF(s, DIRLEN, "%s~new", G->userfile);
   rename(s, G->userfile);
}

static void upgrade_userfilev4 (FILE * f) {
   FUNCTION;
   FILE *f2;
   time_t tt;
   char buf[512], s[512], *t, *u;
   char host[512], part1[512], part2[512], part3[512], part4[512], part5[512];
   int tmp, pos;
   int bans, ignores, sticky;

   G->SPrintF(s, DIRLEN, "%s~new", G->userfile);
   f2 = fopen(s, "w");
   tt = G->now;
   t = buf;
   u = buf;
   bans = 0;
   ignores = 0;
   fprintf(f2, "#5v: %s -- %s -- written %s", G->VersionStr(), G->origbotname, ctime(&tt));
   while (!(feof(f))) {
   t = buf;
   u = buf;
      fgets(t,180,f);
         if (!feof(f)) {
	    G->SPrintF(s, 511, "%s", t);
            if ((s[0] == '-') && (s[1] == '-')) {
	       bans = 0;
	       ignores = 0;
	       t++;
	       t++;
	       if ((!convxtra) && (!strncasecmp("XTRA", t, 4))) {
		  /* Do bugger all */
	       } else {
		  G->SPrintF(s, 511, "=%s", t);
	       }
	    } else if ((s[0] == ':') && (s[1] == ':')) {
	       bans = 1;
	       ignores = 0;
	       t++;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ' ')
	          pos++;
	       s[pos] = 0;
	       G->SPrintF(s, 511, "%s\n", s);
	    } else if ((s[0] == '*') && (s[1] == 'b')) {
	       bans = 1;
	       ignores = 0;
	       strcpy(s, "*b\n");
	    } else if ((s[0] == '-') && (bans == 1)) {
	       sticky = 0;
	       t++;
	       t++;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ':') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
	       strcpy(host, s);
	       /* Extracted the host */
	       t++;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ':') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
	       if (strchr(s, '*') != NULL) {
		  sticky = 1;
		  s[(strlen(s)-1)] = 0;
	       }
	       strcpy(part1, s);
	       /* Extracted first part */
	       t++;
	       t++;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ':') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
 	       strcpy(part2, s);
	       /* Extracted second part */
	       t++;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ':') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
 	       strcpy(part3, s);
	       /* Extracted third part */
	       t++;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ':') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
 	       strcpy(part4, s);
	       /* Extracted fourth part */
	       t++;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ':') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
 	       strcpy(part5, s);
	       /* Slap it together! */
	       if (sticky)
 		  G->SPrintF(s, 511, "-%s %s *%s %s %s %s", host, part1, part2, part3, part4, part5);
	       else
 		  G->SPrintF(s, 511, "-%s %s %s %s %s %s", host, part1, part2, part3, part4, part5);
	    } else if ((s[0] == '*') && (s[1] == 'i')) {
	       bans = 0;
	       ignores = 1;
	       strcpy(s, "*i\n");
	    } else if ((s[0] == '-') && (ignores == 1)) {
	       sticky = 0;
	       t++;
	       t++;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ':') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
	       strcpy(host, s);
	       /* Extracted the host */
	       t++;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ':') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
	       strcpy(part1, s);
	       /* Extracted first part */
	       t++;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ':') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
 	       strcpy(part2, s);
	       /* Extracted second part */
	       t++;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ':') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
 	       strcpy(part3, s);
	       /* Extracted third part */
	       t++;
	       strcpy(s, t);
	       pos = 0;
	       while (s[pos] != ':') {
		  pos++;
		  t++;
	       }
	       s[pos] = 0;
 	       strcpy(part4, s);
	       /* Slap it together! */
 	       G->SPrintF(s, 511, "-%s %s %s %s %s", host, part1, part2, part3, part4);
	    } else if (s[0] == '!') {
	       bans = 0;
	       ignores = 0;
	       /* This is the channel specific information */
	    } else {
	       bans = 0;
	       ignores = 0;
	       pos = 0;
	       for (tmp = 0; tmp<(int)strlen(s) ; tmp++) {
		  if (s[tmp] == '-')
		     pos = tmp;
	       }
	       for (tmp = 0; tmp<pos+2; tmp++)
		  u++;
	       s[pos] = 0;
	       G->RMSpace(s);
	       G->SPrintF(s, 511, "%s %s", s, u);
	    }
	 G->RMSpace(s);
	 strcat(s, "\n");
   	 fputs(s,f2);
         }
   }
   fclose(f);
   fclose(f2);
   unlink(G->userfile);
   G->SPrintF(s, DIRLEN, "%s~new", G->userfile);
   rename(s, G->userfile);
}

static void check_userfile (char * filename) {
   FUNCTION;
   FILE *f;
   char s[512];

   if (!(f = fopen(filename, "r"))) {
      fclose(f);
      G->Fatal(ME->Lang(0x001, ""));
   } else {
      fgets(s, 180, f);
      if (s[1] < '3') {
	 fclose(f);
	 G->Fatal(ME->Lang(0x002, ""));
      } else if (s[1] > '5') {
	 fclose(f);
	 G->Fatal(ME->Lang(0x003, ""));
      } else if (s[1] == '3') {
	 G->LOG_MISC.Put(ME->Lang(0x004, "c", s[1]));
	 upgrade_userfilev3(f);
      } else if (s[1] == '4') {
	 G->LOG_MISC.Put(ME->Lang(0x004, "c", s[1]));
	 upgrade_userfilev4(f);
      }
   }
}

extern "C" {
   char * update_start (ModuleEntryEggdrop * G, ModuleEntry * me) {
      FUNCTION;
      char * r = 0;
      ::G = G;
       ME = NEW ( ModuleEntryUpdate ( me, &r ) );
       if (!r)
	  check_userfile(G->userfile);
       return r;
   }
};
