/*
 * ModuleEntryUserinfo.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "InfoField.h"
#ifdef HAVE_SERVER_H
#include "ModuleEntryServer.h"
#endif
#include "BindTable.h"
#define CLASS "InfoField"

InfoField::InfoField ( const char * mask ) 
: KeyedList<HANDLEN> (*UI->info_fields, mask, NODUPS ) {
   FUNCTION;
   char * list, buf[121], buf2[121], *p = buf2;
   struct command_binds cmds;
   
   cmds.name = key;
   cmds.flags = "-";
   cmds.funcname = NULL;
#ifdef HAVE_SERVER_H
   if (UI->SERVER) {
      cmds.func = UI->userinfo_msg;
      UI->SERVER->bt_msg->AddBinds(&cmds, 1, UI);
   }
#endif
   cmds.func = UI->userinfo_dcc;
   G->bt_dcc->AddBinds(&cmds, 1, UI);
   G->SPrintF(buf, 120, "ch%s", key);
   cmds.name = buf;
   cmds.flags = "m";
   cmds.func = UI->userinfo_dcc_ch;
   G->bt_dcc->AddBinds(&cmds, 1, UI);
   strncpyz(buf2, G->whois_fields, 120);
   while ((list = G->Split(&p))[0]) 
     if (!strcasecmp(list, key))
       break;
   if (!list[0]) {
      int i = strlen(G->whois_fields);
      
      G->SPrintF(G->whois_fields + i, 120 - i, " %s", key);
   }
}

InfoField::~InfoField ( void ) {
   FUNCTION;
   int i;
   char * list, buf[121], buf2[121], *p = buf2;
   struct command_binds cmds;
   
   cmds.name = key;
   cmds.flags = "-";
   cmds.funcname = NULL;
#ifdef HAVE_SERVER_H
   if (UI->SERVER) {
      cmds.func = UI->userinfo_msg;
      UI->SERVER->bt_msg->RemBinds(&cmds, 1);
   }
#endif
   cmds.func = UI->userinfo_dcc;
   G->bt_dcc->RemBinds(&cmds, 1);
   G->SPrintF(buf, 120, "ch%s", key);
   cmds.name = buf;
   cmds.flags = "m";
   cmds.func = UI->userinfo_dcc_ch;
   G->bt_dcc->RemBinds(&cmds, 1);
   strncpyz(buf2, G->whois_fields, 120);
   G->whois_fields[0] = 0;
   i = 0;
   while ((list = G->Split(&p))[0]) 
     if (strcasecmp(list, key))
       i += G->SPrintF(G->whois_fields + i, 120 - i, " %s", key);
}
