/*
 * ModuleEntryUserinfo.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ModuleEntryUserinfo.h"
#include "HelpReference.h"
#include "InfoField.h"
#define CLASS "ModuleEntryUserinfo"

static Version required_eggdrop, userinfo_ver;
static struct patches userinfo_patches[] = {
#include "patch.h"
};

ModuleEntryUserinfo::ModuleEntryUserinfo ( ModuleEntry * o, char ** r )
: ModuleEntry ( "userinfo", userinfo_ver.Set(2,0), userinfo_patches, o ) {
   FUNCTION;
   UI = this;
   if (!Depend("eggdrop", required_eggdrop.Set(2,0)))
     *r = "Your eggdrop core version is incompatible";
   else {
      NEW ( HelpReference("userinfo.help", this) );
      memtype_userinfo = NEW ( MemType("userinfo",(List **)&info_fields,this));
      info_fields = NEW ( InfoField ( ) );
   }
}

ModuleEntryUserinfo::~ModuleEntryUserinfo ( void ) {
   FUNCTION;
   DELETE ( info_fields );
}

int ModuleEntryUserinfo::ExpMem ( void ) {
   FUNCTION;
   return ModuleEntry::ExpMem() + sizeof(ModuleEntryUserinfo);
}
