/*
 * Bot.h
 */

#ifndef _BOTNETMODULE_
# include "botnet.h"
#endif

#ifndef _SOCKET_
#include "Socket.h"
#endif

#ifndef _MODULEENTRYBOTNET_
#include "ModuleEntryBotnet.h"
#endif

#ifndef _BOT_
#define _BOT_

class Bot : public Socket {
  protected:
   char version[121];          /* channel/version info */
   char linker[NOTENAMELEN+1]; /* who requested this link */
   int numver;
   int port;                 /* base port */
   char * call_version;
   struct bot_table_struct * bot_table;
   int size;
   Bot * crosslink;

   /* major cop outs */
   friend class TandemBot;
   friend class BotLink;
   friend class BotLogin;
   friend class BotFork;
  public:
   enum {
      PINGED     = 0x01,  /* waiting for ping to return */
	CALLED     = 0x02,  /* this bot called me */
	WARNED     = 0x04,  /* warned him about unleaflike behavior */
	LEAF       = 0x08,  /* this bot is a leaf only */
	LINKING    = 0x10,  /* the bot is currently going through linking */
   };
   enum {
      TRAFWATCH = 0x01, /* users on bot can watch botnet traffic */
	SERVICE = 0x02, /* a botnet service */
	JUPE = 0x04,
   };
   Bot ( const char *, Bot &);
   Bot ( BotLink &, char *, char * v = "2.0 BOTNET", int = 0 );
   Bot ( BotFork &, const char *);
   inline Bot ( Socket & other, const char * t ) 
     : Socket ( other, t, DCT_BOT, &BNET->bot_timeout) {
     }
   inline Bot ( int fgs, const char * ntype, int fd, const char * host, int p )
     : Socket ( fgs, ntype, DCT_BOT, &BNET->bot_timeout, fd, host, p) {
	port = p;
     }
   inline Bot * Next ( void ) {
      Bot * ptr = this;
      while ((ptr = (Bot *)ptr->next) && !(ptr->type_flags & DCT_BOT));
      return ptr;
   }
   virtual ~Bot ( void );
   
   void Eof ( void );
   void Display2 ( Socket * );
   void Activity ( char *, int );
   int Dump ( char *, int );
   int ExpMem ( void );
   
   inline int Numver ( void ) { return numver; }
   inline void SetNumver ( int x ) { numver = x; }
   inline void SetVersion ( const char * x ) {
      strncpy(version,x,120);
      version[120] = 0;
   }
   inline void SetLinker ( const char * x ) {
      strncpy (linker, x, NOTENAMELEN);
      linker[NOTENAMELEN] = 0;
   }
   inline const char * Version ( void ) { return version; }
   
   virtual void SendMotd (const char *, const char *); 
   virtual void SendReject (const char *, const char *, const char *); 
   virtual void SendTrace (const char *, const char *, const char *);
   virtual void SendTraced (const char *, const char *);
   virtual void SendUnLink (const char *, TandemBot *, const char *);
   virtual void SendWho ( const char *, const char *, int );
   virtual void SendLink (const char *, const char *, const char *);
   virtual void SendPriv (const char *, const char *, const char *);
   virtual void SendZapf (const char *, const char *, const char *);
   virtual void SendLinkInfo (void);
   virtual void SendPing (void);
   virtual void SendPong (void);
   virtual void SendFakeAlert (const char *, const char *);
   virtual void SendBye2 (const char *);

   void ProcessChan (char *, int, char *);
   void ProcessChatter (char *, int, char *);
   void ProcessChat (char *, char *);
   void ProcessActChan (char *, int, char *);
   void ProcessPriv (char *, char *, char *,char *, char *);
   void ProcessBye (char *);
   void ProcessEndLink (char *);
   void ProcessWho (char *, char *, int);
   void ProcessPing (char *);
   void ProcessPong (char *);
   void ProcessInfoQ (char *);
   void ProcessLink (char *, char *, char *);
   void ProcessUnLink (char *, char *, TandemBot *,char *);
   void ProcessUnLinked (TandemBot *, char *);
   void ProcessNLinked (const char *, char *, char, int, int);
   void ProcessHandshake (char *);
   void ProcessJoin (char *, char *, int, char, int, char *, int);
   void ProcessPart (char *, char *, int, char *, int);
   void ProcessAway (char *, int, char *, int);
   void ProcessCrossLink (char *, char *);
   void ProcessUnCrossLink (const char *, const char *);
   void ProcessIdle (char *, int, int, char *);
   void BotCrossLink ( char * );
   void BotUnCrossLink ( char * );
   void BotChat (char *);
   void BotUnLinked (char *);
   void BotVersions (char *);
   void BotZapfbroad (char *);
   void ProcessThisBot (char *);
   void SendZapfBroad ( char *, char *, char * );
   void SendInfoQ ( char * );
   void BotActChan ( char * );
   void BotAway ( char  * );
   void BotChan ( char * );
   void BotChatter ( char * );
   void BotIdle ( char * );
   void BotJoin ( char * );
   void BotNLinked ( char * );
   void BotNickChange ( char * );
   void BotPart ( char * );
   void BotUpdate ( char * );
   void BotZapfBroad ( char * );
   void BotMotd (char *); 
   void BotReject (char *); 
   void BotTrace (char *);
   void BotTraced (char *);
   void BotUnLink (char *);
   void BotWho ( char * );
   void Bot_Link (char *);
   void BotPriv (char *);
   void BotZapf (char *);
   void SendChat ( char *, char * );
   void SendChatter ( char *, int, char * );
   void SendBye ( const char * );
   void SendJoin (int, PartyLiner *, int);
   void SendPart (PartyLiner *, char *, int);
   void SendAct (PartyLiner *, char *);
   void SendChan (PartyLiner *, char *);
   void SendBotChan (Bot *, int, char *);
   void SendNkCh (PartyLiner *, char *);
   void SendAway (PartyLiner *, int);
   void SendUnLinked ( TandemBot *, const char *, int );
   void SendNLinked ( const char *, const char *, char, int, const char * );
   void SendTandBut ( char *, int );
   void SendTandButIso ( char *, int );
   void SendIdle (char *, int, int, char *);
   void SendUpdate ( TandemBot * );
   void SendCrossLink ( TandemBot *, TandemBot * );
   void SendUnCrossLink ( TandemBot *, TandemBot * );
   void ProcessTrace (char *, char *, char *);
   void ProcessTraced (char *, char *);
   void ProcessReject (char *, char *);
   void ProcessZapf (char *, char *, char *);
   void ProcessZapfBroad (char *, char *);
   void ProcessMotd (char *, char *);
   void ProcessNickChange (char *, int, char *);
   void ProcessVersions (char *, char *, char *);
   int BotnetFlags ( const char * );
};

inline Bot * NullBot ( void ) { return (Bot *)0; }

#endif

