/*
 * BotFork.C - class members for BotFork class
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "botnet.h"
#include "BotFork.h"
#include "UserEntryBotaddr.h"
#include "UserEntryPass.h"
#include "TandemBot.h"
#include "BotLink.h"
#define CLASS "BotFork"

BotFork::BotFork ( UserRecord * u, UserEntryBotaddr * bi, const char * linker,
		  Bot * cross)
: Bot ( STRONG | CONNECTING, BNET->BOT_FORK, 0, bi->Value(), bi->Telnet()) {
   FUNCTION;
   user = u;
   SetNick(u->Key());
   TimeNow();
   SetLinker(safe_str(linker));
   SetVersion("(primitive bot)");
   if (cross && !cross->crosslink) {
      crosslink = cross;
      crosslink->crosslink = this;
   }
}

BotFork::~BotFork ( void ) {
   FUNCTION;
}

void BotFork::Eof ( void ) {
   FUNCTION;
   char s1[512];
   
   remoteport++;
   if (remoteport >= (port + G->port_range)) {
      if (linker[0]) {
	 strcpy(s1,linker);
	 G->AddNote(s1, G->botnetnick, BNET->Lang(0x018, "s", nick),NULL, 1);
      }
      if (numver)
	 BNET->LOG_BOTS.Put(BNET->Lang(0x019, "s", nick));
      strcpy(s1,nick);
      Close();
      BNET->AutoLink(s1);
   } else {
      TimeNow();
      if (Scan(port + G->port_range))
	Eof ();
   }
}

void BotFork::Activity (char *, int) {
   FUNCTION;
   FlagRecord bfl (FlagRecord::BOT);
   Bot * ptr = (Bot *)G->socklist, *ptr2 = 0;
   TandemBot * tb;
   UserEntryPass * uep;
   
   context;
   bfl.Set(user);
   if (bfl.BotHub()) {
      /* disconnect all +a bots because we just got a hub */
      while ((ptr = ptr->Next())) {
	 if ((ptr != this) &&
	     ((ptr->Type() == BNET->BOT_FORK) ||
	      (ptr->Type() == BNET->BOT_LINK)) 
	     && bfl.Set(ptr->User())->BotAlt())
	   ptr->Close();
	 if ((tb = BNET->tandbot->Find(nick)) && (ptr2 = tb->NextBot())) {
	    ptr2->SendUnLinked(tb, BNET->Lang(0x01A, "s", ptr2->Nick()),0);
	    ptr2->SendBye2(BNET->Lang(0x0CD, ""));
	    ptr2->Eof();
	 }
      }
   }
   if (crosslink) 
     Printf("%s %s\n", G->botnetnick, crosslink->Nick());
   else 
     Printf("%s\n", G->botnetnick);
   if ((uep = (UserEntryPass *)user->FindEntry(G->entrytype_pass))
       && uep->Value() && strcmp(uep->Value(),"-"))
     Printf("%s\n", uep->Value());
   else
     Printf("-\n");
   NEW ( BotLink (BNET->BOT_LINK, *this ) );
}

void BotFork::Display2 (Socket * where) {
   FUNCTION;
   where->Send(BNET->Lang(0x01B, "s", nick));
}
