/*
 * BotLink.C - class members for BotFork class
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "botnet.h"
#include "BotLink.h"
#include "BindTable.h"
#include "UserRecord.h"
#include "UserEntryXtra.h"
#include "Version.h"
#include "TandemBot.h"
#define CLASS "BotLink"

BotLink::~BotLink ( void ) {
   FUNCTION;
}
   
void BotLink::Eof ( void ) {
   FUNCTION;
   context;
   BNET->LOG_BOTS.Put(BNET->Lang(0x00F, "s", nick));
   Close();
}

void BotLink::Display2 ( Socket * where) {
   FUNCTION;
   where->Send(BNET->Lang(0x017, "sd", nick,G->now - timeval));
}

void BotLink::Timeout ( void ) {
   FUNCTION;
   BNET->LOG_BOTS.Put(BNET->Lang(0x016,"ssd", nick, host, remoteport));
   Close();
}

void BotLink::Activity ( char * buf , int x) {
   FUNCTION;
   char * code;
   int lang = 0;
   
   StripTelnet(buf, &x);
   code = G->Split(&buf);
   if (!strcasecmp(code, "*hello!"))
     GreetNewBot();
   else if (!strcasecmp(code, "h") || !strcasecmp(code, "handshake")) 
     ProcessHandshake(buf);
   else if (!strcasecmp(code, "version") || !strcasecmp(code, "v")) {
      void * args[2] = { this, buf };
      Bot * bot = 0, *cl = crosslink;
      
      if (BNET->bt_version->Check(buf, 0, args) != EXEC_LOG)
	bot = Version(buf);
      if (!bot)
	for (bot = (Bot *)G->socklist; bot->Next(); bot = bot->Next());
      if (bot != this) {
	 args[0] = nick;
	 args[1] = G->botnetnick;
	 BNET->bt_link->Check(nick, 0, args);
	 if (cl) {
	    bot->crosslink = cl;
	    bot->crosslink->crosslink = bot;
	    bot->SendCrossLink(BNET->tandbot->Find(nick), BNET->tandbot);
	 } else {
	    bot->SendNLinked(nick, G->botnetnick, '!', numver, "-");
	    bot->SendLinkInfo();
	 }
      } else 
	lang = 0x0D8;
   } else if (!strcasecmp(code, "badpass"))
	lang = 0x013;
      /* we entered the wrong password */
   else if (!strcasecmp(code, "passreq") && user->PassMatch("-")) {
      lang = 0x014;
      Printf("-\n");
   } else if (!strcasecmp(code, "error")) 
	lang = 0x015;
   if (lang) {
      BNET->LOG_BOTS.Put(BNET->Lang(lang, "ss", nick, buf));
      Close();
   }
   /* ignore otherwise */
}

void BotLink::GreetNewBot (void) {
   FUNCTION;
   FlagRecord bfl (FlagRecord::BOT);
   Socket * idx = G->socklist; 
   
   TimeNow();
   version[0] = 0;
   numver = 0;
   bfl.Set(user);
   if (bfl.BotReject()) {
      UserEntryXtra * uex = (UserEntryXtra *)user->FindEntry(G->entrytype_xtra);
      XtraKeys * p = NULL;
      
      if (uex)
	 p = uex->FindKey("reject");
      BNET->LOG_BOTS.Put(BNET->Lang(0x011, "s", nick));
      Printf("error %s\n", BNET->Lang(0x012, "s", p ? p->Data() : ""));
      Close();
   } else {
      if (bfl.BotLeaf())
	SetStatus(LEAF);
      SetStatus(LINKING);
      Printf("version %02d%02d%02d%02d %d %s <%s>\n", G->Vers()->Major(),
	     G->Vers()->Minor(), G->Vers()->Fix(),
	     G->Vers()->Patch(), HANDLEN, G->VersionStr(), BNET->network);
      while ((idx = idx->Next())) 
	if (idx->Type() == BNET->BOT_FORK)
	  idx->Close();
   }
}

Bot * BotLink::Version (char * par) {
   FUNCTION;
   int l;
   Bot * newone = 0;
   
   context;
   numver = atoi(G->Split(&par));
   if (numver < NEATER_BOTNET) {
      Printf("error %s\n", BNET->Lang(0x0C1, ""));
      Eof();
   } else {
      Printf("B%s %s\n", G->botnetnick,
	     BNET->BotnetFlags((int)(G->debug_output ? Bot::TRAFWATCH : 0)));
      l = atoi(G->Split(&par));
      if (l != HANDLEN) {
	 Printf("error %s\n", BNET->Lang(0x00A, "dd", HANDLEN, l));
	 Close();
      } else 
	newone = NEW ( Bot ( *this, par ) );
   }
   return newone;
}
