/*
 * BotLogin.C
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "BotLogin.h"
#include "UserEntryPass.h"
#include "TandemBot.h"
#include "BotPass.h"
#define CLASS "BotLogin"

BotLogin::~BotLogin ( void ) {
   FUNCTION;
}

void BotLogin::Activity (char * buf2,int atr) {
   FUNCTION;
   FlagRecord fr (FlagRecord::GLOBAL | FlagRecord::CHANNEL | 
		  FlagRecord::ANYWHERE);
   int lang = 0;
   UserRecord * u;
   char * buf;
   
   context;
   StripTelnet(buf2, &atr);
   buf = G->Split(&buf2);
   if (buf2[0]) {
      Bot * bot = (Bot *)G->socklist->Find(buf2, DCT_BOT);
      
      if (bot && !bot->crosslink) {
	 bot->crosslink = this;
	 crosslink = bot;
      }
   }
   if (strlen(buf) > HANDLEN)
     buf[HANDLEN] = 0;
   /* toss out bad nicknames */
   if ((nick[0] != '@') && !G->WildMatch(nick, buf)) 
     lang = 0x01E;
   else if (!(u = G->userlist->Find(buf)))
     lang = 0x01E;
   else {
      SetUser(u);
      /* make sure users-only/bots-only connects are honored */
      if (!fr.Set(u)->GlobBot())
	lang = 0x020;
      else if (BNET->tandbot->Find(buf) && !crosslink)
	lang = 0x022;
      else if (u->PassMatch("-")) {
	 char ps[30];
	 
	 strcpy(ps, "handshake ");
	 G->MakePass(ps + 10);
	 SetPassword(u, ps + 10);
	 u->SetKey(buf);
	 SetNick(buf);
	 SetStatus(CALLED);
	 Send(ps);
	 Printf("*hello!\n");
	 GreetNewBot();	 
	 NEW ( BotLink ( BNET->BOT_LINK, *this ) );
      } else {
	 TimeNow();
	 u->SetKey(buf);
	 SetNick(buf);
	 Printf("passreq\n");
	 NEW ( BotPass ( *this ) );
      }
   }
   if (lang) {
      Send(BNET->Lang(lang, ""));
      BNET->LOG_BOTS.Put(BNET->Lang(lang+1 , "s", buf));
      Close();
   }
}

void BotLogin::Display2 (Socket * where) {
   FUNCTION;
   where->Send(BNET->Lang(0x024, "d", Age()));
}
