/*
 * PartyLiner.C - class members for PartyLiner class
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "botnet.h"
#include "PartyLiner.h"
#include "BindTable.h"
#include "ModuleEntryBotnet.h"
#define CLASS "PartyLiner"

PartyLiner::PartyLiner ( void ) : KeyedList<HANDLEN> ( ) {
   FUNCTION;
}
   
PartyLiner::PartyLiner (TandemBot * b, const char * n, int ch,
			char f, int s, const char * fr, int * oc) 
: KeyedList<HANDLEN> ( *BNET->party, n, KeyedList<HANDLEN>::APPEND) {
   FUNCTION;
   PartyLiner * ptr;

   bot = b;
   *oc = -1;
   sock = s;
   flag = f == ' ' ? '-' : f; 
   chan = ch;
   if (!fr || !fr[0]) 
     fr = BNET->Lang(0x025, "");
   from = (char *)my_malloc(strlen(fr) + 1,BNET->memtype_party);
   strcpy(from,fr);
   for (ptr = b->partyliners; ptr; ptr = ptr->NextByBot()) 
     if (ptr->sock == s) {
	*oc = ptr->chan;
	DELETE ( ptr );
	break;
     }
   if (b->partyliners) 
     next_by_bot = b->partyliners;
   b->partyliners = this;
   timer = G->now;
}

PartyLiner::~PartyLiner ( void ) {
   FUNCTION;
   PartyLiner * ptr, * old = NULL;
   void * args[1];
   char buf[32];
   
   if (bot) {
      for (ptr = bot->partyliners; ptr; old = ptr, ptr = ptr->next_by_bot)
        if (ptr == this) {
	   if (old)
	     old->next_by_bot = next_by_bot;
	   else
	     bot->partyliners = next_by_bot;
        }
      args[0] = this;
      strcpy(buf, G->ToBase10(chan));
      BNET->bt_chpt->Check(buf, 0, args);
      BNET->party->Remove(this);
      if (from)
        my_free(from,BNET->memtype_party);
      if (away)
        my_free(away,BNET->memtype_party);
   }
}

void * PartyLiner::operator new ( size_t s, int x) {
   FUNCTION;
   return BNET->memtype_party->Malloc(s,x);
}

void PartyLiner::operator delete ( void * ptr ) {
   FUNCTION;
   BNET->memtype_party->Free(ptr);
}

void PartyLiner::SetAway ( const char * msg ) {
   FUNCTION;
   if (away) 
     my_free(away,BNET->memtype_party);
   if (msg && msg[0]) {
      away = (char *)my_malloc(strlen(msg)+1, BNET->memtype_party);
      strcpy(away,msg);
   } else
     away = 0;
}

int PartyLiner::ExpMem ( void ) {
   FUNCTION;
   return sizeof(PartyLiner) + (next ? ((PartyLiner *)next)->ExpMem() : 0)
     + (away ? strlen(away) + 1 : 0) + (from ? strlen(from) + 1 : 0);
}
