/*
 * PartyLiner.h - class definition
 */

#ifndef _BOTNETMODULE_
#include "botnet.h"
#endif

#ifndef _KEYEDLIST_
#include "KeyedList.h"
#endif

#ifndef _PARTYLINER_
#define _PARTYLINER_

class PartyLiner : public KeyedList<HANDLEN> {
  protected:
   int sock;
   TandemBot * bot;
   PartyLiner * next_by_bot;
   int chan;
   char * from;
   char flag;
   time_t timer;
   char * away;
   friend class TandemBot;
  public:
   PartyLiner ( void );
   PartyLiner ( TandemBot *, const char *, int, char, int, const char *, int * );
   ~PartyLiner ( void );
   
   inline PartyLiner * Next ( void ) { return (PartyLiner *)next; }
   inline PartyLiner * NextByBot ( void ) { return next_by_bot; }
   int ExpMem ( void );
   void * operator new (size_t, int);
   void operator delete ( void * );
   inline TandemBot * Bot ( void ) { return bot; }
   inline const char * BotName ( void );
   inline const char * Nick ( void ) { return key; }
   inline int Sock ( void ) { return sock; }
   inline const char * Away ( void ) { return away; }
   inline const char * From ( void ) { return from; }
   inline char Flag ( void ) { return flag; }
   inline time_t Timer ( void ) { return timer; }
   inline time_t Age ( void ) { return G->now - timer; }
   inline void TimeNow ( void ) { timer = G->now; }
   inline void SetIdle ( time_t when ) { timer = G->now - when; }
   inline int Chan ( void ) { return chan; }
   void SetAway ( const char * );
};

#ifndef _TANDEMBOT_
#include "TandemBot.h"
#endif

inline const char * PartyLiner::BotName ( void ) {
   return bot->Name ();
}

#endif
