/*
 * TandemBot.h - class defintion
 */

#ifndef _BOTNETMODULE_
#include "botnet.h"
#endif

#ifndef _KEYEDLIST_
#include "KeyedList.h"
#endif

#ifndef _TANDEMBOT_
#define _TANDEMBOT_

class TandemBot : public KeyedList<HANDLEN> {
  protected:
   TandemBot * uplink;
   TandemBot * peer;
   TandemBot * child;
   TandemBot * crosslink;
   PartyLiner * partyliners;
   int ver;
   char share;
   int botnet_flags;
   
   friend class PartyLiner;
   friend class Bot;
  public:
   TandemBot ( void );
   TandemBot ( TandemBot *, const char *, char, int, int = 0 );
   ~TandemBot ( void );
   
   inline TandemBot * Next ( void ) { return (TandemBot *)next; };
   int ExpMem ( void );
   void * operator new (size_t, int);
   void operator delete ( void * );
   inline const char * Name ( void ) { return key[0] ? key : G->botnetnick; }
   inline PartyLiner * PartyLiners ( void ) { return partyliners; }
   inline int Version ( void ) { return ver; }
   inline char Share ( void ) { return share; }
   inline TandemBot * Children ( void ) { return child; }
   inline TandemBot * Uplink ( void ) { return uplink; }
   inline TandemBot * Peer ( void ) { return peer; }
   inline TandemBot * CrossLink ( void ) { return crosslink; }
   inline const char * UplinkName ( void ) {
      return uplink ? uplink->key : G->botnetnick;
   }
   inline TandemBot * Find ( const char * x ) {
      return (TandemBot *)KeyedList<HANDLEN>::Find(x);
   }
   inline int BotnetFlags ( void ) {
      return botnet_flags;
   }
   inline void SetBotnetFlags ( int x ) { botnet_flags |= x; }
   inline void UnSetBotnetFlags ( int x ) { botnet_flags &= ~x; }
   PartyLiner * FindParty ( int );
   PartyLiner * FindParty ( char *, int );
   Bot * NextBot ( void );
   void Update ( Bot * , char = 0, int = 0, int = 0);
   int Dump ( Socket *, char *, int, int);
   void RemoveChild (TandemBot *);
};
#endif
