/*
 * UserEntryBotaddr.h - header files for the UserEntryBotaddr class
 */

#ifndef _USERENTRYCOMMENT_
#include "UserEntryComment.h"
#endif

#ifndef _USERENTRYBOTADDR_
#define _USERENTRYBOTADDR_

class UserEntryBotaddr : public UserEntryComment {
  protected:
   int telnet_port;
   int relay_port;
   
  public:
   inline UserEntryBotaddr ( UserRecord * u, UserEntry * t )
     : UserEntryComment ( u, t ) {
	telnet_port = relay_port = 3333;
   }
   inline UserEntryBotaddr ( ModuleEntry * m ) 
     : UserEntryComment ( "BOTADDR", m ) { }
   ~UserEntryBotaddr ( void );
   
   void Pack ( UserEntry * );
   UserEntry * Create ( UserRecord * );
   
   void GotShare ( char *, Socket * );
   int Write ( FILE *, Socket * );
   int ScriptGet ( ScriptContext *, int, ScriptArgument * );
   int ScriptSet ( ScriptContext *, int, ScriptArgument * );
   void Display (Socket * );
   int ExpMem ( void );
   void Set ( char * );
   
   inline int Telnet ( void ) { return telnet_port; }
   inline int Relay ( void ) { return relay_port; }
};
#endif
