/*
 * botnet.c - botnet code, extracted from original eggdrop core
 */
/*
 * This file is part of the eggdrop2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "botnet.h"
#include "DccChat.h"
#include "UserRecord.h"
#include "UserEntryUnknown.h"
#include "UserEntryXtra.h"
#include "UserEntryPass.h"
#include "UserEntryLaston.h"
#include "UserEntryBotaddr.h"
#include "BindTable.h"
#include "HookList.h"
#include "PartyLiner.h"
#include "ModuleEntry.h"
#include "Version.h"
#include "BotFork.h"
#include "BotLogin.h"
#include "ScriptContext.h"
#include "ScriptArgument.h"
#include "TelnetPort.h"
#include "Channel.h"
#include "Command.h"
#define CLASS ""

ModuleEntryBotnet * BNET;
static ModuleEntryEggdrop * G;

extern "C" {
   char * botnet_start (ModuleEntryEggdrop *, ModuleEntry *);
};

/***************************************************************************
 * Script COMMANDS                                                            *
 ***************************************************************************/

static int script_putbot (ScriptContext * sc, int argc, ScriptArgument ** argv) {
   FUNCTION;
   char msg[401];
   Bot * next = 0;
   TandemBot * tb;
   
   context;
   BADARGS(3, 3, BNET->Lang(0x037, ""));
   if (!(tb = BNET->tandbot->Find(argv[1]->AsString())) ||
       !(next = tb->NextBot())) {
      sc->SetString(BNET->Lang(0x038, ""));
      return SCRIPT_ERROR;
   }
   strncpy(msg, argv[2]->AsString(), 400);
   msg[400] = 0;
   next->SendZapf(G->botnetnick, argv[1]->AsString(), msg);
   return SCRIPT_OK;
}

static int script_putallbots (ScriptContext * sc, int argc, ScriptArgument ** argv) {
   FUNCTION;
   char msg[401];
   
   context;
   BADARGS(2, 2, BNET->Lang(0x039, ""));
   strncpy(msg, argv[1]->AsString(), 400);
   msg[400] = 0;
   NullBot()->SendZapfBroad(G->botnetnick, NULL, msg);
   return SCRIPT_OK;
}

static int script_bots (ScriptContext * sc, int argc, ScriptArgument **) {
   FUNCTION;
   TandemBot * bot = BNET->tandbot;
   
   context;
   BADARGS(1, 1, "");
   while ((bot = bot->Next()))
     sc->AppendString(bot->Name());
   return SCRIPT_OK;
}

static int script_botlist (ScriptContext * sc, int argc, ScriptArgument **) {
   FUNCTION;
   TandemBot * bot = BNET->tandbot;
   const char * list[4];
   char sh[2], string[20];
   
   context;
   BADARGS(1, 1, "");
   sh[1] = 0;
   list[3] = sh;
   list[2] = string;
   while ((bot = bot->Next())) {
      list[0] = bot->Name();
      list[1] = bot->UplinkName();
      strcpy(string,G->ToBase10(bot->Version()));
      sh[0] = bot->Share();
      sc->AppendArray(4,list);
   }
   return SCRIPT_OK;
}

/* list of { nick bot host flag idletime awaymsg [channel]} */
static int script_whom (ScriptContext * sc, int argc, ScriptArgument ** argv) {
   FUNCTION;
   char c[2], idle[10], work[20];
   const char *list[7], * ch;
   int chan = -1;
   PartyLiner * ptr = BNET->party;
   
   context;
   BADARGS(2, 2, BNET->Lang(0x03A, ""));
   ch = argv[1]->AsString();
   if (ch[0] != '*') {
      if ((ch[0] < '0') || (ch[0] > '9')) {
	 void * argv[3] = { &chan, (void *)ch, 0 };
	 if (G->bt_name->Check("", 0, argv) != EXEC_LOG) {
	    sc->SetString(BNET->Lang(0x03B, ""));
	    return SCRIPT_ERROR;
	 }
      } else
	chan = atoi(ch);
      if ((chan < 0) || (chan > 199999)) {
	 sc->SetString(BNET->Lang(0x03C, ""));
	 return SCRIPT_ERROR;
      }
   }
   list[6] = work;
   list[4] = idle;
   list[3] = c;
   while ((ptr = ptr->Next()))
     if ((ptr->Chan() == chan) || (chan == -1)) {
	c[0] = ptr->Flag();
	c[1] = 0;
	strcpy(idle, !ptr->Timer() ? "0" : G->ToBase10(ptr->Age() / 60));
	list[0] = ptr->Nick();
	list[1] = ptr->BotName();
	list[2] = safe_str(ptr->From());
	list[5] = safe_str(ptr->Away());
	if (chan == -1) 
	  strcpy(work, G->ToBase10(ptr->Chan()));
	sc->AppendArray((chan == -1) ? 7 : 6, list);
     }
   return SCRIPT_OK;
}

static int script_link (ScriptContext * sc, int argc, ScriptArgument ** argv) {
   FUNCTION;
   int x;
   char bot[HANDLEN+1], bot2[HANDLEN+1];
   Bot * ptr = 0;
   TandemBot * tb;
   
   context;
   BADARGS(2, 3, BNET->Lang( 0x03D, ""));
   strncpy(bot, argv[1]->AsString(), HANDLEN);
   bot[HANDLEN] = 0;
   if (argc == 2)
       x = BNET->BotLink("", NULL, bot);
   else {
      x = 1;
      strncpy(bot2, argv[2]->AsString(), HANDLEN);
      bot2[HANDLEN] = 0;
      if (!(tb = BNET->tandbot->Find(bot)) || !(ptr = tb->NextBot()))
	x = 0;
      else
	ptr->SendLink(G->botnetnick, bot, bot2);
   }
   sc->SetInteger(x);
   return SCRIPT_OK;
}

static int script_unlink (ScriptContext * sc, int argc, ScriptArgument ** argv) {
   FUNCTION;
   int x,i;
   char bot[HANDLEN+1];
   Bot * ptr = 0;
   TandemBot * tb;
   
   context;
   BADARGS(2, 3, BNET->Lang( 0x03E, ""));
   strncpy(bot, argv[1]->AsString(), HANDLEN);
   bot[HANDLEN] = 0;
   if (!(tb = BNET->tandbot->Find(bot)) || !(ptr = tb->NextBot()))
       x = 0;
   else {
      x = 1;
      if (!strcasecmp(bot, ptr->Nick())) {
	 i = BNET->share_unlinks;
	 BNET->share_unlinks = 1;
	 x = BNET->Unlink(bot, NULL, argv[2]->AsString());
	 BNET->share_unlinks = i;
      } else
	ptr->SendUnLink(G->botnetnick, tb, argv[2]->AsString());
   } 
   sc->SetInteger(x);
   return SCRIPT_OK;
}

static int script_botport (ScriptContext * sc, int argc, ScriptArgument ** argv) {
   FUNCTION;
   TelnetPort * tp = (TelnetPort *)G->socklist;
   context;
   BADARGS(3, 4, BNET->Lang(0x03F, ""));
   if (!G->do_restart) {
      if ((tp = tp->Find(argv[2]->AsInteger()))) {
	 sc->SetString(G->Lang(0x1A9, "ss", argv[1]->AsString(), argv[2]->AsString()));
	 return SCRIPT_ERROR;
      }
      NEW ( TelnetPort ( sc, argv[1]->AsString(), argv[2]->AsInteger(),
			(argc == 3) ? "" : argv[3]->AsString(), "(bots)"));
   }
   return SCRIPT_OK;
}

static int script_boot (ScriptContext * sc, int argc, ScriptArgument ** argv) {
   FUNCTION;
   char who[512];
   Bot * ptr = 0;
   DccChat *p1;
   TandemBot * tb;
   
   context;
   BADARGS(2, 3, BNET->Lang(0x040, ""));
   strcpy(who, argv[1]->AsString());
   if (strchr(who, '@')) {
      char whonick[161];
      G->SplitC(whonick, who, '@');
      whonick[161] = 0;
      if (!strcasecmp(who, G->botnetnick))
	strcpy(who, whonick);
      else if ((BNET->remote_boots > 1) && (tb = BNET->tandbot->Find(who)) &&
	       (ptr = tb->NextBot())) {
	 char to[NOTENAMELEN+1];
	 G->SPrintF(to, NOTENAMELEN, "%s@%s",whonick,who);
	 ptr->SendReject(G->botnetnick, to, argv[2]->AsString());
	 return SCRIPT_OK;
      }
   }
   for (p1 = (DccChat *)G->socklist; (p1 = p1->Next()); )
     if (!strcasecmp(p1->Nick(), who) && (p1->TypeFlags() & DCT_CANBOOT)) {
	p1->DoBoot(G->botnetnick, argv[2]->AsString());
	break;
     }
   return SCRIPT_OK;
}

static int script_botattr (ScriptContext * sc, int argc, ScriptArgument ** argv) {
   FUNCTION;
   const char * chan = 0, * chg;
   char work[100];
   FlagRecord pls, mns, user ( FlagRecord::BOT );
   UserRecord * u;
   
   context;
   BADARGS(2, 4, BNET->Lang(0x041, ""));
   u = G->userlist->Find(argv[1]->AsString());
   chg = argv[2]->AsString();
   if ((argv[1]->AsString()[0] == '*') || !u || !pls.Set(u)->GlobBot()) {
      sc->SetString("*");
      return SCRIPT_OK;
   }
   if (argc == 4) {
      user.SetMatch ( FlagRecord::BOT | FlagRecord::CHANNEL );
      chan = argv[3]->AsString();
   } else if ((argc == 3) && ((chg[0] == '&') || (chg[0] == '#'))) {
      user.SetMatch ( FlagRecord::BOT | FlagRecord::CHANNEL );
      chan = chg;
      chg = 0;
   }
   if (chan && !G->chanset->Find(chan)) {
      sc->SetString(BNET->Lang(0x042, ""));
      return SCRIPT_ERROR;
   }
   user.Set(u, chan);
   /* make changes */
   if (chg) {
      pls.SetMatch(user.Match());
      pls.BreakDown(chg, &mns);
      user += pls;
      user -= mns;
      u->Set(user, chan);
   }
   /* retrieve current flags and return them */
   user.Build(work, 0);
   sc->SetString(work);
   return SCRIPT_OK;
}

static int script_addbot (ScriptContext * sc, int argc, ScriptArgument ** argv) {
   FUNCTION;
   UserRecord * u;
   UserEntryBotaddr * ueb;
   FlagRecord bfl;
   char tbuf[HANDLEN + 1], ubuf[512];
   
   context;
   BADARGS(3, 3, BNET->Lang(0x043, ""));
   strncpy(tbuf, argv[1]->AsString(), HANDLEN);
   tbuf[HANDLEN] = 0;
   if ((tbuf[0] == '*') || G->userlist->Find(tbuf))
     sc->SetString("0");
   else {
      bfl.SetGlobBot();
      u = NEW ( UserRecord ( G->userlist, tbuf, "none", bfl) );
      ueb = (UserEntryBotaddr *)u->GetEntry(BNET->entrytype_botaddr);
      strncpy(ubuf, argv[2]->AsString(),511);
      ubuf[511] = 0;
      ueb->Set(ubuf);
      sc->SetString("1");
   }
   return SCRIPT_OK;
}


/****************************************************************************
 * DCC COMMANDS                                                             *
 ****************************************************************************/

static BindReturn cmd_botinfo (void ** args, const char *) {
   FUNCTION;
   char s[512], s2[32];
   Channel *chan = G->chanset;
   Socket * idx = (Socket *)args[0];
   int l, day = 0, hr, min;
   time_t now;
   
   context;
   now = G->now - G->online_since;
   if (now > 86400) {
      day = (now / 86400);
      now -= day % 86400;
   } 
   hr = now / 3600;
   min = (now % 3600) / 60;
   strncpyz(s2, BNET->Lang(day ? ((day == 1) ? 0x0AF : 0x0AE) : 0x0B0, "ddd",
			   hr, min, day), 31);
   context;
   G->LOG_CMDS.Put(BNET->Lang(0x048, "s", idx->Nick()));
   G->SPrintF(s, 511, "%d:%s@%s",idx->FD(),idx->Nick(),G->botnetnick);
   NullBot()->SendInfoQ(s);
   l = 0;
   s[0] = 0;
   if (G->module_list->Find("server", &BNET->required_server)) {
      s[0] = '*';
      while ((chan = chan->Next()))
	if (!chan->Secret()) 
	  l += G->SPrintF(s + l, 511 - l, "%s, ", chan->Key());
      if (l) 
	s[l - 2] = 0;
   }
   idx->Send(G->Lang(0x111, "ss", G->botnetnick,
		     BNET->Lang(s[0] ? (l ? 0x044 : 0x045) : 0x046,
				"ssss", G->VersionStr(), BNET->network, s, s2)));
   return EXECUTED;
}

static BindReturn cmd_whom (void ** args, const char *) {
   FUNCTION;
   DccChat * idx = (DccChat *)args[0];
   PartyLiner * ptr = BNET->party;
   char * par = (char *)args[1], c, *idle;
   int chan = -1;
   
   context;
   if (idx->Channel() < 0) 
     idx->Send(BNET->Lang(0x047, ""));
   else {
      G->LOG_CMDS.Put(BNET->Lang(0x049, "ss", idx->Nick(), par));
      if (!par[0])
	chan = idx->Channel();
      else if (par[0] != '*') {
	 if ((par[0] < '0') || (par[0] > '9')) {
	    void * args[3] = { &chan, par, 0 };
	    if (G->bt_name->Check("", 0, args) != EXEC_LOG) {
	       idx->Send(BNET->Lang(0x04A, ""));
	       return EXECUTED;
	    }
	 } else 
	   chan = atoi(par);
	 if ((chan < 0) || (chan > 99999)) {
	    idx->Send(BNET->Lang(0x04B, ""));
	    return EXECUTED;
	 }
      }
      context;
      if (chan == -1)
	idx->Send(BNET->Lang(0x04C, "cc", '+', '*'));
      else if (chan > 0) {
	 char buf[100];
	 int x = 100;
	 void * args[3] = { &chan, buf, &x };
	 BindReturn ret = G->bt_name->Check("", 0, args);
	 
	 idx->Send(BNET->Lang((ret == EXEC_LOG) ? 0x04E : 0x04D, "sds",
			      (chan < 100000) ? "" : "*", chan % 100000, buf));
      }
      idx->Send(BNET->Lang(0x04F, " ", HANDLEN - 9));
      idx->Send(BNET->Lang(0x050, " ", HANDLEN - 9));
      while ((ptr = ptr->Next()))
	if ((chan == -1) || ((chan >= 0) && (ptr->Chan() == chan))) {
	   c = ptr->Flag();
	   if (c == '-')
	     c = ' ';
	   if (ptr->Timer() == 0L)
	     idle = BNET->Lang(0x051, "");
	   else if (ptr->Age() > 300) {
	      unsigned long days, hrs, mins;
	      days = ptr->Age() / 86400;
	      hrs = (ptr->Age() - (days * 86400)) / 3600;
	      mins = (ptr->Age() - (hrs * 3600)) / 60;
	      idle = BNET->Lang((days > 0) ? 0x052 : ((hrs > 0) ? 0x053 : 0x054),
				"ddd", days, hrs, mins);
	   } else
	     idle = 0;
	   idx->Send(BNET->Lang(0x055, "cs cs ss", c, ptr->Nick(),
				HANDLEN - strlen(ptr->Nick()), 
				(ptr->Chan() == 0) && (chan == (-1)) 
				? '+' : ' ', ptr->BotName(),
				HANDLEN - strlen(ptr->BotName()), ptr->From(),
				idle));
	   if (ptr->Away())
	     idx->Send(BNET->Lang(0x056, "s", ptr->Away()));
	}
   }
   return EXECUTED;
}

static BindReturn cmd_rmotd (void ** args, const char *) {
   FUNCTION;
   DccChat * idx = (DccChat *)args[0];
   Bot * ptr = 0;
   char * par = (char *)args[1], x[101];
   TandemBot * tb;
   
   context;
   if (par[0]) {
      G->LOG_CMDS.Put(BNET->Lang(0x057, "ss", idx->Nick(), par));
      if (!strcasecmp(par, G->botnetnick))
	idx->ShowMotd();
      else {
	 if (!(tb = BNET->tandbot->Find(par)) || !(ptr = tb->NextBot()))
	   idx->Send(BNET->Lang(0x058, ""));
	 else {
	    G->SPrintF(x, 100, "%s%d:%s@%s", (idx->StripFlags() & STRIP_HILITE)
		       ? "" : (idx->HasStatus(STAT_TELNET) ? "#" : "!"),
		       idx->FD(),idx->Nick(),G->botnetnick);
	    ptr->SendMotd(x, par);
	 }
      }
   } else 
     idx->Send(BNET->Lang(0x059, ""));
   return EXECUTED;
}

static BindReturn cmd_rboot (void ** args, const char * mask) {
   FUNCTION;
   Socket * idx = (Socket *)args[0];
   Bot * ptr = 0;
   char * who, *par = (char *)args[1];
   TandemBot * tb;
   
   if (!par[0]) 
     idx->Send(BNET->Lang(0x05A, ""));
   else {
      who = G->Split(&par);
      if (strchr(who, '@')) {
	 char whonick[512];
	 G->SplitC(whonick, who, '@');
	 whonick[20] = 0;
	 if (!strcasecmp(who, G->botnetnick)) {
	    args[1] = whonick;
	    G->cmd_boot(args, mask);
	 } else if (BNET->remote_boots) {
	    if (!(tb = BNET->tandbot->Find(who)) || !(ptr = tb->NextBot()))
	      idx->Send(BNET->Lang(0x058, ""));
	    else {
	       char to[NOTENAMELEN+1], from[NOTENAMELEN+1];
	       G->SPrintF(to, NOTENAMELEN, "%s@%s",whonick,who);
	       G->SPrintF(from, NOTENAMELEN, "%s@%s",idx->Nick(),G->botnetnick);
	       ptr->SendReject(from, to, par[0] ? par : idx->Nick());
	       G->LOG_MISC.Put(BNET->Lang(0x05B, "ssss", idx->Nick(), 
					   whonick, who, par[0] ? par : idx->Nick()));
	    }
	 } else 
	   idx->Send(BNET->Lang(0x05C, ""));
      } else {
	 *--par = ' ';
	 G->cmd_boot(args, mask);
      }
   }   
   return EXECUTED;
}

static BindReturn cmd_bots (void ** args, const char *) {
   FUNCTION;
   Socket * idx = (Socket *)args[0];
   char s[512];
   int i;
   TandemBot * bot = BNET->tandbot;
   
   context;
   G->LOG_CMDS.Put(BNET->Lang(0x05D, "s", idx->Nick()));
   if (!BNET->tands) 
     idx->Send(BNET->Lang(0x05E, ""));
   else {
      strcpy(s, G->botnetnick);
      i = strlen(G->botnetnick);
      while ((bot = bot->Next())) {
	 if (i > (500 - HANDLEN)) {
	    idx->Send(BNET->Lang(0x05F, "s", s));
	    s[0] = 0;
	    i = 0;
	 } 
	 if (i) {
	    s[i++] = ',';
	    s[i++] = ' ';
	 }
	 i += G->StrCpy(s+i, bot->Name());
      }
      if (s[0])
	idx->Send(BNET->Lang(0x05F, "s", s));
      idx->Send(BNET->Lang(0x060, "d", BNET->tands + 1));
   }
   return EXECUTED;
}

static BindReturn cmd_bottree (void ** args, const char * mask) {
   FUNCTION;
   Socket * idx = (Socket *)args[0];
   char work[1024];
   int lang = (mask[0] == 'v') ? 0x064 : 0x065, tothops;
   
   context;
   G->LOG_CMDS.Put(BNET->Lang(lang + 2, "s", idx->Nick()));
   if (!BNET->tands) 
     idx->Send(BNET->Lang(0x05E, ""));
   else {
      work[0] = 0;
      tothops = BNET->tandbot->Dump(idx, work, 0, lang);
      idx->Send(BNET->Lang(0x068, "Fd",
			   ((float) tothops) / ((float) BNET->tands), 
			   BNET->tands + 1)) ;
   }
   return EXECUTED;
}

static BindReturn cmd_pls_bot (void ** args, const char *) {
   FUNCTION;
   char * handle, *addr, *host, *par = (char *)args[1];
   UserRecord * u1;
   UserEntryBotaddr * ueb;
   Socket * idx = (Socket *)args[0];
   int lang = 0;
   FlagRecord bfl ( FlagRecord::GLOBAL );
   
   if (!par[0])
     lang = 0x069;
   else {
      handle = G->Split(&par);
      addr = G->Split(&par);
      if (strlen(handle) > HANDLEN)
	handle[HANDLEN] = 0;		/* max len = XX .. for the moment :) */
      if (G->userlist->Find(handle)) 
	lang = 0x06A;
      else {
	 if (strlen(addr) > UHOSTLEN)
	   addr[UHOSTLEN] = 0;
	 G->LOG_CMDS.Put(BNET->Lang(0x06D, "sss", idx->Nick(), handle, addr));
	 bfl.SetGlobBot();
	 u1 = NEW ( UserRecord ( G->userlist, handle, "none", bfl) );
	 ueb = (UserEntryBotaddr *)u1->GetEntry(BNET->entrytype_botaddr);
	 ueb->Set(addr);
	 idx->Send(BNET->Lang(0x06C, "ss", handle, addr));
	 host = G->Split(&par);
	 if (host[0])
	   u1->AddHost(host);
	 else
	   lang = 0x06B;
      }
   }
   if (lang)
     idx->Send(BNET->Lang(lang, ""));
   return EXECUTED;
}

static BindReturn cmd_chaddr (void ** args, const char *) {
   FUNCTION;
   char * handle, * addr, *par = (char *)args[1];
   UserRecord * u1;
   Socket * idx = (Socket *)args[0];
   int lang = 0;
   FlagRecord bfl ( FlagRecord::BOT | FlagRecord::GLOBAL );
   
   if (!par[0]) 
     lang = 0x06E;
   else {
      handle = G->Split(&par);
      addr = G->Split(&par);
      if (strlen(addr) > UHOSTLEN)
	addr[UHOSTLEN] = 0;
      u1 = G->userlist->Find(handle);
      bfl.Set(u1);
      if (!u1 || !bfl.GlobBot())
	lang = 0x06F;
      else if (bfl.BotShare() && !bfl.Set(idx->User())->GlobOwner())
	lang = 0x070;
      else {
	 UserEntryBotaddr * ueb = 
	   (UserEntryBotaddr *)u1->GetEntry(BNET->entrytype_botaddr);
	 ueb->Set(addr);
	 G->LOG_CMDS.Put(BNET->Lang(0x072, "sss", idx->Nick(), handle, addr));
	 lang = 0x071;
      }
   }
   if (lang)
     idx->Send(BNET->Lang(lang, ""));
   return EXECUTED;
}

static BindReturn cmd_link (void ** args, const char *) {
   FUNCTION;
   char * s, *par = (char *)args[1], x[NOTENAMELEN+11];
   Socket * idx = (Socket *)args[0];
   Bot * ptr = 0;
   TandemBot * tb;
   
   if (!par[0]) 
     idx->Send(BNET->Lang(0x073, ""));
   else {
      G->LOG_CMDS.Put(BNET->Lang(0x074, "ss", idx->Nick(), par));
      s = G->Split(&par);
      if (!par[0] || !strcasecmp(par,G->botnetnick))
	BNET->BotLink(idx->Nick(), idx, s);
      else if (!(tb = BNET->tandbot->Find(s)) || !(ptr = tb->NextBot()))
	idx->Send(BNET->Lang(0x058, ""));
      else {
	 G->SPrintF(x, NOTENAMELEN + 10, "%d:%s@%s",idx->FD(),
		    idx->Nick(), G->botnetnick);
	 ptr->SendLink(x,s,par);
      }
   }
   return EXECUTED;
}

static BindReturn cmd_crosslink (void ** args, const char *) {
   FUNCTION;
   char *par = (char *)args[1];
   Socket * idx = (Socket *)args[0];
   Bot * ptr = (Bot *)G->socklist, *up;
   TandemBot * tb;
   UserRecord * u;
   UserEntryBotaddr * bi;
   int lang = 0;
   FlagRecord bfl;
   BotFork * bot;
   
   if (!par[0])
     lang = 0x0D5;
   else {
      G->LOG_CMDS.Put(BNET->Lang(0x0D6, "ss", idx->Nick(), par));
      if (!(tb = BNET->tandbot->Find(par)) || !tb->Uplink() 
	  || tb->Uplink()->Uplink() || tb->Uplink()->CrossLink())
	lang = 0x0D7;
      else {
	 u = G->userlist->Find(par);
	 if (!u || !bfl.Set(u)->GlobBot())
	   lang = 0x028;
	 else if (!(up = (Bot *)G->socklist->Find(tb->Uplink()->Key(), DCT_BOT)))
	   lang = 0x028;
	 else {
	    while ((ptr = ptr->Next()))
	      if ((ptr->User() == u) && ((ptr->Type() == BNET->BOT_FORK)
					 || (ptr->Type() == BNET->BOT_LINK)) 
		  || (ptr->Type() == BNET->BOT_PASS)) {
		 lang = 0x027;
		 break;
	      }
	    if (!ptr) {
	       /* address to connect to is in 'info' */
	       bi = (UserEntryBotaddr *)(u->FindEntry(BNET->entrytype_botaddr));
	       if (!bi) {
		  if (idx)
		    idx->Send(BNET->Lang(0x02B, "s", par));
		  lang = 0x02D;
	       } else if (G->dcc_total == G->max_dcc) 
		    lang = 0x02C;
	       else {
		  context;
		  bot = NEW ( BotFork ( u, bi, "", up) );
		  idx->Send(BNET->Lang(0x02E,"ssd",par,bi->Value(),bi->Telnet()));
		  if (!bot->Scan(bot->RemotePort() + G->port_range))
		    return EXECUTED;
		  bot->Eof();
	       }
	    }
	 }
      }
   }
   if (lang) 
     idx->Send(BNET->Lang(lang, "s", par));
   return EXECUTED;
}

static BindReturn cmd_unlink (void ** args, const char *) {
   FUNCTION;
   Socket * ptr = G->socklist, * idx = (Socket *)args[0];
   Bot * botp;
   char *bot, *par = (char *)args[1], x[NOTENAMELEN+11];
   TandemBot * tb;
   PartyLiner * pptr = BNET->party, * pnext = pptr->Next();
   DccChat * dcc;
   
   if (!par[0]) 
     idx->Send(BNET->Lang(0x075, ""));
   else {
      G->LOG_CMDS.Put(BNET->Lang(0x076, "ss", idx->Nick(), par));
      bot = G->Split(&par);
      if (bot[0] == '*') {
	 idx->Send(BNET->Lang(0x02F, ""));
	 while ((ptr = ptr->Next())) 
	   if (ptr->TypeFlags() & DCT_BOT)
	     ptr->Close();
	 idx->Send(BNET->Lang(0x036, ""));
	 while (BNET->tandbot->Next())
	   DELETE ( BNET->tandbot->Next() );
	 while ((pptr = pnext)) {
	    pnext = pptr->Next();
	    if (pptr->BotName()[0])
	      DELETE ( pptr );
	 }
	 dcc = (DccChat *)G->socklist;
	 while ((dcc = dcc->Next()))
	   dcc->CheckLChjn();
	 args[0] = 0;
	 BNET->bt_disc->Check("!", 0, args);
      } else if ((tb = BNET->tandbot->Find(bot)) && tb->Uplink()) {
	 G->SPrintF(x, NOTENAMELEN + 10, "%d:%s@%s", idx->FD(), 
		    idx->Nick(), G->botnetnick);
	 if ((botp = tb->NextBot())) 
	   botp->SendUnLink(x,tb,par);
      } else if (!BNET->Unlink(bot, idx, par))
	   idx->Send(BNET->Lang(0x035, ""));
   }
   return EXECUTED;
}

static BindReturn cmd_trace (void ** args, const char *) {
   FUNCTION;
   Socket * idx = (Socket *)args[0];
   Bot * ptr = 0;
   char x[NOTENAMELEN+11], y[11], *par = (char *)args[1];
   int lang = 0;
   TandemBot * tb;
   
   if (!par[0]) 
     lang = 0x077;
   else if (!strcasecmp(par, G->botnetnick))
     lang = 0x078;
   else if (!(tb = BNET->tandbot->Find(par)) || !(ptr = tb->NextBot()))
     lang = 0x058;
   else {
      G->LOG_CMDS.Put(BNET->Lang(0x079, "ss", idx->Nick(), par));
      G->SPrintF(x, NOTENAMELEN+10, "%d:%s@%s", idx->FD(), idx->Nick(),
		 G->botnetnick);
      G->SPrintF(y, 10, ":%d", G->now);
      ptr->SendTrace(x, par, y);
   }
   if (lang)
     idx->Send(BNET->Lang(lang, ""));
   return EXECUTED;
}

static BindReturn cmd_botattr (void ** args, const char *) {
   FUNCTION;
   char * hand, * chg = NULL, work[1024], *par = (char *)args[1];
   Channel *chan = NULL;
   DccChat * idx = (DccChat *)args[0];
   UserRecord * u2 = 0, *u = idx->User();
   FlagRecord pls, mns, user;
   int lang = 0;
   
   if (!par[0]) 
     lang = 0x07A;
   else if (((hand = G->Split(&par))[0] == '*') ||
	    !(u2 = G->userlist->Find(hand)) || !pls.Set(u2)->GlobBot())
     lang = 0x07B;
   else if (G->socklist->Find(hand, DCT_BOT))
     lang = 0x0D0;
   else {
      if ((par[0] != '#') && (par[0] != '&')) {
	 chg = G->Split(&par);
	 if (!par[0] && strpbrk(chg, "|&"))
	   par = idx->ConsoleChan();
      }
      if (!(chan = G->chanset->Find(par)) && par[0]) 
	lang = 0x07C;
      else {
	 user.Set(u);
	 if (!user.GlobBotmast())
	   lang = 0x07D;
	 else {
	    if (chg) {
	       pls.SetMatch ( FlagRecord::BOT | (chan ? FlagRecord::CHANNEL : 0) );
	       pls.BreakDown(chg, &mns);
	       /* no-one can change these flags on-the-fly */
	       pls.ClearGlobBot();
	       mns.ClearGlobBot();
	       if (chan && user.GlobOwner()) {
		  pls.ClearButShare();
		  mns.ClearButShare();
	       } else {
		  pls.ClearChan();
		  mns.ClearChan();
	       }
	       if (!user.GlobOwner()) {
		  pls.KillOwnerBotFlags();
		  mns.KillOwnerBotFlags();
	       }
	       user.SetMatch(pls.Match());
	       user.Set(u2,par);
	       user += pls;
	       user -= mns;
	       user.SetGlobBot();
	       user.Sanity();
	       u2->Set(user,par);
	    }
	    G->LOG_CMDS.Put(BNET->Lang(chg ? 0x07E : 0x07F, "sssss", idx->Nick(),
					hand, par, chg, chan ? chan->Key() : "*"));
	    /* get current flags and display them */
	    if (!chan || pls.Bot() || mns.Bot()) {
	       user.SetMatch(FlagRecord::BOT);
	       user.Set(u2,0);
	       user.Build(work,0);
	       idx->Send(BNET->Lang((work[0] != '-') ? 0x080 : 0x081,
				    "ss", hand,work));
	    }
	    if (chan) {      
	       user.SetMatch(FlagRecord::CHANNEL);
	       user.Set(u2,par);
	       user.BotFlagsOnly();
	       user.Build(work, 0);
	       idx->Send(BNET->Lang((work[0] != '-') ? 0x082 : 0x083, 
				    "sss", hand, chan->Key(), work));
	    }
	 }
      }
   }
   if (lang)
     idx->Send(BNET->Lang(lang, "s", par));
   return EXECUTED;
}

static BindReturn cmd_rwho (void ** args, const char *) {
   FUNCTION;
   DccChat * idx = (DccChat *)args[0];
   Bot * ptr = 0;
   char * par = (char *)args[1], s[NOTENAMELEN+11];
   int lang = 0;
   TandemBot * tb;
   
   if (!par[0]) 
     lang = 0x084;
   else {
      G->LOG_CMDS.Put(BNET->Lang(0x0AF, "ss", idx->Nick(), par));
      if (!strcasecmp(par, G->botnetnick))
	lang = 0x085;
      else if (!(tb = BNET->tandbot->Find(par)) || !(ptr = tb->NextBot()))
	lang = 0x058;
      else if (idx->Channel() >= GLOBAL_CHANS)
	lang = 0x086;
      else {
	 G->SPrintF(s, NOTENAMELEN + 10, "%d:%s@%s", idx->FD(),
		    idx->Nick(), G->botnetnick);
	 ptr->SendWho(s,par, idx->Channel());
      }
   }
   if (lang)
     idx->Send(BNET->Lang(lang, ""));
   return EXECUTED;
}

static BindReturn cmd_modules (void ** args, const char *) {
   FUNCTION;
   Socket * idx = (Socket *)args[0], * ptr = 0;
   char * par = (char *)args[1];
   int lang = 0;
   TandemBot * tb;
   
   context;
   if (!par[0])
     lang = 0x087;
   else {
      G->LOG_CMDS.Put(BNET->Lang(0x088, "ss", idx->Nick(), par));
      if ((tb = BNET->tandbot->Find(par)) && (ptr = tb->NextBot()))
	ptr->Printf("v %s %s %d:%s\n", G->botnetnick, par, idx->FD(),idx->Nick());
      else
	lang = 0x058;
   }
   if (lang)
     idx->Send(BNET->Lang(lang, ""));
   return EXECUTED;
}

#define DCC_COMMANDS 16
static command_binds my_dcc[DCC_COMMANDS]={
   { "+bot", "t", cmd_pls_bot, NULL },
   { "rboot", "t", cmd_rboot, NULL },
   { "botattr", "t", cmd_botattr, NULL },
   { "botinfo", "t", cmd_botinfo, NULL },
   { "bots", "", cmd_bots, NULL },
   { "bottree", "t", cmd_bottree, NULL },
   { "chaddr", "t", cmd_chaddr, NULL },
   { "crosslink", "n", cmd_crosslink, NULL },
   { "link", "t", cmd_link, NULL },
   { "rmotd", "", cmd_rmotd, NULL },
   { "trace", "", cmd_trace, NULL },
   { "unlink", "t", cmd_unlink, NULL },
   { "vbottree", "t", cmd_bottree, NULL },
   { "whom", "", cmd_whom, NULL },
   { "rwho", "t", cmd_rwho, NULL },
   { "modules", "n", cmd_modules, NULL },
};

/*************************************************************************
 * INCOMING MESSAGES - breaking down                                     *
 *************************************************************************/
   
static struct bot_table_struct bot_table[BOT_TABLE_SIZE] = {
   { "A",  &Bot::BotAway },
   { "B",  &Bot::ProcessThisBot },
   { "C",  &Bot::BotChat },
   { "E",  &Bot::ProcessEndLink },
   { "I",  &Bot::ProcessInfoQ },
   { "J",  &Bot::BotPart },
   { "L",  &Bot::BotUnLink },
   { "M",  &Bot::BotMotd },
   { "N",  &Bot::BotUnLinked },
   { "P",  &Bot::ProcessPong },
   { "T",  &Bot::BotTraced },
   { "X",  &Bot::BotUnCrossLink },
   { "Z",  &Bot::BotZapfBroad },
   { "a",  &Bot::BotActChan },
   { "b",  &Bot::ProcessBye },
   { "c",  &Bot::BotChan },
   { "e",  &Bot::BotChatter },
   { "i",  &Bot::BotIdle },
   { "j",  &Bot::BotJoin },
   { "k",  &Bot::BotNickChange },
   { "l",  &Bot::Bot_Link },
   { "m",  &Bot::BotPriv },
   { "n",  &Bot::BotNLinked },
   { "p",  &Bot::ProcessPing },
   { "r",  &Bot::BotReject },
   { "t",  &Bot::BotTrace },
   { "u",  &Bot::BotUpdate },
   { "v",  &Bot::BotVersions },
   { "w",  &Bot::BotWho },
   { "x",  &Bot::BotCrossLink },
   { "z",  &Bot::BotZapf },
};

/****************************************************************************
 * MISC MODULES STUFF                                                       *
 ****************************************************************************/

static BindReturn botnet_die (void ** args, const char *) {
   FUNCTION;
   NullBot()->SendBye(BNET->Lang(0x0C6, "s", args[0]));
   return EXECUTED;
}

static command_binds my_die[]={
   { "*", "", botnet_die, "botnet"},
};

static BindReturn botnet_lchjn (void ** args, const char *) {
   FUNCTION;
   char buf[32];
   DccChat * sock = (DccChat *)args[0];
   int i;
   void * argv[1];
   PartyLiner * ptr = NEW ( PartyLiner (BNET->tandbot, sock->Nick(), 
					sock->Channel(),
					sock->GetIcon(), sock->FD(),
					sock->Host(), &i));
   NullBot()->SendJoin(0, ptr, i);
   strcpy(buf, G->ToBase10(ptr->Chan()));
   argv[0] = ptr;
   BNET->bt_chjn->Check(buf, NULL, argv);
   return EXECUTED;
}

static command_binds my_lchjn[] = {
   { "*", "", botnet_lchjn, "botnet"},
};

static BindReturn botnet_lchpt (void ** args, const char *) {
   FUNCTION;
   DccChat * sock = (DccChat *)args[0];
   PartyLiner * ptr = BNET->tandbot->FindParty(sock->FD());
   
   if (ptr) {
      NullBot()->SendPart(ptr, (char *)args[1], 0);
      DELETE ( ptr );
   }
   return EXECUTED;
}

static command_binds my_lchpt[] = { 
   { "*", "", botnet_lchpt, "botnet"},
};

static BindReturn botnet_act ( void ** args, const char *) {
   FUNCTION;
   char * nick = (char *)args[0];
   PartyLiner * ptr = 0;
   
   if (!strchr(nick, '@') 
       && (ptr = BNET->tandbot->FindParty(nick, *(int *)args[1]))) 
     NullBot()->SendAct(ptr, (char *)args[2]);
   return EXECUTED;
}

static command_binds my_act[] = { 
   { "*", "", botnet_act, "botnet:act"},
};

static BindReturn botnet_chat ( void ** args, const char *) {
   FUNCTION;
   char * nick = (char *)args[0];
   PartyLiner * ptr = 0;
   
   if (!strchr(nick, '@') 
       && (ptr = BNET->tandbot->FindParty(nick, *(int *)args[1]))) 
     NullBot()->SendChan(ptr, (char *)args[2]);
   return EXECUTED;
}

static command_binds my_chat[] = { 
   { "*", "", botnet_chat, "botnet"},
};

static BindReturn botnet_bcst ( void ** args, const char *) {
   FUNCTION;
   int chan = *(int *)(args[1]);
   
   if (!strcasecmp((char *)args[0], G->botnetnick)) {
      if (chan == -1) 
	NullBot()->SendChat((char *)args[0], (char *)args[2]);
      else
	NullBot()->SendChatter(G->botnetnick, chan, (char *)args[2]);
   }
   return EXECUTED;
}

static command_binds my_bcst[] = { 
   { "*", "", botnet_bcst, "botnet"},
};

static BindReturn botnet_lnkch ( void ** args, const char *) {
   FUNCTION;
   PartyLiner * ptr;
   
   for (ptr = BNET->tandbot->PartyLiners(); ptr; ptr = ptr->NextByBot())
     if (!strcasecmp(ptr->Nick(), (char *)args[0])) {
	ptr->SetKey((char *)args[1]);
	NullBot()->SendNkCh(ptr, (char *)args[0]);
     }
   return EXECUTED;
}

static command_binds my_lnkch[] = { 
   { "*", "", botnet_lnkch, "botnet"},
};

static BindReturn botnet_away ( void ** args, const char *) {
   FUNCTION;
   int sock = *(int *)args[1];
   PartyLiner * ptr = 0;
   char * par = (char *)args[2];
   
   if (!strcasecmp((char *)args[0],G->botnetnick)
       && (ptr = BNET->tandbot->FindParty(sock))) {
      ptr->SetAway(par);
      NullBot()->SendAway(ptr, 0);
   }
   return EXECUTED;
}

static command_binds my_away[] = { 
   { "*", "", botnet_away, "botnet"},
};

static BindReturn botnet_notes (void ** args, const char *) {
   FUNCTION;
   char x[NOTENAMELEN+1], *p, botf[81], ssf[81], *from = (char *)args[0];
   Socket * idx = (Socket *)args[4];
   Bot * ptr = 0;
   TandemBot * tb;
   
   strncpyz(x, (char *)args[3], NOTENAMELEN);
   if ((p = strchr(x, '@'))) {
      *p = 0;
      p++;
      if (!strcasecmp(p, G->botnetnick)) 
	G->AddNote(x, from, (char *)args[2], idx, 0);
      else {
	 if (!strcasecmp(from, G->botnetnick)) 
	   strcpy(botf, G->botnetnick);
	 else if (strchr(from,'@')) 
	   strcpy(botf, from);
	 else
	   G->SPrintF(botf, 80, "%s@%s", from, G->botnetnick);
	 if (!(tb = BNET->tandbot->Find(p)) || !(ptr = tb->NextBot())) {
	    if (idx)
	      idx->Send(BNET->Lang(0x058, ""));
	 } else {
	    *--p = '@';
	    if (idx) {
	       G->SPrintF(ssf, 80, "%d:%s",idx->FD(),botf);
	       ptr->SendPriv(ssf,x, (char *)args[2]);
	    } else
	      ptr->SendPriv(botf,x, (char *)args[2]);
	 }
      }
      return EXEC_LOG;
   }
   return EXECUTED;
}

static command_binds my_notes[] = { 
   { "*", "", botnet_notes, "botnet"},
};

/* once a minute, send 'ping' to each bot -- no exceptions */
static void check_botnet_pings(void) { 
   FUNCTION;
   Bot * ptr = (Bot *)G->socklist;
   char * s;
   TandemBot * tb = 0;
   
   context;
   while ((ptr = ptr->Next())) {
      if (ptr->TypeFlags() & DCT_REALBOT) {
	 tb = BNET->tandbot->Find(ptr->Nick());
	 if (ptr->HasStatus(Bot::PINGED)) {
	    BNET->LOG_BOTS.Put(s = BNET->Lang(0x0C9, "s", ptr->Nick()));
	    ptr->SendUnLinked(tb, s, 0);
	    ptr->Close();
	    continue;
	 } 
	 ptr->SetStatus(Bot::PINGED);
	 ptr->SendPing();
	 if (ptr->HasStatus(Bot::LEAF) && tb && tb->Children()) {
	    /* not leaflike behavior */
	    if (ptr->HasStatus(Bot::WARNED)) {
	       BNET->LOG_BOTS.Put(s = BNET->Lang(0x0CA, "s", ptr->Nick()));
	       ptr->SendBye(BNET->Lang(0x0AB, ""));
	       ptr->SendUnLinked(tb, s,0);
	       ptr->Close();
	       continue;
	    } else {
	       ptr->SendReject(G->botnetnick, (char *)tb->Children()->Name(), 
			       BNET->Lang(0x0CC, "s", ptr->Nick()));
	       ptr->SetStatus(Bot::WARNED);
	    }
	 } else
	   ptr->ClearStatus(Bot::WARNED);
      }
      context;
   }
}

static void botnet_minutely (void) {
   FUNCTION;
   BNET->AutoLink ( 0 );
}

static BindReturn botnet_listen (void ** args, const char * mask) {
   FUNCTION;
   Socket * idx = (Socket *)args[0];
   
   if (!strcmp(mask,"(bots)")) {
      BNET->LOG_BOTS.Put(BNET->Lang(0x0CB,"dsd", idx->LocalPort(), idx->Host(),
				    idx->RemotePort()));
      NEW ( BotLogin ( *idx ) );
   }
   return EXECUTED;
}

static void botnet_rehash ( void ) {
   FUNCTION;
   if (G->debug_output)
     BNET->tandbot->SetBotnetFlags(Bot::TRAFWATCH);
   else
     BNET->tandbot->UnSetBotnetFlags(Bot::TRAFWATCH);
   BNET->tandbot->Update(NullBot(),0,0,0);
}
     
static command_binds my_list[1] =  {
   { "(bots)", "", botnet_listen, NULL }
};

char * botnet_start (ModuleEntryEggdrop * G, ModuleEntry * me) {
   FUNCTION;
   char * r = 0;
   ::G = G;
   BNET = NEW ( ModuleEntryBotnet ( me, G, &r ) );
   G->bt_dcc->AddBinds(my_dcc, DCC_COMMANDS,BNET);
   G->bt_listen->AddBinds(my_list, 1,BNET);
   G->bt_die->AddBinds(my_die, 1,BNET);
   G->bt_lchjn->AddBinds(my_lchjn, 1,BNET);
   G->bt_lchpt->AddBinds(my_lchpt, 1,BNET);
   G->bt_chat->AddBinds(my_chat, 1,BNET);
   G->bt_bcst->AddBinds(my_bcst, 1,BNET);
   G->bt_act->AddBinds(my_act, 1,BNET);
   G->bt_away->AddBinds(my_away, 1,BNET);
   G->bt_lnkch->AddBinds(my_lnkch, 1,BNET);
   G->bt_note->AddBinds(my_notes, 1,BNET);
   G->hook_5minutely->Add(check_botnet_pings,BNET);
   G->hook_minutely->Add(botnet_minutely,BNET);
   G->hook_rehash->Add(botnet_rehash,BNET);
   NEW ( Command ( "putbot", script_putbot, BNET) );
   NEW ( Command ( "putallbots", script_putallbots, BNET ) );
   NEW ( Command ( "bots", script_bots, BNET ) );
   NEW ( Command ( "botlist", script_botlist, BNET ) );
   NEW ( Command ( "whom", script_whom, BNET ) );
   NEW ( Command ( "link", script_link, BNET ) );
   NEW ( Command ( "unlink", script_unlink, BNET ) );
   NEW ( Command ( "boot", script_boot, BNET ) );
   NEW ( Command ( "addbot", script_addbot, BNET ) );
   NEW ( Command ( "botattr", script_botattr, BNET ) );
   NEW ( Command ( "botport", script_botport, BNET ) );
   BNET->bot_table = bot_table;
   return r;
}
