/*
 * Bot11.C
 */
/*
 * This file is part of the eggdrop 2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ModuleEntryBotnet1_1.h"
#include "Version.h"
#include "Bot11.h"
#include "TandemBot.h"
#include "botnet.h"
#include "PartyLiner.h"
#include "FlagRecord.h"
#define CLASS "Bot11"

Bot11::Bot11 ( BotLink & a, char * b) : Bot (a, b, "1.1-1.2 BOTNET") {
   FUNCTION;
   bot_table = B11->bot_table;
   size = 30;
}

Bot11::~Bot11 ( void ) {
   FUNCTION;
}

/* chan <from> <chan> <text> */
void Bot11::Chan (char * msg) {
   FUNCTION;
   char * from = G->Split(&msg);
   char * p = G->Split(&msg);
   char * i = strchr(from, '@');
   
   if (i) {
      TandemBot * tb = B11->BOTNET->tandbot->Find(i + 1);
      
      *i = 0;
      if (tb) {
	 PartyLiner * pl = tb->FindParty(from, G->Base64To(p));
	 
	 if (pl)
	   ProcessChan(i + 1, pl->Sock(), msg);
      }
   } else 
     ProcessChatter(from, G->Base64To(p), msg);
}

/* actchan <from> <chan> <text> */
void Bot11::ActChan (char * par) {
   FUNCTION;
   char *from = G->Split(&par);
   char *p = G->Split(&par);
   char * i = strchr(from, '@');
   
   if (i) {
      TandemBot * tb = B11->BOTNET->tandbot->Find(i + 1);
      
      *i = 0;
      if (tb) {
	 PartyLiner * pl = tb->FindParty(from, G->Base64To(p));
	 
	 if (pl)
	   ProcessActChan(i + 1, pl->Sock(), par);
      }
   }
}

/* who <from@bot> <tobot> <chan#> */
void Bot11::Who (char * par) {
   FUNCTION;
   char *nick, *to, TBUF[511];
   
   context;
   nick = G->Split(&par);
   if (!strchr(nick, '@')) {
      G->SPrintF(TBUF, 511, "%s@%s", nick, nick);
      nick = TBUF;
   }
   to = G->Split(&par);
   ProcessWho(nick, to, atoi(G->Split(&par)));
}

/* bot next share? */
void Bot11::Update (char * par)  {
   FUNCTION;
   char * bot = G->Split(&par), x;
   TandemBot * tb;
   
   context;
   if ((x = par[0]))
     par++;
   if ((tb = B11->BOTNET->tandbot->Find(bot)))
     tb->Update(this, x, atoi(par));
}

/* nlinked <newbot> <next> <share?version> */
void Bot11::NLinked (char * par) {
   FUNCTION;
   char *newbot, *next, x;
   
   context;
   newbot = G->Split(&par);
   next = G->Split(&par);
   if ((x = par[0])) 
     par++;
   else 
     x = '-';
   ProcessNLinked(newbot, next, x, atoi(par), 0);
}

void Bot11::Handshake (char * par) {
   FUNCTION;
   context;
   if (strlen(par) > 9)
     par[9] = 0;
   ProcessHandshake(par);
}

/* join <bot> <nick> <chan> <flag><sock> <from> */
void Bot11::Join (char * par) {
   FUNCTION;
   char * bot = G->Split(&par);
   char * nick = G->Split(&par);
   char * x = G->Split(&par);
   char * y = G->Split(&par);
   int sn = atoi(y + 1);
   
   if (sn == MAP_ZERO)
     sn = 0;
   ProcessJoin(bot, nick, atoi(x), y[0], sn, par, 1);
}

/* part <bot> <nick> <sock> [etc..] */
void Bot11::Part (char * par) {
   FUNCTION;
   char * bot = G->Split(&par);
   char * nick = G->Split(&par);
   char * etc = G->Split(&par);
   int sn = atoi(etc);
   
   if (sn == MAP_ZERO)
     sn = 0;
   ProcessPart(bot, nick, sn, par, 1);
}

/* away <bot> <sock> <message> */
void Bot11::Away (char * par) {
   FUNCTION;
   char * bot = G->Split(&par);
   char * etc = G->Split(&par);
   int sn = atoi(etc);
   
   if (sn == MAP_ZERO)
     sn = 0;
   ProcessAway(bot, sn, par, 1);
}

/* idle <bot> <sock> <#secs> [away msg]*/
void Bot11::Idle (char * par) {
   FUNCTION;
   char * bot = G->Split(&par);
   char * ssock = G->Split(&par);
   char * idle = G->Split(&par);
   int sn = atoi(ssock);
   
   if (sn == MAP_ZERO)
     sn = 0;
   ProcessIdle(bot, sn, atoi(idle), par);
}

void Bot11::Userfile (char *)  {
   FUNCTION;
   context;
   B11->BOTNET->LOG_BOTS.Put(0, "%s %s", "old share request", nick);
   Printf("uf-no %s\n", "Antiquated share request");
}

void Bot11::SendMotd (const char * from, const char * to) {
   FUNCTION;
   Printf("motd %s %s\n", from, to);
}

void Bot11::SendReject (const char * from, const char * to, const char * reason) {
   FUNCTION;
   Printf("reject %s %s %s\n", from, to, reason);
}

void Bot11::SendTrace (const char * to, const char * from, const char * buf) {
   FUNCTION;
   Printf("trace %s %s %s:%s\n", to, from, buf, G->botnetnick);
}

void Bot11::SendWho (const char * from, const char * to, int chan) {
   FUNCTION;
   Printf("who %s %s %d\n",from,to, chan);
}

void Bot11::SendPing (void) {
   FUNCTION;
   Dump("ping\n",5);
}

void Bot11::SendPong (void) {
   FUNCTION;
   Dump("pong\n",5);
}

void Bot11::SendUnLink (const char * who , TandemBot * bot, 
			const char * reason) {
   FUNCTION;
   Printf("unlink %s %s %s %s\n", who, bot->UplinkName(), bot->Name(),reason);
}   

void Bot11::SendLink (const char * who, const char * via, const char * bot) {
   FUNCTION;
   Printf("link %s %s %s\n", who, via, bot);
}

void Bot11::SendTraced (const char * bot, const char * buf) {
   FUNCTION;
   Printf("traced %s %s\n",bot,buf);
}
			 
void Bot11::SendZapf (const char * a, const char * b, const char * c) {
   FUNCTION;
   Printf("zapf %s %s %s\n", a, b, c);
}

void Bot11::SendFakeAlert (const char * item, const char * extra) {
   FUNCTION;
   char * p = B11->BOTNET->Lang(0x009, "sss", Nick(), item, extra);
   Printf("chat %s %s\n",G->botnetnick, p);
   B11->BOTNET->LOG_BOTS.Put(p);
}

/* dump list of links to a new bot */
void Bot11::SendLinkInfo (void) {
   FUNCTION;
   TandemBot * bot = B11->BOTNET->tandbot;
   PartyLiner * ptr = B11->BOTNET->party;
   FlagRecord bfl ( user, FlagRecord::BOT );
   
   context;
   while ((bot = bot->Next()))
     if (strcasecmp(bot->Key(), nick))
       Printf("nlinked %s %s %c%d\n",bot->Name(), bot->UplinkName(),
	      bot->Share(),  bot->Version());
   if (!bfl.BotIsolate()) {
      while ((ptr = ptr->Next())) {
	 int sn = ptr->Sock();
	 
	 if (!sn)
	   sn = MAP_ZERO;
	 
	 Printf("join %s %s %d %c%d %s\n", ptr->BotName(), ptr->Nick(),
		ptr->Chan(), fconv(ptr->Flag()), sn, ptr->From());
	 if (ptr->Away()) 
	   Printf("away %s %d %s\n", ptr->BotName(), sn, ptr->Away());
	 if (ptr->Timer()) 
	   Printf("idle %s %d %d\n", ptr->BotName(), sn, ptr->Age());
      }
   }
}

void Bot11::SendPriv (const char * from, const char * to, const char * message) {
   FUNCTION;
   Printf("priv %s %s %s\n",from,to,message);
}
 
void Bot11::SendBye2 (const char * why) {
   FUNCTION;
   Printf("chat %s %s\n", G->botnetnick, why);
   Printf("bye\n");
}
