/*
 * ModuleEntryBotnet1_1.C
 */
/*
 * This file is part of the eggdrop 2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ModuleEntryBotnet1_1.h"
#include "Version.h"
#include "Bot.h"
#include "TandemBot.h"
#include "botnet.h"
#define CLASS "ModuleEntryBotnet1_1"

static Version botnet1_1_version;
static struct patches botnet1_1_patches [] = {
#include "patch.h"
};

ModuleEntryBotnet1_1::ModuleEntryBotnet1_1 ( ModuleEntry * me, char ** r) :
ModuleEntry ("botnet1_1", botnet1_1_version.Set(2,0), botnet1_1_patches, me) {
   FUNCTION;
   Version required;
   
   if (!(BOTNET = (ModuleEntryBotnet *)Depend("botnet", required.Set(2,0))))
     *r = "This module requires the botnet module";
}

ModuleEntryBotnet1_1::~ModuleEntryBotnet1_1 (void) {
   FUNCTION;
   Bot * ptr = (Bot *)G->socklist;
   TandemBot * tb = 0;
     
   G->LOG_MISC.Put("Unloading botnet1.1 support, unlinking all 1.1 bots");
   while ((ptr = ptr->Next()))
     if ((ptr->Type() == BOTNET->BOT) && 
	 (ptr->Numver() < NEAT_BOTNET) && (ptr->Numver() >= LOWEST_BOTNET)
	 && (tb = BOTNET->tandbot->Find(ptr->Nick())))
       BOTNET->Unlink(ptr->Nick(), G->Log, "botnet1.1 support unloaded");
   BOTNET->RemMassbotFuncs(B11->my_massbots);
}

int ModuleEntryBotnet1_1::ExpMem ( void ) {
   FUNCTION;
   return sizeof(ModuleEntryBotnet1_1) + ModuleEntry::ExpMem();
}
