/*
 * Bot13.C
 */
/*
 * This file is part of the eggdrop 2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ModuleEntryBotnet1_3.h"
#include "ModuleEntryBotnet.h"
#include "Bot13.h"
#include "botnet.h"
#include "TandemBot.h"
#include "FlagRecord.h"
#include "PartyLiner.h"
#define CLASS "Bot13"

Bot13::Bot13 ( BotLink & a, char * b) : Bot (a, b, "1.3 BOTNET") {
   FUNCTION;
   bot_table = B13->bot_table;
   size = 29;
   SetStatus(LINKING);
}

Bot13::~Bot13 ( void ) {
   FUNCTION;
}
 
/* chan <from> <chan> <text> */
void Bot13::Chan (char * msg) {
   FUNCTION;
   char * from = G->Split(&msg);
   char * p = G->Split(&msg);
   char * i = strchr(from, '@');
   
   if (i) {
      TandemBot * tb = B13->BOTNET->tandbot->Find(i + 1);
      
      *i = 0;
      if (tb) {
	 PartyLiner * pl = tb->FindParty(from, G->Base64To(p));
	 
	 if (pl)
	   ProcessChan(i + 1, pl->Sock(), msg);
      }
   } else 
     ProcessChatter(from, G->Base64To(p), msg);
}

/* actchan <from> <chan> <text> */
void Bot13::ActChan (char * par) {
   FUNCTION;
   char *from = G->Split(&par);
   char *p = G->Split(&par);
   char * i = strchr(from, '@');
   
   if (i) {
      TandemBot * tb = B13->BOTNET->tandbot->Find(i + 1);
      
      *i = 0;
      if (tb) {
	 PartyLiner * pl = tb->FindParty(from, G->Base64To(p));
	 
	 if (pl)
	   ProcessActChan(i + 1, pl->Sock(), par);
      }
   }
}

/* who <from@bot> <tobot> <chan#> */
void Bot13::Who (char * par) {
   FUNCTION;
   char *nck, *to, TBUF[511];
   
   context;
   nck = G->Split(&par);
   if (!strchr(nck, '@')) {
      G->SPrintF(TBUF, 511, "%s@%s", nck, nick);
      nck = TBUF;
   }
   to = G->Split(&par);
   ProcessWho(nck, to, atoi(G->Split(&par)));
}

/* bot next share? */
void Bot13::Update (char * par)  {
   FUNCTION;
   char * bot = G->Split(&par), x;
   TandemBot * tb;
   
   context;
   if ((x = par[0]))
     par++;
   if ((tb = B13->BOTNET->tandbot->Find(bot)))
     tb->Update(this, x, G->Base64To(par), 0);
}

/* nlinked <newbot> <next> <share?version> */
void Bot13::NLinked (char * par) {
   FUNCTION;
   char *newbot, *next, x;
   
   context;
   newbot = G->Split(&par);
   next = G->Split(&par);
   if ((x = par[0])) 
     par++;
   else 
     x = '-';
   ProcessNLinked(newbot, next, x, G->Base64To(par), 0);
}

/* join <bot> <nick> <chan> <flag><sock> <from> */
void Bot13::Join (char * par) {
   FUNCTION;
   char * bot = G->Split(&par);
   char * nick = G->Split(&par);
   char * x = G->Split(&par);
   char * y = G->Split(&par);
   int sn = G->Base64To(y + 1), linking = HasStatus(LINKING);
   
   if (bot[0] == '!') {
      linking = 1;
      bot++;
   }
   if (sn == MAP_ZERO)
     sn = 0;
   ProcessJoin(bot, nick, G->Base64To(x), y[0], sn, par, linking);
}

/* part <bot> <nick> <sock> [etc..] */
void Bot13::Part (char * par) {
   FUNCTION;
   char * bot = G->Split(&par);
   char * nick = G->Split(&par);
   char * etc = G->Split(&par);
   int sn = G->Base64To(etc);
   int silent = 0;
   
   if (sn == MAP_ZERO)
     sn = 0;
   if (bot[0] == '!') {
      bot++;
      silent = 1;
   }
   ProcessPart(bot, nick, sn, par, silent);
}

/* away <bot> <sock> <message> */
void Bot13::Away (char * par) {
   FUNCTION;
   char * bot = G->Split(&par);
   char * etc = G->Split(&par);
   int sn = G->Base64To(etc), linking = HasStatus(LINKING);
   
   if (bot[0] == '!') {
      linking = 1;
      bot++;
   }
   if (sn == MAP_ZERO)
     sn = 0;
   ProcessAway(bot, sn, par, linking);
}

/* idle <bot> <sock> <#secs> [away msg]*/
void Bot13::Idle (char * par) {
   FUNCTION;
   char * bot = G->Split(&par);
   char * ssock = G->Split(&par);
   char * idle = G->Split(&par);
   int sn = G->Base64To(ssock);
   
   if (sn == MAP_ZERO)
     sn = 0;
   ProcessIdle(bot, sn, G->Base64To(idle), par);
}
   
/**************************************************************************
 * specific bot destined messages                                         *
 **************************************************************************/

static char OBUF[512];

void Bot13::SendMotd (const char * from, const char * to) {
   FUNCTION;
   Printf("m %s %s\n", from, to);
}

void Bot13::SendReject (const char * from, const char * to, const char * reason) {
   FUNCTION;
   Printf("r %s %s %s\n", from, to, reason);
}

void Bot13::SendTrace (const char * to, const char * from, const char * buf) {
   FUNCTION;
   Printf("t %s %s %s:%s\n", to, from, buf, G->botnetnick);
}

void Bot13::SendWho (const char * from, const char * to, int chan) {
   FUNCTION;
   Dump(OBUF, G->SPrintF(OBUF, 511, "w %s %s %D\n",from,to, chan));
}

void Bot13::SendPing (void) {
   FUNCTION;
   Dump("pi\n",3);
}

void Bot13::SendPong (void) {
   FUNCTION;
   Dump("po\n",3);
}

void Bot13::SendUnLink (const char * who , TandemBot * bot, 
			const char * reason) {
   FUNCTION;
   Printf("ul %s %s %s %s\n", who, bot->UplinkName(), bot->Name(), reason);
}   

void Bot13::SendLink (const char * who, const char * via, const char * bot) {
   FUNCTION;
   Printf(" %s %s %s\n", who, via, bot);
}

void Bot13::SendTraced (const char * bot, const char * buf) {
   FUNCTION;
   Printf("td %s %s\n",bot,buf);
}
			 
void Bot13::SendZapf (const char * a, const char * b, const char * c) {
   FUNCTION;
   Printf("z %s %s %s\n", a, b, c);
}

void Bot13::SendFakeAlert (const char * item, const char * extra) {
   FUNCTION;
   char * p = B13->BOTNET->Lang(0x009, "sss", nick, item, extra);
   Printf("ct %s %s\n",G->botnetnick, p);
   B13->BOTNET->LOG_BOTS.Put(p);
}

/* dump list of links to a new bot */
void Bot13::SendLinkInfo (void) {
   FUNCTION;
   TandemBot * bot = B13->BOTNET->tandbot;
   PartyLiner * ptr = B13->BOTNET->party;
   FlagRecord bfl ( FlagRecord::BOT );
   
   context;
   while ((bot = bot->Next()))
     if (strcasecmp(bot->Key(), nick))
       Dump(OBUF, G->SPrintF(OBUF, 511, "n %s %s %c%D\n", 
			     bot->Name(), bot->UplinkName(),
			     bot->Share(),  bot->Version()));
   bfl.Set(user);
   if (!bfl.BotIsolate()) {
      while ((ptr = ptr->Next())) {
	 int sn = ptr->Sock();
	 
	 context;
	 if (!sn)
	   sn = MAP_ZERO;
	 context;
	 Dump(OBUF, G->SPrintF(OBUF, 511, "j %s %s %D %c%D %s\n", ptr->BotName(),
			       ptr->Nick(), ptr->Chan(), fconv(ptr->Flag()),
			       sn, ptr->From()));
	 context;
	 if (ptr->Away()) 
	   Dump(OBUF, G->SPrintF(OBUF, 511, "aw %s %D %s\n", ptr->BotName(), sn, 
				 ptr->Away()));
	 context;
	 if (ptr->Timer()) 
	   Dump(OBUF, G->SPrintF(OBUF, 511, "i %s %D %D\n", ptr->BotName(), sn,
				 ptr->Age()));
	 context;
      }
   }
   Dump ( "el\n", 3);
   context;
}

void Bot13::SendPriv(const char * from,const char * to,const char * message) {
   FUNCTION;
   Printf("p %s %s %s\n",from,to,message);
}
 
void Bot13::SendBye2 (const char * why) {
   FUNCTION;
   Printf("bye %s\n", why);
}
