/*
 * ModuleEntryBotnet1_3.C
 */
/*
 * This file is part of the eggdrop 2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "ModuleEntryBotnet1_3.h"
#include "ModuleEntryBotnet.h"
#include "Bot.h"
#include "botnet.h"
#include "TandemBot.h"
#define CLASS "ModuleEntryBotnet1_3"

static Version botnet1_3_version;
static struct patches botnet1_3_patches [] = {
#include "patch.h"
};

ModuleEntryBotnet1_3::ModuleEntryBotnet1_3 ( ModuleEntry * old, char ** r) 
: ModuleEntry ( "botnet1_3",  botnet1_3_version.Set(2,0), botnet1_3_patches, old ) {
   FUNCTION;
   Version required;
   
   B13 = this;
   if (!(BOTNET = (ModuleEntryBotnet *)Depend("botnet", required.Set(2,0))))
     *r = "This module requires the botnet module";
}

ModuleEntryBotnet1_3::~ModuleEntryBotnet1_3 ( void ) {
   FUNCTION;
   Bot * ptr = (Bot *)G->socklist;
   TandemBot * tb = 0;
     
   G->LOG_MISC.Put("Unloading botnet1.3 support, unlinking all 1.3 bots");
   while ((ptr = ptr->Next()))
     if ((ptr->Type() == B13->BOTNET->BOT) && 
	 (ptr->Numver() < NEATER_BOTNET) && (ptr->Numver() >= NEAT_BOTNET)
	 && (tb = B13->BOTNET->tandbot->Find(ptr->Nick())))
       B13->BOTNET->Unlink(ptr->Nick(), G->Log, "botnet1.3 support unloaded");
   BOTNET->RemMassbotFuncs(B13->my_massbots);
}

int ModuleEntryBotnet1_3::ExpMem ( void ) {
   FUNCTION;
   return sizeof(ModuleEntryBotnet1_3) + ModuleEntry::ExpMem();
}
