/*
 * botnet1_3.c - support for 1.3 version botnets
 */
/*
 * This file is part of the eggdrop 2 source code
 * copyright (c) 1998 Darrin Smith
 * and is distributed according to the GNU general public license.
 * For full details, read the top of 'main.c' or the file called
 * COPYING that was distributed with this code.
 */

#include "Socket.h"
#include "botnet.h"
#include "UserRecord.h"
#include "BindTable.h"
#include "PartyLiner.h"
#include "Version.h"
#include "ModuleEntryBotnet1_3.h"
#include "ModuleEntryBotnet.h"
#include "Bot13.h"
#include "BotLink.h"
#define CLASS ""

ModuleEntryBotnet1_3 * B13;
static ModuleEntryEggdrop * G;

/**************************************************************************
 * broadcast messages                                                     *
 **************************************************************************/

static char OBUF[512];
static void my_tandout(Bot * sock, char * stuff, int len) {
   FUNCTION;
   Bot * ptr = (Bot *)G->socklist;

   while ((ptr = ptr->Next()))
     if ((ptr->Type() == B13->BOTNET->BOT) && (ptr != sock)
	 && (ptr->Numver() > NEAT_BOTNET) && (ptr->Numver() < NEATER_BOTNET))
       ptr->Dump(stuff, len);
}

static void my_tandout_i(Bot * sock, char * stuff, int len) {
   FUNCTION;
   Bot * ptr = (Bot *)G->socklist;
   FlagRecord bfl ( FlagRecord::BOT );

   while ((ptr = ptr->Next()))
     if ((ptr->Type() == B13->BOTNET->BOT) && (ptr != sock) 
	 && (ptr->Numver() > NEAT_BOTNET) && (ptr->Numver() < NEATER_BOTNET)
	 && !(bfl.Set(ptr->User())->BotIsolate()))
       ptr->Dump(stuff, len);
}

static void infoq_3 (Bot * sock, char * par) {
   FUNCTION;
   my_tandout(sock, OBUF, G->SPrintF(OBUF, 511, "i? %s\n", par));
}

static void chan_3 (Bot * sock, PartyLiner * pl, const char * data) {
   FUNCTION;
   my_tandout_i(sock, OBUF, G->SPrintF(OBUF, 511,"c %s@%s %D %s\n", pl->Key(),
				     pl->BotName(), pl->Chan(), data));
}

static void chatter_3 (Bot * sock, char * botnick, int chan, const char * data) {
   FUNCTION;
   my_tandout_i(sock, OBUF, G->SPrintF(OBUF, 511,"c %s %D %s\n", botnick, chan, data));
}

static void chat_3 (Bot * sock, const char * botnick, char * data) {
   FUNCTION;
   my_tandout_i(sock, OBUF, G->SPrintF(OBUF, 511,"ct %s %s\n",botnick,data));
}

static void act_3 (Bot * sock, PartyLiner * pl, char * data) {
   FUNCTION;
   my_tandout_i(sock, OBUF, G->SPrintF(OBUF, 511,"a %s@%s %D %s\n", pl->Key(),
				     pl->BotName(), pl->Chan(), data));
}

static void unlinked_3 (Bot * sock, TandemBot * bot, const char * r) {
   FUNCTION;
   my_tandout(sock, OBUF, G->SPrintF(OBUF, 511, "un %s %s\n", bot->Name(), r));
}   

static void nlinked_3 (Bot * sock, const char * bot, const char * next,
		       char flag, int vernum, const char *) {
   FUNCTION;
   my_tandout(sock, OBUF, G->SPrintF(OBUF, 511, "n %s %s %c%D\n", bot, next, flag, vernum));
}   

static void zapf_broad_3 (Bot * sock, char * a, char * b, char * c) {
   FUNCTION;
   my_tandout(sock, OBUF, G->SPrintF(OBUF, 511,"zb %s %s %s\n",a,b,c));
}

static void nkch_3 (Bot * sock, PartyLiner * ptr, char *) {
   FUNCTION;
   int sn = ptr->Sock();
   
   if (!sn) 
     sn = MAP_ZERO;
   my_tandout_i(sock, OBUF, G->SPrintF(OBUF, 511,"nc %s %D %s\n", ptr->BotName(), sn, ptr->Nick()));
}

static void idle_3 (Bot * sock, const char * bot, int socki, int idle, 
		    const char * away) {
   FUNCTION;
   if (!socki) 
     socki = MAP_ZERO;
   my_tandout_i(sock, OBUF, G->SPrintF(OBUF, 511,"i %s %D %D %s\n", bot, socki, idle, safe_str(away)));
}
   
static void away_3 (Bot * sock, PartyLiner * partyidx, int linking) {
   FUNCTION;
   int sn = partyidx->Sock();
   
   if (!sn)
     sn = MAP_ZERO;
   my_tandout_i(sock, OBUF, G->SPrintF(OBUF, 511, "aw %s%s %D %s\n", 
				       (sock && linking) ? "!":"",
				       partyidx->BotName(), sn,
				       safe_str(partyidx->Away())));
}

static void join_3 (Bot * sock, int linking, PartyLiner * ptr, int) {
   FUNCTION;
   int sn = ptr->Sock();
   
   if (!sn)
     sn = MAP_ZERO;
   my_tandout_i(sock, OBUF, G->SPrintF(OBUF, 511,"j %s%s %s %D %c%D %s\n",
				     linking ? "!" : "", ptr->BotName(),
				     ptr->Nick(), ptr->Chan(),
				     fconv(ptr->Flag()), sn, safe_str(ptr->From())));
}

static void part_3 (Bot * sock, PartyLiner * ptr, char * reason, int silent) {
   FUNCTION;
   int sn = ptr->Sock();
   
   if (!sn)
     sn = MAP_ZERO;
   my_tandout_i(sock, OBUF, G->SPrintF(OBUF, 511,"%spt %s %s %D %s\n",
				       silent ? "!" : "", ptr->BotName(),
				       ptr->Nick(), sn, safe_str(reason)));
}

static void update_3 (Bot * sock, TandemBot * ptr) {
   FUNCTION;
   my_tandout(sock, OBUF, G->SPrintF(OBUF, 511,"u %s %c%D\n", ptr->Name(), ptr->Share(), ptr->Version()));
}

static void rembot_3 (TandemBot *) {
   FUNCTION;
}

static void bye_3 (const char * msg) {
   FUNCTION;
   my_tandout(NULL, OBUF, G->SPrintF(OBUF, 511, "bye %s\n", msg));
}
   
static void dump_sublinks ( TandemBot * bot ) {
   FUNCTION;
   PartyLiner * ptr;
   TandemBot * bot2;
   
   nlinked_3(0, bot->Name(), bot->UplinkName(), bot->Share(), bot->Version(), 0);
   for (ptr = bot->PartyLiners(); ptr; ptr = ptr->NextByBot()) {
      join_3(0, 1, ptr, 0);
      idle_3(0, ptr->BotName(), ptr->Sock(), ptr->Timer(), ptr->Away());
   }
   for (bot2 = bot->Children(); bot2; bot2 = bot2->Peer())
     dump_sublinks(bot2);
}
   
static void crosslink_3 (TandemBot * b1, TandemBot * b2) {
   FUNCTION;
   if (b1->Uplink() != b2->Uplink()) {
      TandemBot * which = b1;
      char buf[512];
      
      if (b2->Uplink() == b1)
	which = b2;
      G->SPrintF(buf, 511, "Unlinking %S (UNCrosslink re-map)", which->Name());
      unlinked_3 (0, which, buf);
      dump_sublinks(which);
   }
}

static void uncrosslink_3 (TandemBot * b1, TandemBot * b2) {
   FUNCTION;
   if (b1->Uplink() != b2->Uplink()) {
      TandemBot * which = b1;
      char buf[512];
      
      if (b2->Uplink() && (b2->Uplink()->Uplink() == b1))
	which = b2;
      G->SPrintF(buf, 511, "Unlinking %S (UNCrosslink re-map)", which->Name());
      unlinked_3 (0, which, buf);
      dump_sublinks(which);
   }
}

static struct massbot_call_funcs my_massbots ={ 
   0,
     infoq_3,
     chan_3,
     chatter_3,
     chat_3,
     act_3,
     unlinked_3,
     nlinked_3,
     zapf_broad_3,
     nkch_3,
     idle_3,
     away_3,
     join_3,
     part_3,
     update_3,
     rembot_3,
     bye_3,
     crosslink_3,
     uncrosslink_3,
};

/* 29 also in Bot13.C */
static struct bot_table_struct bot_table[29] = {
   { "a",  (void (Bot::*) (char *))&Bot13::ActChan },
   { "aw", (void (Bot::*) (char *))&Bot13::Away },
   { "bye", &Bot::ProcessBye },
   { "c",  (void (Bot::*) (char *))&Bot13::Chan },
   { "ct", &Bot::BotChat },
   { "el", &Bot::ProcessEndLink },
   { "handshake", &Bot::ProcessHandshake },
   { "i",  (void (Bot::*) (char *))&Bot13::Idle },
   { "i?", &Bot::ProcessInfoQ },
   { "j",  (void (Bot::*) (char *))&Bot13::Join },
   { "l",  &Bot::Bot_Link },
   { "m",  &Bot::BotMotd },
   { "n",  (void (Bot::*) (char *))&Bot13::NLinked },
   { "nc", &Bot::BotNickChange },
   { "p",  &Bot::BotPriv },
   { "pi", &Bot::ProcessPing },
   { "po", &Bot::ProcessPong },
   { "pt", (void (Bot::*) (char *))&Bot13::Part },
   { "r",  &Bot::BotReject },
   { "t",  &Bot::BotTrace },
   { "tb", &Bot::ProcessThisBot },
   { "td", &Bot::BotTraced },
   { "u",  (void (Bot::*) (char *))&Bot13::Update },
   { "ul", &Bot::BotUnLink },
   { "un", &Bot::BotUnLinked },
   { "v",  &Bot::BotVersions },
   { "w",  (void (Bot::*) (char *))&Bot13::Who },
   { "z",  &Bot::BotZapf },
   { "zb", &Bot::BotZapfBroad },
};

static BindReturn botnet_version (void ** args, const char *) {
   FUNCTION;
   BotLink * idx = (BotLink *)args[0];
   Bot *newone;
   char buffer[512], *par = buffer;
   int l;
   
   strncpy(buffer, (char *)args[1], 511);
   buffer[511] = 0;
   idx->SetNumver(atoi(G->Split(&par)));
   if ((idx->Numver() >= NEATER_BOTNET) || (idx->Numver() < NEAT_BOTNET))
     return EXECUTED;
   l = atoi(G->Split(&par));
   if (l != HANDLEN) {
      idx->Printf("error %s\n", BNET->Lang(0x00A, "dd", HANDLEN, l));
      return EXECUTED;
   } 
   idx->Printf("tb %s\n", G->botnetnick);
   newone = NEW ( Bot13 ( *idx, par ) );
   return EXEC_LOG;
}

static command_binds my_version [] = {
   { "103*", "", botnet_version, "botnet1_3" },
};

extern "C" {
   char * botnet1_3_start (ModuleEntryEggdrop * G, ModuleEntry * me) {
      FUNCTION;
      char * r = 0;
      
      ::G = G;
      B13 = NEW ( ModuleEntryBotnet1_3 ( me, &r ) );
      context;
      if (!r) {
	 B13->bot_table = bot_table;
	 B13->my_massbots = &my_massbots;
	 B13->BOTNET->bt_version->AddBinds(my_version, 1, B13);
	 B13->BOTNET->AddMassbotFuncs(&my_massbots);
      }
      return r;
   }
}
